/**
 * Test 3 : lecture en flottant, seuillage puis criture en 1 bit compact
 *          permet le traitement sur tout codage.
 */

#include <assert.h>
#include <inrimage/image.h>

int main(int argc, char **argv) {
  struct image *img;
  char nom[256];
  float *buf;
  Fort_int lfmt[9];
		     
  int i,j;
  float val = 0.5;
  
  inr_init(argc,argv,"","","");
  igetopt1( "-n", "%f", &val);

  infileopt(nom);
  img = image_( nom, "e", "", (void*)lfmt);
  
  buf = (float*)i_malloc(DIMX*NDIMY*sizeof(float));
  c_lecflt( img, NDIMY, (void*)buf);
  fermnf_( (void*)&img);

  for(j=0;j<NDIMY;j++)  
    for(i=0;i<DIMX;i++)
      buf[i+DIMX*j] = (buf[i+DIMX*j] < val) ? 0 : 1;

  BSIZE = -1;
  TYPE  = PACKEE;
  
  outfileopt(nom);
  img = image_( nom, "c", "", (void*)lfmt);
  c_ecrflt( img, NDIMY, (void*)buf);
  fermnf_( (void*)&img);
  return 0;
}

