#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"[image-in] [image-out] [-I] [options-de-codage] [-F=file_type] [-hdr=nn]";
static char Udetail[]=
"\tconvertit 'image-in' dans le codage de 'image-out'\n\
\tSi 'image-out' n'existe pas, le codage est pris dans 'options-de-codage'\n\
\tou lu sur stdin si '-I'";



fcmain_()
{
	char inname[80],outname[80];
	int verbose ;


	inr_init(0,0,"2.1",Ucmd,Udetail);

	verbose = igetopt0("-I");

	infileopt(inname);
	outfileopt(outname);

	if ( verbose ) {
		if(tstopts())
			iusage_(Ucmd,Udetail);
		kconvg_();
	} else {
		if(gtstopts(0,0,1))
			iusage_(Ucmd,Udetail);
		sconvg_(inname,outname);
	}

}

