/*kfmoy_
**************************************************************************
*									 *
* Ce programme est le lanceur de l'executable " moyenne"  .              *
* Il recupere les  arguments :						 *
* - x (kdim) dimension du filtre en colonnes (par defaut = 3)		 *
* - y (idim) dimension du flitre en lignes (par defaut = 3)		 *
* - inname   nom de l'image d'entree (eventuellement un pipe)		 *
* - outname  nom de l'image de sortie (eventuellement un pipe)		 *
*									 *
*   Puis il appelle kmoye.f qui definira ouvrira les images et lancera   *
*   smoyen par un "call exec" 						 *
*									 *
**************************************************************************
*/

#include <inrimage/image.h>
#include <stdio.h>

#include "fcmain.h"

static char Ucmd[]=
"[-x nn] [-y nn] [image-in] [image-out]";
static char Udetail[]=
"\tconvolution de 'image-in' (defaut stdin) par filtre moyen\n\
\t -x, -y : taille du filtre (3x3 par defaut)";


f_c_main
{
	char inname[128],outname[128];
	int dummy;
	Fort_int idim = 3 , kdim = 3;

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);

	if( igetopt("-x","",0,"%d",&dummy,"",0))
	  kdim = dummy;
	if( igetopt("-y","",0,"%d",&dummy,"",0))
	  idim = dummy;
	if(kdim == 0) kdim = 1;
	if(idim == 0) idim = 1;

	fileopt(inname,"i");
	fileopt(outname,"o");
	if ( tstopts())
		iusage_(Ucmd,Udetail);

	sfmoy_(inname,outname,&idim,&kdim);
	return 0;

}
