#include <inrimage/image.h>
#include <stdio.h>

static char version[]= "2.2";

static char Ucmd[]=
"image1-in-out image2-in-out [-V]";
static char Pdet1[]=
"\tpassage (sur place) de {partie-reelle,partie-imaginaire} a {module,phase}\n\
\t -I : demande des noms en interactif";
static char Pdet2[]=
"\tpassage (sur place) de {module,phase} a {partie-reelle,partie-imaginaire}\n\
\t -V : demande des noms en interactif";
static char *Pdetail;

extern debug_;
static struct multi_cmd cmds[] = {
	"ri",Ucmd,Pdet1,	/*  1 */
	"ma",Ucmd,Pdet2,	/*  2 */
	0,0,0,
};

fcmain_()
{
	register struct multi_cmd *ppcmd;
	char im1[80],im2[80];
	int verbose;
	Fort_int choix;

	choix = inr_initm(0,0,version,cmds);
	ppcmd = &cmds[choix];

	if ( debug_ ) fprintf(stderr,"fonction %s\n",ppcmd->name);
	
	verbose = igetopt("-I","",0,"",0,"",0);

	Pdetail = ppcmd->udetail;
	choix++;
#ifndef NONINTERACTIF
	if ( verbose ) {
		if(tstopts())
			iusage_(Ucmd,Pdetail);
		kmgpha_(&choix);
		return 1;
	}
#endif
	if ( !igetopt("","%s",im1,"",0,"",0) || !igetopt("","%s",im2,"",0,"",0) )
		iusage_(Ucmd,Pdetail);

	if ( tstopts())
		iusage_(Ucmd,Pdetail);

	smgpha_(&choix,im1,im2);
	return 0;

}


