/*
	normalisation d'image (pour la ramener entre 0 et 1)
	tous types acceptes (conversion automatique en Read et Write)
   si l'entree est un pipe ou n'est pas de type flottant, on copiera
	sur un fichier temporaire
*/

#include <inrimage/image.h>
#include <stdio.h>
#include "fcmain.h"

static char Ucmd[]=
"[image-in] [image-out]";
static char Udetail[]=
"\t ramene les valeurs d'une image entre 0 et 1 \n\
\t   peut etre utilise en filtre, et sur tout type d'images";

f_c_main
{
	char inname[128],outname[128],tempname[80];

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);

	fileopt(inname,"i");
	fileopt(outname,"o");

	if(tstopts())
		iusage_(Ucmd,Udetail);

	/* on travaille sur un fichier temporaire pour
		pouvoir utiliser la commande en filtre */

	strcpy(tempname,"/tmp/norma.XXXXXX");
/*	mktemp(tempname);  /* done in image_() */

	snormi_(inname,outname,tempname);
	return 0;

}
