C* SLOGIC
	SUBROUTINE SLOGIC(in1,in2,out,ic,ival)
C
C ******************************************
C * PROGR. DE LOGIQUE BINAIRE EN BIT S. QCQ.
C  7 SOUS-COMMANDES QUI DEFINISSENT IOPT :
C * IOPT =     1   .IAND. ENTRE 2 IMAGES
C *            2   .IOR.  ENTRE 2 IMAGES
C *            3   .IEOR. ENTRE 2 IMAGES
C *            4 .IAND. AVEC UNE CONSTANTE
C *            5  .IOR. AVEC UNE CONSTANTE
C *            6  .IEOR. AVEC UNE CONSTANTE
C *            7  INVERSION DE TOUS LES BITS
C *
C * 1ERE IMAGE ENTREE=NF1,SF1,LFMT.
C * 2EME IMAGE ENTREE (SI NECESSAIRE) : NF2,SF2,LFMT2
C         LE FORMAT NE PEUT DIFFERER QUE PAR LE CODAGE
C          (LE NB DE BITS DE STOCKAGE DOIT ETRE LE MEME, ET
C           LA BIT SIZE DE L'IMAGE 1 DOIT ETRE >= A CELLE DE IMAGE 2)
C * IMAGE SORTIE=NFO,SFO,MM FORMAT QUE NF1,SF1
C *
C ******************************************
C
	DIMENSION LFMT(9),LFMT2(9)
	EXTERNAL LOGBIN
	INTEGER*2 ICB,ICMD(8),CMD(75),SF1,SF2,SFO
	INTEGER*8 nf1,nf2,nfo,image

100   CALL ERREUR(IER)
	CALL IMPERR(IER)
	CALL FPANIC
	IF(IER.LT.0) RETURN
ccc	IC=IQUEL(CMD,IBRK,2,ICB)
	IF(IC.EQ.8) RETURN
C  POIDS DES TABLEAUX A ALLOUER PAR EXEC
	IF(IC.LT.4) GOTO 20
C  OPERATIONS A 1 SEULE IMAGE D'ENTREE
        nf1=image(in1,'e ','  ',lfmt)
cc	CALL WRFMG(LFMT,1)
	IF(IC.EQ.7) GOTO 30
ccc	IVAL=IHXGET(0,'CONSTANTE HEXA $')
	GOTO 30
C  APPEL 1ERE IMAGE ENTREE.
 20     nf1=image(in1,'e ','  ',lfmt)
        nf2=image(in2,'e ','  ',lfmt2)
C  VERIFICATION COMPATIBILITE NB DE BITS DE STOCKAGE
	K=ICPFMG(LFMT,LFMT2)
	IF(K.LT.2) CALL ERMESF(7)
	IF(K.EQ.3) GOTO 30
	IBS=LFMT(3)
	IF(IBS.GT.0) GOTO 21
	IBS=-IBS
	GOTO 22
21    IBS=8*IBS
22    IBS2=LFMT2(3)
	IF(IBS2.GT.0) GOTO 23
	IBS2=-IBS2
	GOTO 24
23    IBS2=8*IBS2
24    IF(IBS.NE.IBS2) CALL ERMESF(6)
C  APPEL IMAGE SORTIE.
 30   nfo=image(out,'s ','a ',lfmt)
C
C  APPEL SOUS-PROGRAMME AVEC ALLOCATION MEMOIRE.
C
	IDIMV=1
	CALL EXEC(IER,0,0,1,IDIMV,LOGBIN,NF1,SF1,
     #NF2,SF2,NFO,SFO,LFMT,LFMT2,IC,IVAL,IER)
	CALL IMPERR(IER)
	return
	END
