/*
 c_sonsim
	c_sonsim(image,tout,inter,ixyz,idxyz,format)
 lecture sur tty si inter > 0, ou sur stdin (par scanf) si inter == 0
 de tout (tout=1) ou partie (tout=0)
 d'une image reelle ou virg fixe
 Si tout==0, IXYZ donne les origines en X,Y,Z (>= 1) et IDXYZ les tailles
 FORMAT : chaine vide ou format pour scanf
*/

#include <stdio.h>
#include <inrimage/image.h>

static Fort_int nb, un= 1, zer= 0, ier;

extern readi_();

void sonsim_(nf,lfmt,tout,inter,ixyz,idxyz,format,infile)
struct image *nf;
Fort_int *tout, *inter;
char *format;
Fort_int *ixyz, *idxyz;
Fort_int *lfmt;
FILE *infile;
{
	register char *pfmt;
	if(*tout) {
		ixyz[0] = 1; ixyz[1] = 1; ixyz[2] = 1;
		idxyz[0] = DIMX;
		idxyz[1] = NDIMY;
		idxyz[2] = NDIMZ;
	} else {
		if(ixyz[0] <= 0) ixyz[0] = 1;
		if(ixyz[1] <= 0) ixyz[1] = 1;
		if(ixyz[2] <= 0) ixyz[2] = 1;
		if(idxyz[0] <= 0) idxyz[0] = DIMX - ixyz[0] + 1;
		if(idxyz[1] <= 0) idxyz[1] = NDIMY - ixyz[1] + 1;
		if(idxyz[2] <= 0) idxyz[2] = NDIMZ - ixyz[2] + 1;
	}
	if(*inter != 0) {
		pfmt = "%g";
	} else if(*format == 0) {
		if(BSIZE > 1 || BSIZE < -8)
			pfmt = "%g";
		else
			pfmt = "%d";
	} else
		pfmt = format;
	nb = 1;
	exec_(&ier,&zer,&zer,&un,&nb,readi_,&nf,ixyz,idxyz,infile,pfmt,tout,inter,&ier);
}
