/*
C*SOPARA
	SUBROUTINE SOPARA(nom,flag)
calucule Min. Moy et Max de l'image
impression sur stdout si flag == 0, sur stderr avec nom image sinon
*/

#include <stdio.h>
#include <inrimage/image.h>

static float amax, amin, amoy;
static Fort_int ier;
static Fort_int nfx= 0;
static Fort_int nvar= 1, dimvar= 0;
static struct image *nf;
extern int calpar_();

sopara_(nom,outf)
char *nom;
FILE *outf;
{
	Fort_int lfmt[9];
        nf=image_(nom,"e","",lfmt);
	dimvar = 1;
	amoy = 0.;
	exec_(&ier,&nfx,&nfx,&nvar,&dimvar,calpar_,&nf,&amoy,&amax,&amin,&ier);
	fermnf_(&nf);
	imperr_(&ier);
	if(ier != 0) return 1 /* makes c99 happy */;
/* om imprime le resultat */
	if(outf == stdout) {
		printf(" %13f %13f %13f\n",amin,amoy,amax);
		return 1 /* makes c99 happy */;
	}
	fprintf(outf,"%s:\t %13f %13f %13f\n",nom,amin,amoy,amax);
}
