C*  APOLYG
	SUBROUTINE APOLYG(A,B,NMAX,NMX,EPS,IOPFR)
C  EFFECTUE L'APPROXIMATION POLYGONALE SUR LES CONTOURS D'UN FICHIER
C   DE CONTOURS "OUVERT" PAR LEDKCN ET RANGE LE RESULTAT DANS UN 2E FICHIER
C     (PAR ECDKCN)
C  A ET B SONT 2 TABLEAUX DE TRAVAIL (DONNEES ET RESULTATS POUR CHAQUE CONT.)
C    NMAX CONTIENT LES DIMENSION DE A ET B
C   NMX EST LE NUMERO MAXIMUM DE CONTOUR
C   EPS EST LA MARGE D'ERREUR POUR L'APPROXIMATION (EN NOMBRE DE PAS X, Y)
C    IOPFR=1 SI LES CONTOURS SONT FERMES (ON RELIE 1ER ET DERNIER POINTS)
C    ET IOPFR=0 SINON
	INTEGER*2 B(3)
	INTEGER A(1),LGRAN(2)
	COMMON /SCBUFF/ ISU(64)
	EQUIVALENCE (LGRA,LGRAN(1)),(LGRN,LGRAN(2))
	B(2)=0
	LGRA=0
	LGRN=0
	DO 1 I=1,NMX
	CALL LEDKCG(1,1,I,IE,LGR,NP,ISU,A,NMAX)
	IF(LGR.LT.0)GO TO 1
	LGRA=LGRA+LGR
	IF(IOPFR.EQ.1) GOTO 2
C  NE PAS FERMER LES CONTOURS
	CALL POLYGN(A,B(3),LGR,EPS)
	GOTO 3
2     CALL POLYG(A,B(3),LGR,EPS)
3     LGRN=LGRN+LGR
	B(1)=LGR
	CALL ECDKCG(1,1,I,IE,1,ISU,LGR,1,B)
1     CONTINUE
	CALL WRTBI(0,'ANCIENNE ET NOUVELLE LONGUEURS $',1,2,LGRAN,0,-1)
	RETURN
	END
