/* FENETE
	SUBROUTINE FENETE(IND,N,NS,I,COORDF)

    le type de fenetre d'erosion etant determine
    dans kerode,le ss-programme affecte aux pts
    de ladite leurs coordonnees relatives au pt
    a traiter
    I=1 FENETRE STANDARD A 4 PTS,=2 8 PTS,=3 12 PTS,=4 20 PTS
    I=5 la liste des points (max N) est prise dans le fichier de nom COORDF
*/

#include <stdio.h>
#include <inrimage/image.h>

extern int errno;

void fenete_(ind,n,ns,i,coordf)
register short *ind;
Fort_int *n, *ns, *i;
char *coordf;
{
	FILE *fc;
	register j, n1, n2;
	int vx, vy;
	if(*i <= 0 || *i > 5)
		imerror(9,"fenete: mauvais type de fenetre\n");
	if(*i == 5) {
		if((fc = fopen(coordf,"r")) == NULL)
			imerror(1,"open err %d on %s\n",errno,coordf);
		n1 = n2 = 0;
		for(j=0;j<*n;j++) {
			if(fscanf(fc,"%d %d",&vx,&vy) != 2)
				break;
			*ind++ = vy;
			*ind++ = vx;
			if(vy < 0) {
				if(n2 > vy)
					n2 = vy;
			} else if(vy > 0) {
				if(n1 < vy)
					n1 = vy;
			}
		}
		*n = j;  /* nb effectif de points */
		n2 = -n2;
		if(n1 < n2)
			n1 = n2;
		*ns = n1;  /* nb de lignes au bords */
		return;
	}
	*ns = 0;
	switch(*i) {
	case 4:
		*(ind+24) = 1;
		*(ind+25) = 2;
		*(ind+26) = 2;
		*(ind+27) = 1;
		*(ind+28) = 2;
		*(ind+29) = -1;
		*(ind+30) = 1;
		*(ind+31) = -2;
		*(ind+32) = -1;
		*(ind+33) = -2;
		*(ind+34) = -2;
		*(ind+35) = -1;
		*(ind+36) = -2;
		*(ind+37) = 1;
		*(ind+38) = -1;
		*(ind+39) = 2;
	case 3:
		*(ind+16) = 0;
		*(ind+17) = 2;
		*(ind+18) = 2;
		*(ind+19) = 0;
		*(ind+20) = 0;
		*(ind+21) = -2;
		*(ind+22) = -2;
		*(ind+23) = 0;
		*ns = 1;
	case 2:
		*(ind+8) = 1;
		*(ind+9) = 1;
		*(ind+10) = -1;
		*(ind+11) = 1;
		*(ind+12) = 1;
		*(ind+13) = -1;
		*(ind+14) = -1;
		*(ind+15) = -1;
	case 1:
		*ind = 1;
		*(ind+1) = 0;
		*(ind+2) = 0;
		*(ind+3) = 1;
		*(ind+4) = -1;
		*(ind+5) = 0;
		*(ind+6) = 0;
		*(ind+7) = -1;
		*ns += 1;
	}
		
}
