C* LEDKCG
	SUBROUTINE LEDKCG(NF,IOPT,NUM,IEXT,LGR,NPAR,IPAR,ICHN,ICOM,LGRD)
C  ACCES (EN LECTURE) A UN FICHIER DE CONTOUR
C  ! COMPATIBLE AVEC LES FICHIERS D'ANCIEN TYPE !!!
C NF=NUMERO DU FICHIER ( 1 A 3)
C  AVEC ENTRY MDDKPG ET MDDKCG POUR MODIF. PARAMETRES OU CONTOUR
C  IOPT=OPTION 0=INIT POUR LECTURE, 1=LECTURE PARAMETRES + POINTS D'UN
C     CONTOUR, 2=LECTURE PARAM. SEULS, -1=FERMETURE FICHIER
C IOPT=0 OUVERTURE DU FICHIER : LECTURE SECTEUR 0 ET INIT PTRS
C    NUM=U.L.
C   RETOUR : IEXT=NUMERO MAX DE CONTOUR, LGR=NB EFFECTIF DE CONTOURS,
C    NPAR=NB TOTAL DE SECTEURS DATA+INDEX, IPAR=SURF TOTALE NOIRE
C       (SOMME ALGEBRIQUE DU 1ER PARAM DES CHN),  ICHN (2 MOTS)= SOMME D
C       SURF DES CONTOURS EXTERIEURS
C     (SOMME DES 1ER PARAM. DES CONTOUR A NUM. D'ENVELOPPE NUL) ET
C      NB MAX DE PARAMETRES PAR CONTOUR.
C    ICOM=TABLEAU DE 32 MOTS RECEVANT LE COMMENTAIRE TERMINE PAR "$"
C IOPT=-1 "FERMETURE" DU FICHIER (SANS FERMETURE D'U.L.) : INDISPENSABLE
C      SI ON A FAIT DES MODIFICATIONS PAR MDDKPG OU MDDKCG (MISE A JOUR
C       BLOCS DE DATA). PARAMETRES IGNORES
C IOPT=1 LECTURE DU CONTOUR DE NUMERO NUM DANS LE TABLEAU ICHN DE TAILLE
C      ICOM MOTS. LE PROGRAMME RENVOIE LA LONGUEUR DANS LGR (-1 SI LE
C      CONTOUR N'EXISTE PAS, AUTRES PARAMETRES INCHANGES),
C  IEXT=NUMERO D'ENVELOPPE, NPAR=NB DE PARAM. DU CONTOUR,
C   IPAR=TABLEAU INTEGER RECEVANT LES PARAMETRES
C IOPT=2 LECTURE PARAMETRES SEULS : MEMES PARAMETRES QUE CI-DESSUS,
C   MAIS ICHN N'EST PAS MODIFIE.
C
C MDDKPG(NF,NUM,IEXT,NPAR,IPAR) : MODIFIE LES NPAR 1ERS PARAM DU
C   CONTOUR NUM DU FICHIER NF, A PARTIR DU TABLEAU IPAR
C MDDKCG(NF,NUM,ICHN,LGRD) : MODIFIE LES POINTS DU CONTOUR NUM. LGRD EST
C     LA NOUVELLE LGR (ELLE PEUT ETRE SUP. OU INF. A L'ANCIENNE)
	DIMENSION ICHN(2),IBI(64,3),IBD(64,3),IPAR(1)
	INTEGER*2 ICOM(2),IBC(2),IBD2(128,3)
	INTEGER ION(3),NMX(3),IN0(3),INF(3),NSI(3),IFLW(3)
	INTEGER INDX(3),INDXN(3),IDCR(3),LU(3),NPRMX(3)
	COMMON /CODCAR/ IBRK,IRETC,ILF,IBELL,ICTRA,ICTRB,ICTRC,IBLAN
     1,IBACK,IPV,IDOLL,IADS,IEXCL,INFR,ISLSH,IPLUS,IMOINS,ISTAR
     2,IEGAL,IPOINT,I2P,IC0,IC9,ICA,ICZ,ICPA,ICPZ
	EQUIVALENCE (IBD2(1,1),IBD(1,1)),(IBC(1),ITR)
	DATA LU/0,0,0/,KRD/0/,KWR/1/
C  STRUCTURE SECT 0 :
C    1=NUMERO CONTOUR MAX, 2=NB EFFECTIF DE CONTOURS, 3=NB DE SECT. INDX
C    4=NB TOTAL SECT. INDEX+DATA, 5=ADRESSE 1ER SECT. INDEX
C    6=ADRESSE DERNIER SECT IND., 7=PTR DE LA 1ERE DONNEE (2*256+2)
C    8=PTR DU PROCHAIN MOT LIBRE POUR LES DONNEES
C    9=FLAG INDIQUANT SI LE FICHIER EST OUVERT EN ECRITURE (VAL 2)
C    10=SURFACE TOTALE D'OBJET (SOMME ALGEBRIQUES DES 1ER PARAM. DES CON
C    11=SURF. TOTALE DES CONT. "EXTERIEURS" (SOMME DES VAL. ABS. DES
C       1ERS PARAM. DES CONTOURS)
C    12=NB MAX DE PARAMETRES POUR UN CONTOUR DONNE
C       (0 SI FICHIER ANCIEN TYPE, -1 SI NB MAX NUL POUR NEW TYPE)
C    33 A 64 : COMMENTAIRE TERMINE PAR 1/2 MOT NUL.
C
C STRUCTURE SECT INDEX : 1 PTR VEC SECT. IND. PRECEDENT, 1 PTR VERS SUIV
C    62 PTRS VERS DATAS DU CONTOUR (PTR NUM. N POUR CONTOUR N) :
C       VALEUR 256*K+L OU K=NUM SECT ET L=INDICE DE MOT DANS SECT
C
C STRUCTURE SECTEUR DATA : 1 PTR VERS SECT SUIVANT, 63 MOTS DE DATA.
C   LES CONTOURS SONT RANGES CONSECUTIVEMENT :
C     1/2 MOT=LGR EFFECTIVE, 1/2 MOT NUM. ENVELOPPE
C      1/2 MOT NB DE PARAM, 1/2 MOT INDICATEUR DE CHAINAGE (0 SI DATAS
C       CONSECUTIVES, +N SI N MOTS CONSECUTIFS PAS TOUS OCCUPES, -N
C       SI N-1 MOTS CONSECUTIFS SUIVIS D'UN PTR VERS LA SUITE  DANS CE
C        CAS LA SUITE COMMENCE PAR UN MOT INDICATEUR DE CHAINAGE)
C    K MOTS PARAMETRES
C     MOTS DE DONNEES
C
C  POUR LES FICHIERS DE L'ANCIEN TYPE ON A : 1/2 MOT LGR EFFECTIVE,
C   1/2 MOT NUM. ENVELOPPE, 1 MOT PARAMETRE (SURFACE), PUIS LES DATAS
C
	IF((IOPT.LT.-1).OR.(IOPT.GT.2))CALL ERMESF(9)
	IF(NF.LT.1.OR.NF.GT.3) CALL ERMESF(9)
	IF(IOPT)10,20,50
C INITIALISATION LECTURE
20    LU(NF)=NUM
	CALL IOSECT(IBD(1,NF),0,LU(NF),KRD)
	ION(NF)=IBD(9,NF)
	IF(ION(NF).NE.0)CALL ERMESF(15)
C  INIT FLAGS : IFLW=1 SI SECT DATA MODIFIE ET NON ECRIT
	IFLW(NF)=0
	IBD(9,NF)=1
	NMX(NF)=IBD(1,NF)
	LGR=IBD(2,NF)
	IN0(NF)=IBD(5,NF)
	INF(NF)=IBD(6,NF)
	NSI(NF)=IBD(3,NF)
	IEXT=NMX(NF)
	INDX(NF)=0
	INDXN(NF)=0
	IDCR(NF)=0
	IBI(2,NF)=IN0(NF)
	NPAR=IBD(4,NF)
	IPAR(1)=IBD(10,NF)
	ICHN(1)=IBD(11,NF)
	NPRMX(NF)=IBD(12,NF)
	IF(NPRMX(NF)) 1,2,3
C  FLAG FICHIER ANCIEN TYPE
2     NPRMX(NF)=-1
	GOTO 3
1     NPRMX(NF)=0
3     ION(NF)=1
	ICHN(2)=NPRMX(NF)
	DO 7 I=1,64
	ITR=IBD2(I+64,NF)
	IF(ITR.EQ.0)GOTO 8
	ICOM(I)=ITR
7     CONTINUE
8     ICOM(I)=IDOLL
	RETURN
C  FIN LECTURE,FERMETURE FICHIER
10    IF(LU(NF).LE.0)RETURN
	IF(ION(NF).NE.1)RETURN
	IF(IFLW(NF).LE.0) GOTO 11
C REECRITURE BLOC DATA MODIFIE
	CALL IOSECT(IBD(1,NF),IDCR(NF),LU(NF),KWR)
	IFLW(NF)=0
11    CALL IOSECT(IBD(1,NF),0,LU(NF),KRD)
	IBD(9,NF)=0
	ION(NF)=0
	RETURN
C LECTURE CHAINE (PAR SEULS SI IOPT=2)
50    IF(LU(NF).LE.0)CALL ERMESF(9)
	IF(ION(NF).NE.1)CALL ERMESF(15)
	IBC(1)=ICOM(1)
	IBC(2)=ICOM(2)
	NMAX=ITR
	N=(NUM+61)/62
	IF(NUM.GT.NMX(NF))GOTO 80
	CALL GTSIND(IBI(1,NF),N,IN0(NF),INF(NF),NSI(NF),INDX(NF),
     #INDXN(NF),LU(NF),IFLW(NF))
	K=NUM-(N-1)*62+2
	IPT=IBI(K,NF)
	IF(IPT.EQ.0)GOTO 80
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IEXT=IBC(2)
	LGR=IBC(1)
	IF(NPRMX(NF).GE.0) GOTO 61
C  FICHIER ANCIEN TYPE : 1 SEUL PARAM.
	NPAR=1
	LG2=0
	GOTO 62
61    CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	NPAR=IBC(1)
	LG2=IBC(2)
	IF(NPAR.LE.0) GOTO 64
62    DO 63 K=1,NPAR
	CALL LEDKMG(IPAR(K),IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
63    CONTINUE
64    IF(IOPT.EQ.2)RETURN
	IF(LGR.GT.NMAX)CALL ERMESF(8)
	IF(LG2.GE.0) GOTO 69
	LG2=-LG2-1
	J=1
	K=1
66    IF(J.GT.LGR) RETURN
	IF(K.LE.LG2) GOTO 68
C  LIRE BLOC SUIVANT
	CALL LEDKMG(IT,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IPT=IT
	IF(IT.LE.0) GOTO 234
	K=1
	CALL LEDKMG(LG2,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IF(LG2) 660,661,662
662   IF(LG2.LT.(LGR-J+1)) GOTO 234
	GOTO 66
661   LG2=LGR-J+1
	GOTO 66
660   LG2=-LG2+1
	GOTO 66
68    CALL LEDKMG(ICHN(J),IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	J=J+1
	K=K+1
	GOTO 66
69    DO 65 J=1,LGR
	CALL LEDKMG(ICHN(J),IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
65    CONTINUE
	RETURN
209   CALL ERMESF(9)
234   CALL MESERR('FICHIER CORROMPU $',34)
80    LGR=-1
	RETURN
C  MDDKPG(NF,NUM,IEXT,NPAR,IPAR)  MODIFICATION DES PARAMETRES
C  MDDKCG(NF,NUM,ICHN,LGRD) MODIFICATION DU CONTOUR
	ENTRY MDDKP2(NF,IOPT,NUM,IEXT,LGR,NPAR,IPAR,ICHN,ICOM,LGRD)
	KOPT=1
	GOTO 70
	ENTRY MDDKC2(NF,IOPT,NUM,IEXT,LGR,NPAR,IPAR,ICHN,ICOM,LGRD)
	KOPT=2
70    IF(LU(NF).LE.0)CALL ERMESF(9)
	IF(ION(NF).NE.1)CALL ERMESF(15)
	N=(NUM+61)/62
	IF(NUM.GT.NMX(NF)) GOTO 209
	CALL GTSIND(IBI(1,NF),N,IN0(NF),INF(NF),NSI(NF),INDX(NF),
     #INDXN(NF),LU(NF),IFLW(NF))
	K=NUM-(N-1)*62+2
	IPT=IBI(K,NF)
	IF(IPT.EQ.0)GOTO 209
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	LGRV=IBC(1)
	IF(KOPT.EQ.2) GOTO 76
C  MODIF PARAM.
	IBC(2)=IEXT
	IPT=IPT-1
	CALL MDDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IF(NPAR.LE.0) RETURN
	NP=1
	IF(NPRMX(NF).LT.0) GOTO 71
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	NP=IBC(1)
71	IF(NP.LT.NPAR) CALL MESERR('NB PARAM. CONTOUR INCORRECT $',9)
	DO 75 K=1,NPAR
	CALL MDDKMG(IPAR(K),IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
75    CONTINUE
	RETURN
C  MODIF CONTOUR
76    IF(LGRD.LE.0) GOTO 209
	IBC(1)=LGRD
	IPT=IPT-1
	CALL MDDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	NP=1
	LG2=0
	IF(NPRMX(NF).LT.0) GOTO 72
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IP0=IPT-1
	LG2=IBC(2)
	NP=IBC(1)
	IF(NP.LE.0) GOTO 78
C  SAUTER LES PARAM.
72    DO 77 K=1,NP
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
77    CONTINUE
78    IFLMG=0
	IF(LG2) 83,82,81
82    IF(NPRMX(NF).LT.0) GOTO 300
	LG2=LGRV
81    IF(LGRD-LG2) 84,85,95
C  CONTOUR N'OCCUPE PAS TOUTE LA PLACE
84    IFLMG=1
	LGG=LG2
85    DO 90 J=1,LGRD
	CALL MDDKMG(ICHN(J),IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
90    CONTINUE
99    IF(IFLMG.EQ.0) RETURN
	IPT=IP0
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	IBC(2)=LGG
	IPT=IPT-1
	CALL MDDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFLW(NF))
	RETURN
83    LG2=-LG2
	IF(LGRD.LT.LG2) GOTO 85
95    CALL MESERR('NON IMPLEMENTE $',66)
	GOTO 99
300   IF(LGRD-LGRV) 85,85,209
	END

	subroutine MDDKPG(NF,NUM,IEXT,NPAR,IPAR)
	integer*2 icom(2)
	call mddkp2(NF,IOPT,NUM,IEXT,LGR,NPAR,IPAR,ICHN,ICOM,LGRD)
	return
	end

	subroutine MDDKCG(NF,NUM,ICHN,LGRD)
	integer*2 icom(2)
	call mddkc2(NF,IOPT,NUM,IEXT,LGR,NPAR,IPAR,ICHN,ICOM,LGRD)
	return
	end
