C* POLYG
	SUBROUTINE POLYG(X,IS,N,EPS)
C  APPROXIMATION POLYGONALE DU CONTOUR DE N POINTS CONTENU DANS X
C  RESULTAT DANS IS. ON RENVOIE DANS LE NOMBRE DE POINTS DU RESULTAT
C  CHAQUE POINT OCCUPE 1 MOT (1/2 POUR X, 1/2 POUR Y)
C   EPS= MARGE D'ERREUR EN PAS DE COORDONNEE (UN POINT APPARTIENT
C   A UN SEGMENT SI SA DISTANCE EST <EPS)
C  LE PROGRAMME SUPPOSE QUE LES CONTOURS SONT FERMES : IL RECOPIE
C   LE 1ER POINT A LA FIN DE X
C
C   ENTRY POLYGN(X,IS,N,EPS)
C    APPROXIMATION SANS FERMER LE CONTOUR
	INTEGER*2 IS(3),X(4)
	INTEGER X0,Y0,X1,Y1
C
C   INITIALISATION
C
	N=N+1
	N2=2*N
	X(N2-1)=X(1)
	X(N2)=X(2)
	GOTO 3
C
C   2E ENTREE
	ENTRY POLYGN(X,IS,N,EPS)
	N2=2*N
	IF(N.GT.1) GOTO 3
	IS(1)=X(1)
	IS(2)=X(2)
	RETURN
3     EPS2=EPS*EPS
	IS(1)=1
	NS=3
	DMAX=0.
	DO 12 K=3,N2,2
	D=(X(1)-X(K))*(X(1)-X(K))+(X(2)-X(K+1))*(X(2)-X(K+1))
	IF (D.LT.DMAX) GO TO 12
	DMAX=D
	KMAX=K
12    CONTINUE
	IS(3)=N
	IS(2)=(KMAX+1)/2
	IF(DMAX.GT.EPS2) GO TO 2
	NS=1
	GO TO 101
2     I=1
11    K=IS(I)
	L=IS(I+1)
	K2=2*K
	X0=X(K2-1)
	Y0=X(K2)
	KP1=K+1
10    LM1=L-1
	IF(LM1.LT.KP1)GO TO 4
C
C   CALCUL DE LA DISTANCE MAX A LA DROITE K-L
C
	L2=2*L
	X1=X(L2-1)
	Y1=X(L2)
	EPSA=((X1-X0)*(X1-X0)+(Y1-Y0)*(Y1-Y0))*EPS2
	DMAX=0.
	DO 1 K1=KP1,LM1
	K12=2*K1
	D=(X(K12-1)-X0)*(Y1-Y0)-(X(K12)-Y0)*(X1-X0)
	D=D*D
	IF(D.LE.DMAX) GO TO 1
	DMAX=D
	KMAX=K1
1     CONTINUE
	IF(DMAX.LE.EPSA) GO TO 4
C
C   INSERTION D'UN SOMMET SUPPLEMENTAIRE
C
	I1=I+1
	NS1=NS+I1
	DO 5 K1=I1,NS
	J=NS1-K1
5     IS(J+1)=IS(J)
	IS(I+1)=KMAX
	L=KMAX
	NS=NS+1
	GO TO 10
C
C   VALIDATION DU SOMMET
C
4     I=I+1
	IF(I.EQ.NS) GO TO 20
	GO TO 11
C
C   SUPRESSION EVENTUELLE DU 1 ER SOMMET
C
20    NS=NS-1
	IF(NS.EQ.2)GO TO 101
	NS1=IS(NS)*2
	J=IS(2)*2
	Y0=X(J)-X(NS1)
	X0=X(J-1)-X(NS1-1)
	D2=X0*X0+Y0*Y0
	IF(D2.NE.0.) GOTO 21
	D=(X(J-1)-X(1))*(X(J-1)-X(1))+(X(J)-X(2))*(X(J)-X(2))
	GOTO 22
21    D=((X(J-1)-X(1))*Y0-(X(J)-X(2))*X0)
	D=D*D/D2
22    IF(D.GT.EPS2) GO TO 101
	DO 13 I=1,NS
13    IS(I)=IS(I+1)
	NS=NS-1
C
C  CREATION DU TABLEAU DES SOMMETS
C
101   I1=2*NS
	NS1=NS+1
	DO 14 I=1,NS
	J=NS1-I
	K=IS(J)*2
	IS(I1)=X(K)
	IS(I1-1)=X(K-1)
14    I1=I1-2
	N=NS
	RETURN
	END
