C* DOIT21
	SUBROUTINE DOIT21(LINE,ILINE,HIDDEN,IHIDD,IBUF,NDIMF,A,B,NDIMV
     :,NF,ISF,FMT,DX,DY,RPDX,RPDY,RMIN,RMAX)
C inputs: 
C     LINE, ILINE, HIDDEN, IHIDD, IBUF : tableaux fixes (4 de 128 et 1 de 256)
C     A, B : tableaux variables (image orig. et echantillonee)
C     FMT : format de l'image (NF, ISF)
C     DX, DY : pas d'echantillonage en X et Y (>= 1)
C     RPDX, RPDY : dim. en X et Y de l'image echantillonee
C     RMIN, RMAX: min, max
	INTEGER FMT(2),DX,DY,RPDX,RPDY,PDX,PDY,PNT,SKPROW,PDY1
     :,LINE(1),HIDDEN(1)
	DIMENSION IBUF(1),A(1),B(1),NDIMV(2),NDIMF(1),ILINE(1),IHIDD(1)
	PDX=FMT(1)
	PDY=FMT(2)
	IF(RMAX.EQ.RMIN)GO TO 3
	R1=1./(RMAX-RMIN)
	R2=-RMIN*R1
	GOTO4
3     R1=1.
	R2=0.
4     CONTINUE
	CALL SETUP(NDIMV(1),FMT,NROW,IRWRST,NDIM)
	IF(NROW.EQ.0)CALL ERMESF(8)
	PNT=PDY+1
	SKPROW=0
	LINNUM=0
	PDY1=PDY-IRWRST
	CALL ISOSET(RPDX,RPDY,A1,B1,A2,B2,XS,YS,IPX,RN,
     :RALPHA,BETA,GAMMA)
	DO 1 I=1,PDY1,NROW
1     CALL DOIT22(NF,ISF,FMT,PNT,SKPROW,LINNUM,NROW,DX,DY,RPDX,A,B
     :,LINE,ILINE,HIDDEN,IHIDD,IBUF,R1,R2,A1,B1,A2,B2,XS,YS,
     :IPX,RN,RALPHA,BETA,GAMMA)
	IF (IRWRST.EQ.0) GO TO 2
	NROW=IRWRST
	CALL DOIT22(NF,ISF,FMT,PNT,SKPROW,LINNUM,NROW,DX,DY,RPDX,A,B
     :,LINE,ILINE,HIDDEN,IHIDD,IBUF,R1,R2,A1,B1,A2,B2,XS,YS,
     :IPX,RN,RALPHA,BETA,GAMMA)
2     call lptset(nf,1)
	RETURN
	END
