C* DOIT22
	SUBROUTINE DOIT22(NF,ISF,FMT,PNT,SKPROW,LINNUM,NROW,DX,
     :DY,RPDX,A,B,LINE,ILINE,HIDDEN,IHIDD,IBUF,R1,R2,
     :A1,B1,A2,B2,XS,YS,IPX,RN,RALPHA,BETA,GAMMA)
C inputs:
C     NF, ISF, FMT : image
C     NROW : nb lignes image originale dans A
C     DX, DY : pas d'echantillonage en X et Y (>= 1)
C     RPDX : dim en X apres echantillonage
C     A, B : pour images orig et echantillonee
C     LINE, ILINE, HIDDEN, IHIDD, IBUF : tableaux fixes (4 de 128 et 1 de 256)
C     R1, R2 : coeff pour ramener datas entre 0 et 1 (y = R1*x + R2)
C inpu/output:
C     PNT : num + 1 de derniere ligne (on commence par la fin)
C     SKPROW : utilisee pour sample (on commence par la fin en NROW-SKPROW)
C     LINNUM : num ligne courante (1 a RPDY)
C
	DIMENSION A(1),B(1),ILINE(1),IHIDD(1)
	INTEGER IBUF(1),FMT(1),PNT,SKPROW,DX,DY,RPDX,P,PDX,
     :SKPRW1,LINE(1),HIDDEN(1)
	PNT=PNT-NROW
	PDX=FMT(1)
	P=(NROW-SKPROW-1)/DY+1
	NDIMB=P*RPDX
	SKPRW1=P*DY-NROW+SKPROW
	IF(NROW.GT.SKPROW) GO TO 2
	SKPROW=SKPROW-NROW
	RETURN
2     CALL LPTSET(NF,PNT)
	CALL LECT(NF,NROW,A)
	CALL SAMPLE(SKPROW,DX,DY,PDX,RPDX,NROW,A,B,P)
	CALL ISCALE(B,NDIMB,R1)
	CALL BIAS(B,NDIMB,R2)
	DO 1 I=1,P
	LINNUM=LINNUM+1
	J1=(P-I)*RPDX+1
1     CALL SETLIN(B(J1),RPDX,LINNUM,LINE,
     :ILINE,HIDDEN,IHIDD,IBUF,A1,B1,A2,B2,XS,YS,IPX,RN,RALPHA,BETA,
     :GAMMA)
	SKPROW=SKPRW1
	RETURN
	END
