C* GRAPH
	SUBROUTINE GRAPH(CC,CX,CZ,IDIMF,AV,NDIM,NF,ISF,LFMT0)
	DIMENSION CC(1),CX(1),CZ(1),AV(1)
	DIMENSION PTMAX(4),PTMIN(4)
        COMMON /TYPSZ/LGFLT,LGFINT,LGLONG,LGINT,LGINT4,LGPTR,LGALGN
C ****************************************************************
C *                                                              *
C *                PARTIE SAISIE DE DONNEES                      *
C *                                                              *
C ****************************************************************
 
 
C CC SERT A RANGER LES 1,2,3,4 COUPES
C CX = AXE DE TRACER, CZ = CF FORT3D
C NX,NY = COORD DU PT D'ORIGINE
C NDX,NDY = DELTAX ,DELTAY
C NDXD,NDYD = DELTAX, DELTAY --DISCRET
C NDZ = ANCIEN NDXD OU NDYD
C MARKT = TYPE DE COURBE CELON CAS DISCRET
C MARKV = MARQUEUR DU SENS DE VISU
C MARKD = MARQUEUR DE DECALAGE
C IPC,IPL = COORD DU PROCHAIN PT A LIRE
C
	INTEGER INIT(7,3,4)
	INTEGER IBUF(65),DESSIN
	INTEGER LFMT0(9),IFMT(4),IDIMF(5),NCOURB
	INTEGER NX(4),NY(4),NDX(4),NDY(4),NDXD(4),NDYD(4),NDZ(4)
	INTEGER IPC(4),IPL(4),ND(4),MARKV(4),MARKD(4),MARKT(4)
	DATA DESSIN/1/
	DATA IUN/1/,IZR/0/
 
C ****************************************************************
C ***   INITIALISATION DU TABLEAU DES CAS DISCRETS    ************
C ****************************************************************
	DATA (INIT(1,1,K),K=1,4)/9,-1,0,0/
	DATA (INIT(1,2,K),K=1,4)/13,-1,1,1/
	DATA (INIT(2,1,K),K=1,3)/5,-1,0/
	DATA (INIT(2,3,K),K=1,4)/12,-1,1,-1/
	DATA (INIT(3,2,K),K=1,3)/4,0,1/
	DATA (INIT(3,3,K),K=1,4)/8,0,1,0/
	DATA (INIT(5,2,K),K=1,3)/3,0,1/
	DATA (INIT(5,3,K),K=1,4)/7,0,1,0/
	DATA (INIT(6,1,K),K=1,3)/2,1,0/
	DATA (INIT(6,3,K),K=1,4)/11,1,1,1/
	DATA (INIT(7,1,K),K=1,4)/6,1,0,0/
	DATA (INIT(7,2,K),K=1,4)/10,1,1,1/
	IBUF(1)=256
C   INITIALISATION FORMAT TYPE FLOAT
	IFMT(1)=LFMT0(1)
	IFMT(2)=LFMT0(2)
	IFMT(3)=LGFLT
	IFMT(4)=1
C
 
C **********************************************************
C ****    RELEVE INTERACTIF DES COURBES A TRACER    ********
C **********************************************************
 
 
C ***   SAISIE DE NIVEAU  1   ***
C ***************************************
 
1000  CALL OUTSTR(0,' $')
	CALL OUTSTR(0,'     ******************************************$')
	CALL OUTSTR(0,'     * VISUALISATION DE COUPES DANS UNE IMAGE *$')
	CALL OUTSTR(0,'     ******************************************$')
	CALL OUTSTR(0,' $')
	CALL OUTSTR(0,' VOULEZ-VOUS : $')
	CALL OUTSTR(0,'       --> 1 = SORTIR DU PROGRAMME $')
	CALL OUTSTR(0,'       --> 2 = DES EXPLICATIONS $')
	CALL OUTSTR(0,'       --> 3 = UNE SEULE COUPE $')
	CALL OUTSTR(0,'       --> 4 = DEUX COUPES $')
	CALL OUTSTR(0,'       --> 5 = TROIS COUPES $')
	CALL OUTSTR(0,'       --> 6 = COMPARER DES PARALELLES $')
	CALL OUTSTR(0,'       --> 7 = COMPARER PAR RAPPORT A UN POINT $')
	CALL OUTSTR(0,' $')
	CALL OUTSTR(0,'   UNE SEULE COUPE PAR DEFAUT $')
	CALL OUTSTR(0,' $')
	ICHO1=INTCHK(0,'   VOTRE CHOIX : $',IZR,7)+1
	CALL OUTSTR(0,' $')
	CALL OUTSTR(0,' $')
	NCOURB=1
	     GOTO (2000,5000,1500,2000,1002,1003,2000,2000) ICHO1
C 5000 ---> RETURN
C 1500 ---> CALL EXPLICATIONS
C 3000 ---> CAS DES 3 PARALELLES
C 4000 ---> CAS DU POINT DE REF
1003       NCOURB=NCOURB+1
1002       NCOURB=NCOURB+1
	        GOTO 2000
1500    GOTO 1000
C ICI SERA IMPLANTE CALL EXPLIQUE
 
 
C ***    SAISIE DE NIVEAU 2 ****
C ******************************
 
2000  DO 2500 I=1,NCOURB
	        IF (ICHO1.EQ.7) GOTO 2005
	        IF (ICHO1.EQ.8) GOTO 2005
	        CALL IWRNB(0,' COUPE NO : $',I)
	        CALL OUTSTR(0,' $')
	   CALL OUTSTR(0,' VOULEZ-VOUS : $')
	   CALL OUTSTR(0,'       --> 0 = UNE LIGNE $')
	   CALL OUTSTR(0,'       --> 1 = UNE COLONNE $')
	   CALL OUTSTR(0,'       --> 2 = DIAGONALE 1 (DX=1,DY=1) $')
	   CALL OUTSTR(0,'       --> 3 = DIAGONALE 2 (DX=-1,DY=1) $')
	   CALL OUTSTR(0,'       --> 4 = AUTRE $')
	   CALL OUTSTR(0,'       --> 5 = ERREUR RETOUR EN ARRIERE $')
	   CALL OUTSTR(0,' $')
	   ICHO2=INTCHK(0,' VOTRE CHOIX : $',IZR,5)+1
	   CALL OUTSTR(0,' $')
	GOTO (2001,2002,2003,2004,2005,1000) ICHO2
 
C   CAS  DES HORIZONTALES
 
2001  CALL IWRNB(0,' LES NO DE LIGNES VONT DE 1 A $',IFMT(2))
	NY(I)=INTCHK(0,'    NO CHOISI : $',IUN,IFMT(2))
	NX(I)=1
	NDX(I)=1
	NDY(I)=0
ccccccccccccc ATTENTION modif P. CIPIERE du 26/09/83 
ccccccccccccc symetrisation de la numerotation des lignes
	ny(i)=ifmt(2)-ny(i)+1
ccccccccccccc
ccccccccccccc
	  GOTO 2500
 
C   CAS DES VERTICALES
 
2002  CALL IWRNB(0,' LES NO DE COLONNES VONT DE 1 A $',IFMT(1))
	NX(I)=INTCHK(0,'    NO CHOISI : $',IUN,IFMT(1))
	NY(I)=1
	NDX(I)=0
	NDY(I)=1
	  GOTO 2500
 
C   CAS DE LA DIAGONALES 1
 
2003  NDX(I)=1
	NDY(I)=1
	NX(I)=1
	NY(I)=1
	  GOTO 2500
 
C   CAS DE LA DIAGONALE 2
2004  NDX(I)=-1
	NDY(I)=1
	NX(I)=IFMT(1)
	NY(I)=1
	  GOTO 2500
2005  CALL OUTSTR(0,' COORDONNEES MAX ET MIN DU POINT $')
	CALL IWRNB(0,'             AXE HORIZONTALE : 1 A $',IFMT(1))
	CALL IWRNB(0,'             AXE VERTICALE   : 1 A $',IFMT(2))
	CALL OUTSTR(0,'     PAS EN X OU EN Y COMPRIS ENTRE -3,+3 $')
	NX(I)=INTCHK(0,' COORDONNEE EN X= $',IUN,IFMT(1))
	NY(I)=INTCHK(0,' COORDONNEE EN Y= $',IUN,IFMT(1))
	     IF (ICHO1.EQ.8) GOTO 2500
2006  NDX(I)=INTCHK(0,' PAS EN X= $',-3,3)
	NDY(I)=INTCHK(0,' PAS EN Y= $',-3,3)
	IF ((NDX(I).EQ.0).AND.(NDY(I).EQ.0)) GOTO 3100
2500    CONTINUE
	  IF (ICHO1.EQ.8) GOTO 4000
	  IF (ICHO1.NE.7) GOTO 4500
 
C CAS DES 3 PARALELLES
 
	CALL OUTSTR(0,' ECART = DISTANCE SUIVANT X SEPARANT LES COUPES$')
	CALL OUTSTR(0,' ATTENTION A NE PAS DONNER UN ECART QUI SORTE$')
	IECAR1=INTCHK(0,' ECART EN PT DES 2 PREMIERE (1 A 10) $',1,10)
	IECAR2=INTCHK(0,' ECART EN PT DES 2 AUTRE (1 A 10) $',1,10)
	NCOURB=3
	NDX(2)=NDX(1)
	NDX(3)=NDX(1)
	NDY(2)=NDY(1)
	NDY(3)=NDY(1)
	NY(2)=NY(1)
	NY(3)=NY(1)
	NX(2)=NX(1)+IECAR1
	NX(3)=NX(1)-IECAR2
	IF (NX(2).LE.IFMT(1)) GOTO 3010
	NX(2)=NX(2)-10
3010  IF (NX(3).GE.1) GOTO 4500
	NX(3)=NX(3)+10
	GOTO 4500
3100    CALL OUTSTR(0,' $')
	CALL OUTSTR(0,'CE PROGRAMME TRAITE DES DROITES PAS DES POINTS$')
	  CALL OUTSTR(0,' $')
	GOTO 2006
4000  NCOURB=4
 
C CAS DU POINT DE REF
 
	NX(2)=NX(1)
	NX(3)=NX(1)
	NX(4)=NX(1)
	NY(2)=NY(1)
	NY(3)=NY(1)
	NY(4)=NY(1)
	NDX(1)=1
	NDY(1)=0
	NDX(2)=0
	NDY(2)=1
	NDX(3)=1
	NDY(3)=1
	NDX(4)=1
	NDY(4)=-1
C
C
C ************************************************************
C ***     INITIALISATION POUR LA LECTURE         *************
C ************************************************************
 
4500  IX=IFMT(1)
	IY=IFMT(2)
	MAX=MAX0(IX,IY)
	MIN=1
	CALL SETUP(NDIM,IFMT,NROW,NREST,NDIMA)
	IF (NROW.LE.0) CALL ERMESF(8)
	NCOUP=IFMT(2)/NROW
C ON INITIALISE CC A 0
	DO 10 I=1,MAX*4
	CC(I)=0
10    CONTINUE
 
 
C **************************************************************
C DEBUT BOUCLE DE CALCUL DU POINT DE DEPART DES 4 COURBES
	DO 200 I=1,NCOURB
C                  CHANGEMENT DE REPERE
	       NDY(I)=-NDY(I)
	       NY(I)=IY-NY(I)+1
C ON SE RAMENE A UNE ROT DE 180 A.L.D. 360
	    IF (NDY(I).GE.0) GOTO 20
	        NDY(I)=-NDY(I)
	        NDX(I)=-NDX(I)
20        CONTINUE
 
 
C *************************************************************
C *****    SEPARATION  DES  CAS , TYPE DE LA DROITE      ******
C *************************************************************
 
 
C SEPARATION DES CAS ET RECHERCHE DU TYPE DE DROITE
 
C ** CAS DES DROITES A NDX=NDY , TYPE 1
C *************************************
 
	   IF (IABS(NDX(I)).NE.NDY(I)) GOTO 22
	      NDYD(I)=1
	      NDY(I)=1
	      MARKT(I)=1
	   IF (NDX(I).LE.0) GOTO 21
	      NDXD(I)=1
	      NDX(I)=1
	   GOTO 700
21          NDXD(I)=-1
	      NDX(I)=-1
	   GOTO 700
 
C CAS DES VERTICALES
C *******************
22       IF (NDX(I).NE.0) GOTO 23
	             NDYD(I)=1
	             NDXD(I)=0
	             MARKT(I)=1
	       IPL(I)=1
	       IPC(I)=NX(I)
	             GOTO 100
C CAS DES HORIZONTALES
C *
23       IF (NDY(I).NE.0) GOTO 25
	             MARKT(I)=1
	             NDYD(I)=0
	       IPL(I)=NY(I)
	       IPC(I)=1
	       IF (NDX(I).LE.0) GOTO 24
	             NDXD(I)=1
	             GOTO 100
24                 NDXD(I)=-1
	             GOTO 100
 
C ***  AUTRES CAS,INITIALISATION DU DISCRET ***
C *********************************************
 
25              M1=NDX(I)+4
	          M2=NDY(I)
	    MARKT(I)=INIT(M1,M2,1)
	    NDXD(I)=INIT(M1,M2,2)
	    NDYD(I)=INIT(M1,M2,3)
	    NDZ(I)=INIT(M1,M2,4)
 
C ****    CALCUL DU PREMIER POINT A LIRE, CAS NON TRIVIAUX
C+*******************************************************
 
700       RIX=IX
	    RIY=IY
	    RNX=NX(I)
	    RNY=NY(I)
	    RNDX=NDX(I)
	    RNDY=NDY(I)
	    IF (NDX(I).GT.0) GOTO 50
 
C  INTERSECTION AVEC X=1
 
	    IF ((((RIX-RNX)/RNDX)-FLOAT((IX-NX(I))/NDX(I))).NE.0)GOTO30
	           ND(I)=IABS((IX-NX(I))/NDX(I))
	           IPC(I)=IX
	                     GOTO 80
30    IF((((RIX-RNX-1.)/RNDX)-FLOAT((IX-NX(I)-1)/NDX(I))).NE.0)GOTO40
	           ND(I)=IABS((IX-NX(I)-1)/NDX(I))
	           IPC(I)=IX-1
	                     GOTO 80
40               ND(I)=IABS((IX-NX(I)-2)/NDX(I))
	           IPC(I)=IX-2
	                     GOTO 80
C
C INTERSECTION AVEC X=IFMT(1)
 
50         IF ((((RNX-1.)/RNDX)-FLOAT((NX(I)-1)/NDX(I))).NE.0) GOTO 60
	           ND(I)=IABS((NX(I)-1)/NDX(I))
	           IPC(I)=1
	                     GOTO 80
60         IF ((((RNX-2.)/RNDX)-FLOAT((NX(I)-2)/NDX(I))).NE.0) GOTO 70
	           ND(I)=IABS((NX(I)-2)/NDX(I))
	           IPC(I)=2
	                     GOTO 80
70               ND(I)=IABS((NX(I)-3)/NDX(I))
	           IPC(I)=3
C
80        IF (NY(I)-NDY(I)*ND(I).LE.0) GOTO 90
C   INTERSECTION AVEC  Y=1
 
	           IPL(I)=NY(I)-NDY(I)*ND(I)
	                     GOTO 100
90         IF ((((RNY-1.)/RNDY)-FLOAT((NY(I)-1)/NDY(I))).NE.0) GOTO 92
	           IPL(I)=1
	           ND(I)=IABS((NY(I)-1)/NDY(I))
	                     GOTO 98
92        IF ((((RNY-2.)/RNDY)-FLOAT((NY(I)-2)/NDY(I))).NE.0) GOTO 94
	           IPL(I)=2
	           ND(I)=IABS((NY(I)-2)/NDY(I))
	                     GOTO 98
94               IPL(I)=3
	           ND(I)=IABS((NY(I)-3)/NDY(I))
C
98            IPC(I)=NX(I)-ND(I)*NDX(I)
C
C ON CONNAIT MAINTENANT IPL(I),IPC(I) ET ND(I)
C
C ***  CALCUL DE MARKD,SELON LA VUE MARKV
C ***************************************
 
100       IF (NDY(I).EQ.0) GOTO 150
	    IF ((IABS(NDX(I))/IABS(NDY(I))).GE.IX/IY) GOTO 150
	         MARKV(I)=2
	         IF (IX.GE.IY) GOTO 110
	             MARKD(I)=0
	             GOTO 200
110                MARKD(I)=INT((IX-IY)/2)
	             GOTO 200
150            MARKV(I)=1
	         IF (IY.GE.IX) GOTO 160
	             MARKD(I)=0
	             GOTO 200
160                MARKD(I)=INT((IY-IX)/2)
	             GOTO 200
200     CONTINUE
C FIN DE LA BOUCLE
C
 
C ************************************************************
C *********          LECTURE DE  CC          *****************
C ************************************************************
 
C CHARGEMENT DES TABLEAUX
C
	CALL LPTSET(NF,1)
	NCPT=0
300   DO 500 I=1,NCOUP
	       NCPT=NCPT+NROW
	       CALL LECT(NF,NROW,AV)
	       IF(LFMT0(4).EQ.1) GOTO 301
	       NDM=NROW*IFMT(1)
	       CALL CNVTBG(AV,AV,NDM,LFMT0(3),IFMT(3),LFMT0(9),0)
301          DO 500 J=1,NCOURB
310                 IF (IPL(J).GT.NCPT) GOTO 500
	              IF (IPC(J).LE.0) GOTO 500
	              IF (IPC(J).GT.IX)GOTO 500
	              IF (IPL(J).LE.0) GOTO 500
	              IF (IPL(J).GT.IY)GOTO 500
	              IF (MARKV(J).EQ.1) GOTO 320
	                  K=IPL(J)
	                  GOTO 330
320                     K=IPC(J)
330   CC(K+MARKD(J)+MAX*(J-1))=AV(IX*(IPL(J)-(NCPT-NROW+1))+IPC(J))
400                 IPL(J)=IPL(J)+NDYD(J)
	              IPC(J)=IPC(J)+NDXD(J)
	GOTO(310,402,403,404,402,406,407,408,406,410,411,412,410)MARKT(J)
402                 CALL RST1(NDYD(J),0,1)
	                   GOTO 310
403                 CALL RST1(NDXD(J),0,1)
	                   GOTO 310
404                 CALL RST1(NDXD(J),0,-1)
	                   GOTO 310
406                 CALL RST2(NDYD(J),NDZ(J),0,1,1)
	                   GOTO 310
407                 CALL RST2(NDXD(J),NDZ(J),0,1,1)
	                   GOTO 310
408                 CALL RST2(NDXD(J),NDZ(J),0,-1,-1)
	                   GOTO 310
410                 CALL RST2(NDYD(J),NDZ(J),1,1,0)
	                   GOTO 310
411                 CALL RST2(NDXD(J),NDZ(J),1,1,0)
	                   GOTO 310
412                 CALL RST2(NDXD(J),NDZ(J),-1,-1,0)
	                   GOTO 310
500   CONTINUE
	IF (NREST.EQ.0) GOTO 550
	    NROW=NREST
	    NREST=0
	    NCOUP=1
	GOTO 300
C
C FIN DE CHARGEMENT
C
C CX=AXE DE TRACE
C
550    DO 560 I=1,MAX
	        CX(I)=I
560    CONTINUE
C
C CALCUL DES MIN ET MAX DE CHAQUE COUPES
	 DO 800 I=1,NCOURB
	             PTMAX(I)=CC(1+MAX*(I-1))
	             PTMIN(I)=CC(1+MAX*(I-1))
	 DO 800 J=1,MAX
	             PTINTR=CC(J+MAX*(I-1))
	        IF (PTINTR.GT.PTMAX(I)) PTMAX(I)=PTINTR
	        IF (PTINTR.LT.PTMIN(I)) PTMIN(I)=PTINTR
800    CONTINUE
C
C
 
C ****************************************************************
C *                                                              *
C *               PARTIE  VISUALISATION  EN  3-D                 *
C *                                                              *
C ****************************************************************
 
 
 
C  VARIABLES UTILISEES POUR LE 3D
 
C  XM = X MINIMUM DU MASQUE DE L'IMAGE VIRTUELLE
C  YM = Y   " "    "   " "   "   "  "    "   "
C  XX = X MAXIMUM  "   " "   "   "  "    "   "
C  YX = Y   " "    "   " "   "   "  "    "   "
C  XMIN = X MINI  DE LA FENETRE DE VISUALISATION
C  YMIN = Y  ""    "  "   "  "   "    "  "  "
C  XMAX = X MAXI   "  "   "  "   "    "  "  "
C  YMAX = Y  ""    "  "   "  "   "    "  "  "
C  PTMIN(I) = TABLEAU DES MINI DE CHAQUE COURBES DONNES PAR SAISIE
C  PTMAX(I) =   "  "   "  MAXI "    " "    "  "   "  "   "   "  "
C  NCOURB   = NOMBRE DE COURBE A VISUALISER ,     "  "   "   "  "
C  CC (I)   = TABLEAU CONTENANT LES COUBES A TRACER, "   "   "  "
C  CX(I)    =   " "   DE REFERENCE EN X              "   "   "  "
C  CZ(I)    = TABLEAU DE VISU DE COURBE.
C  MAX = MAX0(IFMT(1),IFMT(2))
C  MIN = 1 CAR UNE TOUT INDICE COMMENCE A 1
C  N0CBE= NUMERO DE LA COURBE A TRACER.
C  ICHO1 = VALEUR DETERMINE PAR SAISIE.
C  ICHOI2= CONTIENT LE TYPE DE REPRESENTATION DEMANDE DANS SAISIE.
C  ICHM= MEMOIRE DU ICH DE NIVEAU 1 PRECEDENT.
C  INDCH= 1 SI ICHM A ETE INITIALISE.
 
 
 
C    ASSIGNATION DE LA TEK EN MODE GRAPHIQUE
C    INITIALISATION DU PERIFERIQUE EN SORTIE PAR LE BUFFER
C    IBUF ETANT UN BUFFER DE TRANSMISSION.
C    OUVERTURE D'UN DESSIN AVEC NETOYAGE DE L'ECRAN.
 
	CALL ASSTEK
	CALL DEVICE(1,IBUF)
	CALL INIDES(0,DESSIN)
 
 
	XM=MIN
	XX=MAX
	YM=PTMIN(1)
	YX=PTMAX(1)
	IF(YX-YM) 919,909,919
909   YM=YM-.2*(YM+1)
	YX=YX+.2*(YX+1)
919   DO 900 I=1,NCOURB
	IF (YM.GT.PTMIN(I)) YM=PTMIN(I)
	IF (YX.LT.PTMAX(I)) YX=PTMAX(I)
900   CONTINUE
 
	IF(NCOURB.GT.1) GOTO 6123
C
C ************************************************************
C ***************** COURBE SIMPLE ****************************
C ************************************************************
C
	CALL OUTSTR(0,' $')
	CALL OUTSTR(0,'***********************$')
	CALL OUTSTR(0,'*    COURBE SIMPLE    *$')
	CALL OUTSTR(0,'***********************$')
6100  CALL GECRAN(XM,XX,YM,YX,1,PTMIN,PTMAX,1,ICHO1)
	CALL ZOOM(XM,XX,YM,YX,CC,CZ,1,MAX)
	CALL CURVE2(CX,CZ,IFIX(XX-XM+1))
ccc modif P. CIPIERE 4/11/83
ccc hardcopy sur plotter hp
	call hpcopy
	   CALL OUTSTR(0,' $')
	   CALL OUTSTR(0,' VOUS-VOULEZ  $')
	   CALL OUTSTR(0,'     --> 0 = UN ZOOM $')
	   CALL OUTSTR(0,'     --> 1 = UNE AUTRE COURBE $')
	ICH=INTCHK(0,' VOTRE CHOIX : $',IZR,9)
	   CALL OUTSTR(0,' $')
	IF(ICH.NE.0) GOTO 2000
	   CALL IWRNB(0,' ZOOM ENTRE 1 ET $',MAX)
	XM=INTCHK(0,'    POINT MINIMUM = $',IUN,MAX)
	XX=INTCHK(0,'    POINT MAXIMUM = $',IFIX(XM),MAX)
	CALL INIDES(1,DESSIN)
	GO TO 6100
 
C ************************************************************
C ***************** COURBES MULTIPLES ************************
C ************************************************************
C
	  CALL OUTSTR(0,' $')
	  CALL OUTSTR(0,'*************************$')
	  CALL OUTSTR(0,'*   COURBES MULTIPLES   *$')
	  CALL OUTSTR(0,'*************************$')
 
6123  CONTINUE
 
	INDICH=0
	NCB=NCOURB
	INS=1
6000  CALL GECRAN(XM,XX,YM,YX,NCOURB,PTMIN,PTMAX,1,ICHO1)
	DO 6001 I1=INS,NCB
	CALL ZOOM(XM,XX,YM,YX,CC,CZ,I1,MAX)
6001  CALL CURVE2(CX,CZ,IFIX(XX-XM+1))
ccc modif P. CIPIERE 4/11/83
ccc hardcopy sur plotter hp
	call hpcopy
8222	CALL OUTSTR(0,' VOULEZ-VOUS $')
	CALL OUTSTR(0,'       --> 6 = VISU PLEIN ECRAN$')
8223  CALL OUTSTR(0,'       --> 5 = AUTRES COURBES $')
	GOTO(7001,7002,7003,7004) NCOURB
7004     CALL OUTSTR(0,'       --> 4 = ZOOM SUR C4 $')
7003     CALL OUTSTR(0,'       --> 3 = ZOOM SUR C3 $')
7002     CALL OUTSTR(0,'       --> 2 = ZOOM SUR C2 $')
7001     CALL OUTSTR(0,'       --> 1 = ZOOM SUR C1 $')
	   CALL OUTSTR(0,'       --> 0 = ZOOM C1 C2 C3 C4 $')
	ICHM=ICH
	ICH=INTCHK(0,' VOTRE CHOIX : $',IZR,6)
	   CALL OUTSTR(0,' $')
	IF(ICH.EQ.5) GOTO 1000
 
C   ON VEUT VISUALISER LA COURBE(S) EN PLEIN ECRAN
	IF(ICH.NE.6) GOTO 7000
	IF(INDICH.EQ.0) GOTO 8223
	CALL INIDES(1,DESSIN)
	IF(ICHM.NE.0) GOTO 6666
	INS=1
	NCB=4
	GOTO 6000
6666  INS=ICHM
	NCB=ICHM
	GOTO 6000
 
7000    CALL IWRNB(0,'ZOOM ENTRE 1 ET $',MAX)
	XM=INTCHK(0,'   POINT MINIMUM = $',IUN,MAX)
	XX=INTCHK(0,'   POINT MAXIMUM = $',IFIX(XM)+10,MAX)
	INDICH=1
 
 
C *  VISUALISATION EN MOYEN ECRAN AVEC PETITES FENETRES   *
C *********************************************************
 
C DEFINITION D'UN NOUVEAU CONTEXT D'AFFICHAGE.
C
	CALL INIDES(1,DESSIN)
C ONTRACE LES PETITES FENETRES.
	DO 6002 N0CBE=1,NCOURB
	RTMAX=MAX
	RTMIN=MIN
	CALL GECRAN(RTMIN,RTMAX,YM,YX,N0CBE,PTMIN,PTMAX,3,ICHO1)
	CALL ZOOM(RTMIN,RTMAX,YM,YX,CC,CZ,N0CBE,MAX)
	CALL CURVE2(CX,CZ,MAX)
6002  CONTINUE
 
C ON TRACE LA FENETRE DE TRAVAIL EN MOYEN ECRAN.
	CALL GECRAN(XM,XX,YM,YX,N0CBE-1,PTMIN,PTMAX,2,ICHO1)
 
C ON VISUALISE LA OU LES COURBES.
	IF(ICH.EQ.0) GOTO 8000
	CALL ZOOM(XM,XX,YM,YX,CC,CZ,ICH,MAX)
	CALL CURVE2(CX,CZ,IFIX(XX-XM+1))
ccc modif P. CIPIERE 4/11/83
ccc hardcopy sur plotter hp
	call hpcopy

	GOTO 8222
8000  DO 2 J=1,4
	CALL ZOOM(XM,XX,YM,YX,CC,CZ,J,MAX)
	CALL CURVE2(CX,CZ,IFIX(XX-XM+1))
2     CONTINUE
ccc modif P. CIPIERE 4/11/83
ccc hardcopy sur plotter hp
	call hpcopy
	GOTO 8222
 
5000  CONTINUE
	CALL CLOSEG(DESSIN)
	RETURN
	END
