C* ISOLIN
	SUBROUTINE ISOLIN(ARM,LINE,ILINE,HIDDEN,IHIDD,IBUF,LINNUM,IPDX
     :,A1,B1,A2,B2,XS,YS,IPX,RN,RALPHA,BETA,GAMMA)
C     trace une ligne image
C inputs:
C     IPDX : dim. en X de l'image echantillonee
C     IPX : min du facteur de repetition : (min de (128 / IPDX) et (128 /IPDY)
C     RN : delta entre 2 points image orig. (1/(max)(dimx,dimy))
C     B1 : offset en X dans page Tek (512.)
C     B2 : offset en Y dans page Tek (512.)
C     XS, YS : coord extremes (par ex 1., 1.)
C     LINNUM : num ligne courante (1 a RPDY)
C     RALPHA BETA GAMMA : cosinus des angles de proj.
C     LINE, ILINE, HIDDEN, IHIDD, IBUF : tableaux fixes (4 de 128 et 1 de 256)
C     ARM : datas de la ligne a afficher
	INTEGER IBUF(3),LINE(1),ILINE(1),HIDDEN(1),IHIDD(1)
	DIMENSION ARM(1)
	LOGICAL HID1,HID2,TRC
	DATA NPROG/504/
	K=1
	TRC=.FALSE.
	Y=YS-(LINNUM-1.)*IPX*RN
	X=A1*BETA*(XS-Y)+B1+.5
	IX0=IFIX(X)
	R1=A2*GAMMA*(XS+Y)+B2
	R2=-A2*GAMMA*RN
	R3=A2*RALPHA
	M=(IPDX-1)*IPX+1
	YES1=R1+.5
	IYES1=IFIX(YES1)
	YES2=YES1+R2*(M-1.)
	IYES2=IFIX(YES2)
	IF (LINNUM.NE.1) GO TO 1
	IX=IX0+2*(M-1)
c	IBUF(1)=IGS
        ibuf(1)=-1
	IBUF(3)=ISOPUT(IX0,IYES1)
	IBUF(2)=ISOPUT(IX,IYES2)
	K=4
	TRC=.TRUE.
1     IX=IX0-2

	DO 2 I=1,M
	IX=IX+2
	RY=R1+R2*(I-1.)+R3*ARM(I)+.5
	IY=IFIX(RY)
	LINE(I)=IY
	ILINE(I)=ISOPUT(IX,IY)
2     CONTINUE
	IF(LINNUM.NE.1)GOTO30
	DO 31 I=1,M
31    HIDDEN(I)=0
30    CONTINUE
	L=1+IPX
	IF(TRC)GOTO21
cc	IBUF(K)=IGS
	IBUF(K)=-1
	IBUF(K+1)=ISOPUT(IX0,IYES1)
	IBUF(K+2)=ILINE(1)
	IBUF(K+3)=ILINE(L)
	K=K+4
	GOTO22
21    IBUF(K)=ILINE(1)
	IBUF(K+1)=ILINE(L)
	K=K+2
22    TRC=.TRUE.
	IF (LINE(L)-HIDDEN(1)) 4,4,3
3     HID1=.FALSE.
	HIDDEN(1)=LINE(L)
	IHIDD(1)=ILINE(L)
	GO TO 5
4     HID1=.TRUE.
5     CONTINUE
	M=M-1
	DO 6 I=L,M
	N=I+1-IPX
	IF (LINE(I+1)-HIDDEN(N)) 8,8,7
7     HID2=.FALSE.
	J=HIDDEN(N)
	HIDDEN(N)=LINE(I+1)
	IHIDD(N)=ILINE(I+1)
	GO TO 9
8     HID2=.TRUE.
9     CONTINUE
	IF(HID1.AND.HID2)GOTO15
	IF(TRC)GOTO16
cc	IBUF(K)=IGS
	IBUF(K)=-1
	N1=N-1
	IBUF(K+1)=IHIDD(N1)
	IBUF(K+2)=IHIDD(N)
	K=K+3
	GOTO17
16    IBUF(K)=IHIDD(N)
	K=K+1
17    TRC=.TRUE.
	GOTO40
15    TRC=.FALSE.
40    HID1=HID2
6     CONTINUE
	IF(HID2)GOTO19
	IF(LINNUM.EQ.1)GOTO50
	J=MAX0(J,IYES2)
	IBUF(K)=ISOPUT(IX,J)
	GO TO 51
50    IBUF(K)=IBUF(2)
51    K=K+1
19    CONTINUE
      call isotra(ibuf,k-1)
	M=M+1
	N=M-IPX
	DO 10 I=1,N
	K1=N-I+1
	K2=M-I+1
	HIDDEN(K2)=HIDDEN(K1)
10    IHIDD(K2)=IHIDD(K1)
	DO 11 I=1,IPX
	IHIDD(I)=ILINE(I)
11    HIDDEN(I)=LINE(I)
	RETURN
201   CALL TEKERR(1,IS2)
	END
