C* ISOSET
	SUBROUTINE ISOSET(IPDX,IPDY,A1,B1,A2,B2,XS,YS,IPX,RN,RALPHA,BETA
     :,GAMMA)
C inputs:
C     IPDX, IPDY : dim. en X et Y de l'image echantillonee
C outputs:
C     IPX : min du facteur de repetition : (min de (128 / IPDX) et (128 /IPDY)
C     RN : delta entre 2 points image orig. (1/(max)(dimx,dimy))
C     B1 : offset en X dans page Tek (512.)
C     XS, YS : coord extremes (par ex 1., 1.)
C RALPHA BETA GAMMA : cosinus des angles de proj.
	RALPHA=0.70710678
	BETA=-0.7071067818
	GAMMA=-0.5
      IPX=128/IPDX
      IPY=128/IPDY
	IPX=MIN0(IPX,IPY)
	IF (IPDX-IPDY) 7,8,9
7     RN=1./((IPDY-1.)*IPX)
	XS=.5*(1.+(IPDX-1.)*IPX*RN)
	YS=1.
	GO TO 10
8     RN=1./((IPDX-1.)*IPX)
	XS=1.
	YS=1.
	GO TO 10
9     RN=1./((IPDX-1.)*IPX)
	XS=1.
	YS=.5*(1.+(IPDY-1.)*IPX*RN)
10    A1=-2./(RN*BETA)
	B1=512.
	C=RALPHA-2.*GAMMA
	A2=260./C
	B2=570.-260.*RALPHA/C
	RETURN
	END
