/*
 PRINTI
	SUBROUTINE PRINTI(A,NDIM,NF,IXYZ,IDXYZ,FILE,IFORM,LGOUT,COMPACTF)
	printi_(a,ndim,nf,ixyz,idxyz,file,iform)
  impression de la fenetre de taille IDXYZ(1),IDXYZ(2),IDXYZ(3) en X,Y,Z
   et de 1er point IXYZ(1),IXYZ(2),IXYZ(3), de l'image NF
 image lue dans tableau A et imprimee sur file FILE
  (stdout si FILE == 0)
  IFORM : format d'impression d'une valeur par printf
 LGOUT : nb max de valeurs par ligne d'impression
 COMPACTF != 0 => format  compact : sans num ligne ni plan si >0, avec num plans si < 0
*/
#include <inrimage/image.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

static char * ifmt1, *ifmt2;
extern char *i_malloc();

printi_(a,ndim,nf,ixyz,idxyz,file,iform,lgout,compactf)
register char *a;
Fort_int *ndim, *lgout, *compactf;
struct image **nf;
Fort_int *ixyz, *idxyz;
FILE *file;
char *iform;
{
	Fort_int lfmt[9];
	int ixi, iyi, izi;
	int ntot, nlig, isig;
	register i, j, n, ibs;
	register nlg;
	int y0, ibits, ityp;
	Fort_int icodo[2];
	register char *s;
	if(iform == 0 || *iform == 0)
		imerror(9,"printi: format non defini\n");
	if(file == NULL)
		file = stdout;
	c_getgfm(*nf,lfmt,0);
	ixi = ixyz[0] -1;
	iyi = ixyz[1] -1;
	izi = ixyz[2] -1;
	if(NDIMZ == 1)
		izi = 0;
	if(((ixi + idxyz[0]) > DIMX) ||
	   ((iyi + idxyz[1]) > NDIMY) ||
	   ((izi + idxyz[2]) > NDIMZ))
		imerror(9,"printi : parametres de fenetre incorrects\n");

	ntot = *ndim * sizeof(t_aligned);
	if((ityp = formtype(iform)) < 0)
		imerror(9,"printi: format incorrect\n");
	if(BSIZE > 0)
		ibs = BSIZE;
	else
		ibs = (7 - BSIZE) / 8;
	ibits = TYPE >= 0 ? 8 * ibs : -BSIZE;
	i = ibs;
	if(ityp > 0) {
		i = sizeof(float);
		icodo[0] = i;
		icodo[1] = 1;
	} else {
		icodo[0] = ibs;
		icodo[1] = TYPE == REELLE ? REELLE : FIXE;
		if(ibs > 1) {
			i = sizeof(float);
		}
	}
	nlig = ntot / (DIMX * i);
	if(nlig <= 0)
		imerror(8,"printi: pas assez de memoire (utilisez option -k)\n");
	i = strlen(iform) + 2;
	ifmt1 = (char *)i_malloc(i);
	i = compil_format(iform,ifmt1);
	ifmt2 = (char *)i_malloc(i + 2);
	strcpy(ifmt2,ifmt1);
	s = ifmt1 + i -1;
	if(*s == ' ' || *s == '\t' || *s == '\n') {
		i--;
	} else {
		*(++s) = ' ';
		*(++s) = 0;
	}
	s = ifmt2 + i;
	*s++ = '\n';
	*s++ = 0;
	if(nlig > idxyz[1])
		nlig = idxyz[1];
	y0 = iyi + (izi * NDIMY) + 1;
	if(NDIMZ <= 1)
		izi = -1;  /* pour passer 0 a iprinttb et rprinttb */
	isig = EXP < 0 ? 1 : 0;
	for(i=0;i<idxyz[2];i++) {
		c_lptset(*nf,y0);
		nlg = idxyz[1];
		n = nlig;
		j = iyi + 1;
		while(nlg > 0) {
			if(n > nlg) n = nlg;
			c_lect(*nf,n,a);
			c_trtblb(a,DIMX,ixi+1,a,idxyz[0],1,idxyz[0],n,ibits);
			c_cnvtbg(a,a,n * idxyz[0],&lfmt[2],icodo,EXP,EXP);
			if(!ityp) 
				iprinttb(a,idxyz[0],n,j,izi +i +1,file,ifmt1,ifmt2,*lgout,*compactf,ibs,isig);
			else
				rprinttb(a,idxyz[0],n,j,izi + i +1,file,ifmt1,ifmt2,*lgout,*compactf);
			nlg -= n;
			j += n;
		}
		y0 += NDIMY;
	}
}
