#include <ctype.h>


/* retourne 1 si flottant, -1 si err (nb de % != 1) , 0 sinon */
int formtype(fmt)
register char *fmt;
{
	register c, flgp, flgt, ist;
	flgp = 0; flgt= 0;
	while((c = *fmt++) != 0) {
		if(c == '%') {
			if(flgp) return -1;  /* plusieurs % */
			flgp = 1;
		} else {
			if(!flgp || flgt)
				continue;
			if(isalpha(c)) {
				flgt = 1;  /* type found */

				if(c == 's') return -1;
				c |= 0x20;  /* force minuscules */
				if(c == 'f' || c == 'g' || c == 'e')
					ist = 1;
				else
					ist = 0;
			}
		}
	}
	return ist;
}

/* copie un format en remplacant les \n et autres par leur code */
int compil_format(in,out)
register char *in, *out;
{
	register n;
	register c, flgb;
	n = 0;
	flgb = 0;
	while((c = *in++) != 0) {
		if(c == '\\') {
			if(flgb) {
				*out++ = c;
				n++;
				flgb = 0;
			} else {
				flgb = 1;
			}
			continue;
		}
		if(flgb) {
			flgb = 0;
			switch (c) {
			case 't':
				c = '\t';  /* TAB */
				break;
			case 'r':
				c = '\r';
				break;
			case 'n':
				c = '\n';
				break;
			}
		}
		*out++ = c;
		n++;
	}
	*out = 0;
	return n;
}
