/*
	rprinttb(a,lglig,nlig,iyi,izi,file,iform1,iform2,lgout,compactf)

 impression sur fichier FILE, du tableau A de NLIG lignes de LGLIG flottants
 IYI, IZI : numero plan et 1e ligne (IZI == 0 si pas de plans)
 IFORM1 :  format pour printf d'une valeur
 IFORM2 :  format pour printf de la derniere valeur de la ligne d'impression
   dans ces 2 formats les caracteres speciaux doivent etre donnes par leur code
   et non par une sequence '\'
 LGOUT : nb max de valeurs par ligne d'impression
 COMPACTF != 0 => pas d'impression de num de ligne
*/

#include <stdio.h>

rprinttb(a,lglig,nlig,iyi,izi,file,iform1,iform2,lgout,compactf)
register float *a;
int lglig, nlig, iyi, izi;
register char *iform1, *iform2;
FILE *file;
int lgout, compactf;
{
	register i, j, k;
	for(i=0;i<nlig;i++) {
		if(!compactf) {
			if(izi)
				fprintf(file,"plan %d, ligne %d\n",izi,iyi +i);
			else
				fprintf(file,"ligne %d\n",iyi +i);
		}
		k = 0;
		for(j=0;j<lglig;j++) {
			k++;
			if(k >= lgout) {
				fprintf(file,iform2,*a++);
				k=0;
			} else
				fprintf(file,iform1,*a++);
		}
		if(k > 0)
			fprintf(file,"\n");
	}
}
