#include <stdio.h>
#include <inrimage/image.h>
#include "bmp.h"

extern errno;
extern debug_;

int bmp_read1(pnf,buf,n)
struct extimage **pnf;
register char *buf;
register n;
{
	register i;
	register char *pc;
	if(n <= 0)
		return 0;
	pc = buf;
	while(n > 0) {
		if((i = fread(pc,1,n,(*pnf)->file)) < 0) {
			fermbmp(pnf);
			imerror(1,"read err %d\n",errno);
		}
		pc += i;
		n -= i;
	}
	return i;
}


int bmp_err(pnf,code,txt,p1,p2,p3,p4)
struct extimage **pnf;
int code;
char *txt;
char *p1, *p2, *p3, *p4;
{
	fermbmp(pnf);
	imerror(code,txt,p1,p2,p3,p4);
}

fermbmp(pnf)
register struct extimage **pnf;
{
	register struct extimage *nfext;
	if(!(nfext = *pnf)) return 1 /* makes c99 happy */;
	if(nfext->file == NULL) return 1 /* makes c99 happy */;
	fclose(nfext->file);
	if(nfext->data)
		i_Free(&nfext->data);
	if(nfext->cindex)
		i_Free(&nfext->cindex);
	if(nfext->x_params)
		i_Free(&nfext->x_params);
	i_Free(pnf);
}

