#define LG_NAME 256
struct extimage {
	char name[LG_NAME];
	FILE *file;
	int dimx, dimy, size;
	int nbits; /* bits/ pixel */
	unsigned char *data;
	unsigned char *cindex;  /* color index, used by quantize */
	int numcols;
	short interlace, flg89;
	unsigned char rbuf[256], gbuf[256], bbuf[256];  /* color tables */
};

/* gif structure (les shorts sont swapps)
1 bloc= 1 char longueur, n char data

file:
6 char : GIF87a ou GIF89a

2 short : screen width and height
1 char : flag (0x80= colormap, 0x70= nb -1 color resolution bits, 0x7 = nb bits - 1 => nb colors = 2 ** nbits)
1 char : background
1 char : aspect ratio ,   (float) (byte + 15) / 64.

3 * nbcolors char : colormap si presente (rgb,rgb,...)

1 char type :
	';'  : fin de fichier
	'!' : extension block, suivi de 
		1 char type suivi de blocks, termins par block de taille nulle
		   types: 0xf9 transparence 
		          0xfe comment
			  0x1  plain text
	',' : image separator, suivi des donnes image


Image:
2 short : left offset , top offset
2 short : image width, height
1 char  : flag (0x40 = entrelac, 0x80= colormap, 0x7 = nbits-1)
3*ncolors char si colormap
LZWencoded data


*/
