C* CONVLC
	SUBROUTINE CONVLC(A,NTABV,NF1,ISF1,NF2,ISF2,IFMT,
     #FEN,IFMTF,ITYP)
C
C   CONVOLUTION DE L'IMAGE NF1,ISF1 DE FORMAT IFMT, AVEC UNE FENETRE
C  CONSTANTE DE VALEUR FEN ET DE FORMAT IFMTF.
C   RESULTAT DANS IMAGE NF2,ISF2 (FORMAT IFMT)
C  PROLONGEMENTS AUX BORDS PAR REPETION DES ELEMENTS EXTREMES
C IMAGES ET FENETRE DOIVENT ETRE REELS
C  CONVOLUTION NORMALE (Y(I,J)=SOM X(I-K,J-L)*F(K,L)) POUR ITYP=1
C  ET PSEUDO-CONVOLUTION POUR ITYP=2 (Y(I,J)=SOM X(I+K,J+L)*F(K,L)),
C   POUR K DE -N2 A N1 ET L DE -M2 A M1 (N1+N2+1=N, M1+M2+1=M),
C    AVEC N1=(N-1)/2, N2=N/2, M1=(M-1)/2, M2=M/2 POUR ITYP=1
C     ET  N1=N/2, N2=(N-1)/2, M1=M/2, M2=(M-1)/2 POUR ITYP=2.
	DIMENSION A(1),IFMT(4),IFMTF(4)

	NXF=IFMTF(1)
	NYF=IFMTF(2)
	IDIMX=IFMT(1)
	IDIMY=IFMT(2)
	IF(ITYP.EQ.2) GOTO 20
	IF(ITYP.NE.1) CALL ERMESF(9)
	IDXF2=(NXF-1)/2
	IDYF2=(NYF-1)/2
	IDYF3=NYF/2
	IDXF3=NXF-IDXF2-1
	GOTO 21
20    IDXF2=NXF/2
	IDXF3=(NXF-1)/2
	IDYF2=NYF/2
	IDYF3=(NYF-1)/2
21    IF(NYF.GT.IDIMY.OR.NXF.GT.IDIMX) CALL ERMESF(9)
	IF(NTABV.LT.NYF*(IDIMX+NXF)) CALL ERMESF(8)
	NB1=IDYF2*IDIMX
	IDEB0=NXF*NYF+1
	IDEB=IDEB0+NB1
	NBLIG=(NTABV-IDEB+1)/IDIMX
	NMXL=NBLIG
	IF(NBLIG.GT.IDIMY) NBLIG=IDIMY
	N2=NBLIG+IDYF3
	IF(NMXL.GT.N2) NMXL=N2
	NCOP=(NYF-1)*IDIMX+IDEB0-1
	NTRT=0
	NTOT=0
	NBLEC=0
	NBECR=0
	ILEC=1
	NBLG=NMXL-IDYF3
	NBLC=NMXL-NBLIG
	IDBL=IDEB+IDYF3*IDIMX
	IDXF=IDXF2+1
	N2=IDIMX-NXF+1
C  LECTURE 1ERES LIGNES ET DUPLIC 1ERE LIGNE
	CALL lecflt(NF1,NBLIG,A(IDEB))
	NBLEC=1
	IA=IDEB
	NB2=0
	IB0=IDEB0
	DO 10 J=1,IDIMX
	IB=IB0
	R=A(IA)
	DO 11 I=1,IDYF2
	A(IB)=R
11    IB=IB+IDIMX
	IA=IA+1
10    IB0=IB0+1
	GOTO 2
C  RECOPIER NYF-1 LIGNES AU DEBUT DU TABLEAU
1     IA=IDEB+(NBLGO-IDYF2)*IDIMX
	DO 5 IB=IDEB0,NCOP
	A(IB)=A(IA)
5     IA=IA+1
	IF(ILEC.LE.0) GOTO 2
	CALL lecflt(NF1,NBLIG,A(IDBL))
	NBLEC=NBLEC+1
2     IF(NBLC.LE.0) GOTO 3
	IB0=IDEB+NB2+NBLIG*IDIMX
	IA=IB0-IDIMX
	DO 31 J=1,IDIMX
	IB=IB0
	R=A(IA)
	DO 32 I=1,NBLC
	A(IB)=R
32    IB=IB+IDIMX
	IA=IA+1
31    IB0=IB0+1
C    DEBUT TRAITEMENT DES LIGNES EN MEMOIRE
3     IA00=IDEB0
	IB=1
	DO 400 IYA=1,NBLG
	NXF0=IDXF
C  1E CAS FENETRE DEBORDANT A GAUCHE
	DO 100 IXA=1,IDXF2
	IA0=IA00
	R=0.
	DO 103 IYF=1,NYF
	IA=IA0
	IXF=1+NXF0
	R=R+NXF0*A(IA)
	IA=IA+1
102   IF(IXF.GT.NXF) GOTO 103
	R=R+A(IA)
	IA=IA+1
	IXF=IXF+1
	GOTO 102
103   IA0=IA0+IDIMX
	A(IB)=R*FEN
	IB=IB+1
	NXF0=NXF0-1
100   CONTINUE
C  2E PARTIE : FENETRE INCLUSE DANS IMAGE
	N=N2
200   IF(N.LE.0) GOTO 300
	IA0=IA00
	R=0.
	DO 203 IYF=1,NYF
	IA=IA0
	DO 202 IXF=1,NXF
	R=R+A(IA)
202   IA=IA+1
	IA0=IA0+IDIMX
203   CONTINUE
	A(IB)=R*FEN
	IB=IB+1
	N=N-1
	IA00=IA00+1
	GOTO 200
C  3E PARTIE : FENETRE DEBORDANT A DROITE
300   NXF0=NXF-2
	DO 310 IXA=1,IDXF3
	R=0.
	IA0=IA00
	DO 302 IYF=1,NYF
	IA=IA0
	IXF=1
301   IF(IXF.GT.NXF0) GOTO 303
	R=R+A(IA)
	IA=IA+1
	IXF=IXF+1
	GOTO 301
303   IF(IXF.GT.NXF) GOTO 305
	R=R+A(IA)*(NXF-IXF+1)
305   CONTINUE
302   IA0=IA0+IDIMX
	A(IB)=R*FEN
	IB=IB+1
	NXF0=NXF0-1
310   IA00=IA00+1
	IA00=IA00+IDXF2
400   CONTINUE
	CALL ECR(NF2,NBLG,A)
	NBECR=NBECR+1
	NTRT=NTRT+NBLG
	NTOT=NTOT+NBLIG
	NBLGO=NBLG
	NBLIG=NBLG
	NB2=IDYF3*IDIMX
	NREST=IDIMY-NTOT
	IF(NREST.LE.0) GOTO 403
	IF(NREST.GT.NBLIG) GOTO 1
	NBLIG=NREST
	GOTO 404
403   ILEC=-1
	NBLIG=0
404   NREST=IDIMY-NTRT
	IF(NREST.LE.0) GOTO 500
	IF(NREST.GT.NBLG) GOTO 405
	NBLG=NREST
405   NBLC=NBLG-NBLIG
	GOTO 1
500   RETURN
	END
