C* DOARIT
	SUBROUTINE DOARIT(NFI,SFI,NFO,SFO,LFMTI,LFMTO,NROW,NDIMA,A,TYPE,
     *SC,VAL)
C   OPERATIONS ARITHM. PONCTUELLES SUR IMAGES REELLES
C    EFFECTUEES SUR NROW LIGNES (=NDIMA POINTS)
C    ENTREE (NFI,SFI), SORTIE (NFO,SFO), FORMATS LFMTI ET LFMTO
C    A=TABLEAU DE TRAVAIL
C   SC=SCALAIRE EVENTUEL DE L'OPERATION (MULTIPLICATEUR, SEUIL, ETC.)
C    VAL= VALEUR A METTRE POUR LES SEUILS VARIABLES
C  OPERATIONS, SELON LA VALEUR DE TYPE :
C      0=BIAS, 1=SCALE, 2=LOG, 3=EXP, 4=RACINE, 5=SEUIL BAS,
C     6=SEUIL HAUT, 7=DIVISION (INTERDIT : REMPLACE PAR MULTIPL.),
C     8=MASQUE BAS, 9=MASQUE HAUT, 10=MODULE, 11=CARRE, 12=SEUIL BAS VAR
C     13=SEUIL HAUT VARIABLE
C  POUR MASQUES BAS ET HAUT, RESULTAT SUR 1 BIT
	INTEGER TYPE,PTR,LFMTI(9),LFMTO(9)
	DIMENSION A(1)
	INTEGER*2 SFI,SFO

	PTR=LPTGET(NFO)
c si l'image n'est pas reelle on la convertit en reelle
	CALL lecflt(NFI,NROW,A)
	I=TYPE+1
	IF(I.LT.1.OR.I.GT.14)GOTO 80
	GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140),I
C   BIAS
10    DO 11 J=1,NDIMA
11    A(J)=A(J)+SC
	GOTO 200
C   SCALE
20    DO 21 J=1,NDIMA
21    A(J)=A(J)*SC
	GOTO 200
C   LOG
30    DO 31 J=1,NDIMA
31    A(J)=ALOG(A(J))
	GOTO 200
C   EXPONENTIELLE
40    DO 41 J=1,NDIMA
41    A(J)=EXP(A(J))
	GOTO 200
C   RACINE CARREE
50    DO 51 J=1,NDIMA
51    A(J)=SQRT(A(J))
	GOTO 200
C   SEUIL BAS
60    DO 61 J=1,NDIMA
	IF(A(J).GE.SC)GOTO 61
	A(J)=SC
61    CONTINUE
	GOTO 200
C  SEUIL HAUT
70    DO 71 J=1,NDIMA
	IF(A(J).LT.SC)GOTO 71
	A(J)=SC
71    CONTINUE
	GOTO 200
C   TYPE INCORRECT
80    CALL ERMESF(5)
C   MASQUE BAS
90    CALL DOMASQ(A,NDIMA,SC,0)
	GOTO 201
C   MASQUE HAUT
100   CALL DOMASQ(A,NDIMA,SC,1)
	GOTO 201
C    MODULE
110   DO 111 J=1,NDIMA
111   A(J)=ABS(A(J))
	GOTO 200
C   CARRE
120   DO 121 J=1,NDIMA
121   A(J)=A(J)*A(J)
	GO TO 200
C  SEUIL BAS VARIABLE
 130  DO 131 J=1,NDIMA
	IF(A(J).LT.SC)A(J)=VAL
 131  CONTINUE
	GO TO 200
C  SEUIL HAUT VARIABLE
 140  DO 141 J=1,NDIMA
 141  IF(A(J).GT.SC)A(J)=VAL
200   CALL LPTSET(NFO,PTR)

	CALL ecrflt(NFO,NROW,A)
	RETURN
201   CALL LPTSET(NFO,PTR)
	call ecr(nfo,nrow,a)
	END

