C* SEUIL
	SUBROUTINE SEUIL(A1,A2,A3,NDIM,NF1,SF1,NF2,SF2,NF3,SF3,NLAB)
C (NF1,SF1) EST UNE IMAGE VECTORIELLE DE DIMENSION 8 OU 4 CONTENANT LES
C SORTIES D'OPERATEURS DE DETECTION DE CONTOURS DANS LES 8 OU 4
C DIRECTIONS NORD, NORDOUEST,OUEST,...., NORDEST.
C (NF2,SF2) CONTIENT UN SEUIL EN CHAQUE POINT
C ON ECRIT LA CARTE DES CONTOURS SUR L'IMAGE ENTIERE (NF3,SF3) EN
C COMPARANT LE MAXIMUM DES SORTIES EN UN POINT AU MAXIMUM EN CE POINT.
C SI A3 EST DE DIMENSION N, A2 EST DE DIMENSION 4*N ET A1 DE DIMENSION
C NLAB*4*N.
	DIMENSION NDIM(3),LFMT1(4),LFMT2(4),LFMT3(4)
	DIMENSION A1(1),A2(1),A3(1)
	CALL GETFMG(NF1,SF1,LFMT1)
	CALL GETFMG(NF2,SF2,LFMT2)
	CALL GETFMG(NF3,SF3,LFMT3)
	CALL SETUP(NDIM(2),LFMT2,NROW,IRWRST,NDIMA2)
	IF(NROW.LE.0)CALL ERMESF(8)
	J=LFMT2(2)-IRWRST
1     DO 10 I=1,J,NROW
	CALL LECT(NF1,NROW,A1)
	CALL LECT(NF2,NROW,A2)
	DO 20 K=1,NDIMA2
	IPNT=(K-1)*NLAB+1
	CALL MMX1(A1(IPNT),NLAB,SMIN,IMIN,S,IMAX)
	IF((A2(K)-S))30,40,40
30    A2(K)=1.
	GOTO20
40    A2(K)=0.
20    CONTINUE
	CALL CONVTB(A2,A3,NDIMA2,4,1,1,0)
10    CALL ECR(NF3,NROW,A3)
	IF(IRWRST.EQ.0)GOTO50
	NDIMA2=LFMT2(2)*IRWRST
	NROW=IRWRST
	IRWRST=0
	J=1
	GOTO1
50    CALL LPTSET(NF1,1)
	CALL LPTSET(NF2,1)
	CALL LPTSET(NF3,1)
	RETURN
	END
