C* TRANSP
	SUBROUTINE TRANSP(A,NA1,NFI,SFI,NF,SF)
C  TRANSPOSITION DE L'IMAGE NFI,SFI EN NF,SF
C LA BYTE SIZE PEUT ETRE QUELCONQUE, MAIS LES DIM EN 2**N
C CE SOUS PROGRAMME EFFECTUE LA TRANSPOSITION PLUS RAPIDEMENT
C QUE LE SOUS PROGRAMME TRANSP
	INTEGER A(1),IFMTI(9),IFMT(9)
	INTEGER*2 SFI,SF
	CALL GETFMG(NFI,SFI,IFMTI)
	CALL GETFMG(NF,SF,IFMT)
	IF(ICMPFG(NF,NFI).EQ.2)CALL ERMESF(7)
	ITP=IFMT(4)
	N2=IFMT(1)
	IF(N2.EQ.IFMT(2)) GO TO 101
	CALL ERMESF(2)
101   N=IPOWER(N2)
	K=LIGBIT(IFMT,IBITS)
	IBS=(IBITS+7)/8
	NA=(NA1*4)/(N2*IBS)
	K=IPOW2(NA,JM)
	J2M=2**JM
	IF(JM.GT.0) GO TO 107
	CALL ERMESF(8)
107   IF(J2M.LE.N2)GO TO 111
	JM=N
	J2M=N2
111   DO 108 JQ=1,N2,J2M
	CALL LPTSET(NFI,JQ)
	CALL LECT(NFI,J2M,A)
	IF(ITP.GE.0) GOTO 112
C   UNPACK TABLEAU SI BIT SIZE "PACKED"
	NPT=N2*J2M
	CALL UNPKBT(A,A,NPT,IBITS)
112   DO 110 K=1,JM
	K2=2**K
	K21=K2/2
	INC=K21*N2
	INC2=INC+INC
	K01=1
	DO 106 K1=1,J2M,K2
	K1L1=K01
	DO 104 L1=1,K21
	K1L2=K1L1+INC
	CALL TRANS1(A,A,K1L1,K1L2,IBS,N2,K2)
104   K1L1=K1L1+N2
106   K01=K01+INC2
110   CONTINUE
	CALL LPTSET(NF,JQ)
	IF(ITP.LT.0) CALL PCKBT(A,A,NPT,IBITS)
	CALL ECR(NF,J2M,A)
108   CONTINUE
	NJM=N-JM
	IF(NJM.LE.0) GOTO 199
	JM1=2**(JM-1)
	J2M2=J2M/2
	ISC1=1+(N2*JM1*IBS+3)/4
	DO 1 K=1,NJM
	NJMK=2**(NJM-K)
	K22=2**K
	K23=2**(JM+K)
	K24=K23/2
	NBT=K24*IBS
	DO 2 L=1,NJMK
	DO 3 I=1,K22
	IP1=1+(I-1)*JM1+(L-1)*K23
	IP2=IP1+K24
	CALL LPTSET(NF,IP1)
	CALL LECT(NF,J2M2,A(1))
	CALL LPTSET(NF,IP2)
	CALL LECT(NF,J2M2,A(ISC1))
	IF(ITP.GE.0) GOTO 9
	NPT=J2M2*N2
	CALL UNPKBT(A,A,NPT,IBITS)
	CALL UNPKBT(A(ISC1),A(ISC1),NPT,IBITS)
9     LL2=1
	DO 10 LL=1,JM1
	KKJ=LL2
	DO 12 KK=1,NJMK
	IF(IBS.NE.4) GOTO 13
C  CAS PARTICULIER CODAGE SUR 4 OCTETS
	IA=KKJ+K24
	IB=KKJ+ISC1-1
	DO 11 II=1,K24
	ITE=A(IA)
	A(IA)=A(IB)
	A(IB)=ITE
	IA=IA+1
11    IB=IB+1
	GOTO 12
C  CAS B.S. QUELCONQUE
13    IB=(KKJ-1)*IBS
	IA=(KKJ-1+K24)*IBS
	DO 16 II=1,NBT
	CALL ILBYTE(ITE,A,IA)
	CALL ILBYTE(IT2,A(ISC1),IB)
	CALL ISBYTE(IT2,A,IA)
	CALL ISBYTE(ITE,A(ISC1),IB)
	IA=IA+1
	IB=IB+1
16    CONTINUE
12    KKJ=KKJ+K23
10    LL2=LL2+N2
	IF(ITP.GE.0) GOTO 15
	CALL PCKBT(A,A,NPT,IBITS)
	CALL PCKBT(A(ISC1),A(ISC1),NPT,IBITS)
15    CALL LPTSET(NF,IP1)
	CALL ECR(NF,J2M2,A(1))
	CALL LPTSET(NF,IP2)
	CALL ECR(NF,J2M2,A(ISC1))
3     CONTINUE
2     CONTINUE
1     CONTINUE
199   CALL LPTSET(NF,1)
	RETURN
	END
