C* TRSFVP
	SUBROUTINE TRSFVP(A,NDIM,NF,ISF,NBI,NBO,LFMTI,LFMTO)
C  TRANSFORME DES IMAGES D'UN TYPE DANS UN AUTRE (1 IMAGE A 1 PLAN DE
C   VECTEURS A N COMPOSANTES, 1 IMAGE DE N PLANS SCALAIRES, N IMAGES
C   SCALAIRES A 1 PLAN)
C  A : TABLEAU DE TRAVAIL DE NDIM MOTS
C  NF,ISF : TABLES DES IDENTIFICATEURS DES NBI IMAGES D'ENTREE
C   ET DES NBO IMAGES DE SORTIE (FORMATS LFMTI ET LFMTO)
	INTEGER A(1),LFMTI(9),LFMTO(9)
	INTEGER*8 NF(1)
	INTEGER*2 ISF(1)
	NVI=LFMTI(7)
	NZI=LFMTI(8)
	NVO=LFMTO(7)
	NZO=LFMTO(8)
	IF(NZI.GT.1.AND.NZO.GT.1) GOTO 999
	IF(NVI.GT.1.AND.NVO.GT.1) GOTO 999
	IF(NBI.GT.1.AND.NBO.GT.1) GOTO 999
	NDIMX=LFMTI(5)
	NDIMY=LFMTI(6)
	IY=1
	NBITS=-LFMTI(3)
	IF(NBITS.LT.0) GOTO 2
	IF(LFMTI(4).LT.0) GOTO 3
	NBITS=8*((NBITS+7)/8)
	GOTO 3
2     NBITS=-8*NBITS
3     NV=NVI
	IF(NVO.GT.1) NV=NVO
	LGLZ=NBITS*LFMTI(5)
C  INDICES TABLEAUX ENTREE ET SORTIE
	KI=1
	KO=1
	IF(NV.EQ.1) GOTO 100
C  CAS D'IMAGES VECTORIELLES : COUPER A EN 2 PARTIES
	LGLV=LGLZ*NV
	IF(NVI.GT.1) GOTO 5
	NZ=NZI
	IF(NZ.LE.1) NZ=NBI
	GOTO 6
5     NZ=NZO
	IF(NZ.LE.1) NZ=NBO
6     NROW=32*NDIM/(LGLV+LGLZ)
	IF(NROW.LE.NDIMY) GOTO 20
C  CAS OU TOUTE L'IMAGE VECT. PEUT TENIR EN MEMOIRE
	NROW=NDIMY
	K=(NROW*LGLV+31)/32+1
	NDIM2=NDIM-K+1
	NPL2=NDIM2/((NROW*LGLZ+31)/32)
	IF(NPL2.GT.NZ) NPL2=NZ
	GOTO 25
20    IF(((NROW*LGLV+31)/32+(NROW*LGLZ+31)/32).GT.NDIM) NROW=NROW-1
	IF(NROW.LE.0) CALL ERMESF(8)
	K=(NROW*LGLV+31)/32+1
	NPL2=1
25    NCP2=NZ/NPL2
	NRST2=NZ-NCP2*NPL2
	NCOUP=NDIMY/NROW
	NREST=NDIMY-NROW*NCOUP
	IF(NVI.EQ.1) GOTO 26
	KO=K
	GOTO 300
26    KI=K
C
C   BOUCLE DE TRANSFORMATION POUR ENTREE OU SORTIE VECT.
300   CONTINUE
	DO 600 ICOUP=1,NCOUP
	KM=(LGLZ*NROW+31)/32
	IZ=1
	IF(NVI.GT.1) GOTO 390
C  ENTREES NON VECTORIELLES
	K=1
	II=1
	NCPZ=NCP2
	NRSTZ=NRST2
	NPLZ=NPL2
310   DO 360 ICP=1,NCPZ
	IF(NBI.EQ.1) GOTO 330
C  ENTREE SUR N FICHIERS
	KA=KI
	DO 320 KK=1,NPLZ
	CALL LECT(NF(K),NROW,A(KA))
	K=K+1
320   KA=KA+KM
	GOTO 340
C  LECTURE N PLANS D'UNE IMAGE POUR SORTIE VECT.
330   CALL LECNPL(NF,ISF,LFMTI,IY,IZ,NPLZ,NROW,A(KI))
	IZ=IZ+NPLZ
C  TRANSFORMATION TABLEAU POUR PASSAGE N PLANS A 1 VECT.
340   KA=KI
	NPT=NDIMX*NROW
	DO 350 KK=1,NPLZ
	CALL TBP1TV(A(KA),A(KO),II,NVO,NPT,NBITS)
	KA=KA+KM
350   II=II+1
360   CONTINUE
	IF(NRSTZ.EQ.0) GOTO 380
	NPLZ=NRSTZ
	NRSTZ=0
	NCPZ=1
	GOTO 310
C  SORTIE IMAGE VECT
380   K=NBI+1
	CALL ECR(NF(K),NROW,A(KO))
	GOTO 600
C  ENTREE VECT.
390   CALL LECT(NF,NROW,A(KI))
C  SORTIE N PLANS OU N FICHIERS POUR ENTREE VECT.
	K=NBI+1
	NCPZ=NCP2
	NRSTZ=NRST2
	NPLZ=NPL2
	II=1
	NPT=NDIMX*NROW
445   DO 480 ICP=1,NCPZ
	IF(NVI.EQ.1) GOTO 460
C  TRAITEMENT POUR ENTREE VECT.
	KA=KO
	DO 450 KK=1,NPLZ
	CALL TBVTP1(A(KI),A(KA),II,NVI,NPT,NBITS)
	II=II+1
450   KA=KA+KM
	IF(NBO.GT.1) GOTO 460
C   SORTIE N PLANS POUR ENTREE VECT
	CALL ECRNPL(NF(K),ISF(K),LFMTO,IY,IZ,NPLZ,NROW,A(KO))
	IZ=IZ+NPLZ
	GOTO 480
C  SORTIE N FICHIERS
460   KA=KO
	DO 470 KK=1,NPLZ
	CALL ECR(NF(K),NROW,A(KA))
	KA=KA+KM
470   K=K+1
480   CONTINUE
	IF(NRSTZ.EQ.0) GOTO 600
	NPLZ=NRSTZ
	NRSTZ=0
	NCPZ=1
	GOTO 445
600   IY=IY+NROW
	IF(NREST.EQ.0) RETURN
	NROW=NREST
	NREST=0
	NCOUP=1
	GOTO 300
999   CALL MESERR('ENTREE ET SORTIE SONT DE MEME TYPE! $',9)
C  NZ, ZN  PASSAGE DE N PLANS A N FICHIERS ET INVERSEMENT
100   NZ=NBI
	IF(NZ.EQ.1) GOTO 101
	J0=1
	GOTO 102
101   J0=2
	NZ=NBO
102   NROW=NDIM*32/LGLZ
	IF(NROW.LE.NDIMY) GOTO 110
	NPL2=NROW/NDIMY
	IF(NPL2.GT.NZ) NPL2=NZ
	NROW=NDIMY
	GOTO 115
110   NPL2=1
115   NCOUP=NDIMY/NROW
	NREST=NDIMY-NCOUP*NROW
	NCP2=NZ/NPL2
	NRST2=NZ-NPL2*NCP2
	IZ=1
120   DO 800 ICP=1,NCP2
	NCP=NCOUP
	NRW=NROW
	NRST=NREST
	IY=1
130   DO 750 ICOUP=1,NCP
	KM=(LGLZ*NRW+31)/32
	IF(NBI.GT.1) GOTO 710
C  ENTREE PLANS, SORTIE N FICHIERS
	CALL LECNPL(NF,ISF,LFMTI,IY,IZ,NPL2,NRW,A)
	KA=KO
	K=J0
	DO 705 KK=1,NPL2
	CALL ECR(NF(K),NRW,A(KA))
	KA=KA+KM
705   K=K+1
	GOTO 750
C  SORTIE SUR N PLANS D'1 IMAGE POUR ENTREE N FICHIERS
710   KA=KI
	K=J0
	DO 720 KK=1,NPL2
	CALL LECT(NF(K),NRW,A(KA))
	KA=KA+KM
720   K=K+1
	K2=NBI+1
	CALL ECRNPL(NF(K2),ISF(K2),LFMTO,IY,IZ,NPL2,NRW,A)
750   IY=IY+NRW
	IF(NRST.EQ.0) GOTO 780
	NCP=1
	NRW=NRST
	NRST=0
	GOTO 130
780   J0=J0+NPL2
800   IZ=IZ+NPL2
	IF(NRST2.EQ.0) RETURN
	NCP2=1
	NPL2=NRST2
	NRST2=0
	GOTO 120
	END
