/*
	subroutine imotpr(ix,iy,ia,i,ic)
c    subroutine calculant les octets a envoyer a la
c    tektro pour trace avec la pleine resolution
c    ix,iy coordonnees du point a tracer
c    ia tableau ou sont ranges les octets a envoyer
c    i indice (>=1) dans ia pour le debut du rangement
c    en sortie i est egal a l'indice du premier octet de ia non utilise
c    ic  0:premier trace 1:traces suivants on utilise
c    le point precedant pour d'eventuelles simplifications

version c : int c_cnvtek(ix,iy,buf,ic) :
	buf = adr de rangement
	ic =0 si 1er trace, 1 sinon
	renvoie le nb de char ecrits.
*/

#include <stdio.h>
#include <inrimage/image.h>

static int iyh,iyha,ixh,ixha,iyl,ixl,ieb;
static short jh=0x20,jlx=0x40, jly= 0x60;

imotpr_(x,y,ia,i0,icc)
Fort_int *x, *y, *i0, *icc;
char *ia;
{
	*i0 += c_cnvtek((int)*x,(int)*y,ia+ (int)*i0 -1,(int)*icc);
}

c_cnvtek(ix,iy,p,ic)
register int ix, iy, ic;
register char *p;
{
register int icas;
	icas=1;
	if(ix < 0 || ix > 4095) goto er11;
	if(iy < 0 || iy > 4095) goto er11;
	iyh = iy >> 7;
	ixh = ix >> 7;
	iyl = (iy >> 2) & 0x1f;
	ixl = (ix >> 2) & 0x1f;
	ieb = ((iy << 2) & 0xc) | (ix & 3);
	if(ic != 0) {
		if(iyh == iyha) icas= 2;
		if(ixh == ixha) icas= icas +2;
	}
	switch (icas) {
/*  hx et hy doivent etre envoyes */
	case 1:
		*p++ = jh + iyh;
		*p++ = jly + ieb;
		*p++ = jly + iyl;
		*p++ = jh + ixh;
		*p++ = jlx + ixl;
		iyha=iyh;
		ixha=ixh;
		return 5;
	/*  seul hx est envoye */
	case 2 :
		*p++ = jly + ieb;
		*p++ = jly+iyl;
		*p++ = jh+ixh;
		*p++ = jlx+ixl;
		ixha=ixh;
		return 4;
	/*  seul hy est envoye */
	case 3:
		*p++ = jh+iyh;
		*p++ = jly+ieb;
		*p++ = jly+iyl;
		*p++ = jlx+ixl;
		iyha=iyh;
		return 4;
	/*   hx et hy ne sont pas envoyes */
	case 4:
		*p++ = jly+ieb;
		*p++ = jly+iyl;
		*p++ = jlx+ixl;
		return 3;
	}
 er11:		fprintf(stderr,"warning: point tektro hors limites\n");
	return 0;
}
