#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>

extern FILE *inr_PSFILE;

/* n = nb de pages, 0 si indefini 
xymin[2] : x et y min
xymax[2] : x et y max
*/
ps_prologue(nbp,xymin,xymax)
register nbp;
int *xymin, *xymax;
{
	ps_creator();
	fprintf(inr_PSFILE,"%%%%BoundingBox: %d %d %d %d\n",xymin[0],xymin[1],xymax[0],xymax[1]);
	if(nbp > 0)
		fprintf(inr_PSFILE,"%%%%Pages: %d %d\n",nbp,nbp);
	else
		fprintf(inr_PSFILE,"%%%%Pages: ?? ??\n");
	fprintf(inr_PSFILE,"%%%%EndComments\n");
	fprintf(inr_PSFILE,"gsave\n");
	fprintf(inr_PSFILE,"%%%%EndProlog\n");
}

ps_creator()
{
	char buff[255];
	register n, i;
	register char *p, *out;
	strcpy(buff,inr_basename(xargv[0]));
	n = strlen(buff);
	out = buff + n;
	*out++ = ' ';
	n = 254 - n;
	for(i=1;i<xargc;i++) {
		if((p = xargv[i]) != (char *)0) {
			while(*p != 0) {
				*out++ = *p++;
				if(n-- <= 0) break;
			}
			if(n <= 0) break;
			*out++ = ' ';
		}
	}
	*out = 0;
	fprintf(inr_PSFILE,"%%!PS-Adobe-2.0\n%%%%Creator: %s\n",buff);
}
