/*T4VABS
	SUBROUTINE T4VABS(IX,IY,ITRAC)
C  ENVOI LS COORDONNEE IX,IY (NBS ENTIERS ENTRE 0 ET 4095)
C  ITRAC<1 1ER POINT (SANS TRACE), ITRAC=1 POINT COURANT
C   ITRAC>1 DERNIER POINT
	c_t4vabs(ix,iy,itrac)
	int ix, iy, itrac;
*/
#include <inrimage/image.h>
extern struct tktrnx tktrnx_;
static char ps_first= 0;
static int ps_ix, ps_iy, ps_lgpath= 0;

#define MAXPATH 200

void c_t4vabs();

t4vabs_(x,y,trac)
Fort_int *x, *y, *trac;
{
	c_t4vabs((int)*x,(int)*y,(int)*trac);
}

static char a[8];
static char igs= 0x1d;	/* GS */
void c_t4vabs(ix,iy,itrac)
register int ix, iy, itrac;
{
	register int ic, n;
	register char *pc;
	if(tktrnx_.tk_psmode) {  /* mode PostScript */
		if(tktrnx_.tk_text) {
			ps_endtext(0);
			tktrnx_.tk_text = 0;
		}
		tktrnx_.tk_lastpos[0] = ix;
		tktrnx_.tk_lastpos[1] = iy;
		if(itrac < 1) {  /* 1e point */
			if(tktrnx_.tk_path) {
				tktrnx_.tk_path = 0;
				ps_endpath(0);
			}
			ps_lgpath = 0;
			ps_first = 1;
			ps_ix = ix;
			ps_iy = iy;
		} else {
			tktrnx_.tk_page = 1;		    
			tktrnx_.tk_path = 1;
			if (ps_first) {
				printf("newpath %d %d moveto\n",ps_ix,ps_iy);
				ps_first = 0;
			}
			ps_lgpath++;
			printf(" %d %d lineto",ix,iy);
			if(itrac > 1) { /* dernier point */
				printf(" stroke\n");
				ps_lgpath = 0;
			} else if(ps_lgpath >= MAXPATH) {  /* forcer end of path */
				printf(" stroke\n");
				c_t4vabs(ix,iy,0);  /* reinjecter comme 1e point */
			}
		}
		return;
	}
	/* mode Tektro normal */
	ic=1;
	if(itrac < 1) { /* 1er point */
		ic = 0;
		c_t4send(&igs,1);
	}
	if(tktrnx_.tksize <= 0) {
		n = c_cnvtek(ix,iy,a,ic);
		c_t4es(a,n,1);
		return;
	}
	if(tktrnx_.tkoff > tktrnx_.tksize - 5) t4dspl_();
	pc = tktrnx_.tkbuf + tktrnx_.tkoff;
	n = c_cnvtek(ix,iy,pc,ic);
	tktrnx_.tkoff += n;
	if(itrac > 1 ) t4dspl_();
}
