/* table des mots cles reserves pour le header */
#include <inrimage/inrfile.h>

struct  hdr_keys hdr_keys[HDR_NB_KEYS] = {0};

init_hdrkeys()
{
	if(hdr_keys[0].key_length != 0) return 1 /* makes c99 happy */; 
	hdr_keys[IS_NDIMX].key = S_NDIMX;
	hdr_keys[IS_NDIMX].key_length = sizeof(S_NDIMX) -1;
	hdr_keys[IS_NDIMY].key = S_NDIMY;
	hdr_keys[IS_NDIMY].key_length = sizeof(S_NDIMY) -1;
	hdr_keys[IS_NDIMZ].key = S_NDIMZ;
	hdr_keys[IS_NDIMZ].key_length = sizeof(S_NDIMZ) -1;
	hdr_keys[IS_NDIMV].key = S_NDIMV;
	hdr_keys[IS_NDIMV].key_length = sizeof(S_NDIMV) -1;
	hdr_keys[IS_TYPE].key = S_TYPE;
	hdr_keys[IS_TYPE].key_length = sizeof(S_TYPE) -1;
	hdr_keys[IS_TYPE].key_type = K_STRING;
	hdr_keys[IS_BSIZE].key = S_BSIZE;
	hdr_keys[IS_BSIZE].key_length = sizeof(S_BSIZE) -1;
	hdr_keys[IS_BSIZE].key_type = K_STRING;
	hdr_keys[IS_SCALE].key = S_SCALE;
	hdr_keys[IS_SCALE].key_length = sizeof(S_SCALE) -1;
	hdr_keys[IS_SCALE].key_type = K_STRING;
	hdr_keys[IS_CPU].key = S_CPU;
	hdr_keys[IS_CPU].key_length = sizeof(S_CPU) -1;
	hdr_keys[IS_CPU].key_type = K_STRING;
	hdr_keys[IS_BIAS].key = S_BIAS;
	hdr_keys[IS_BIAS].key_length = sizeof(S_BIAS) -1;
	hdr_keys[IS_BIAS].key_type = K_STRING;
	hdr_keys[IS_XOFF].key = S_XOFF;
	hdr_keys[IS_XOFF].key_length = sizeof(S_XOFF) -1;
	hdr_keys[IS_YOFF].key = S_YOFF;
	hdr_keys[IS_YOFF].key_length = sizeof(S_YOFF) -1;
	hdr_keys[IS_ZOFF].key = S_ZOFF;
	hdr_keys[IS_ZOFF].key_length = sizeof(S_ZOFF) -1;
	hdr_keys[IS_MAILLE].key = S_MAILLE;
	hdr_keys[IS_MAILLE].key_length = sizeof(S_MAILLE) -1;
	hdr_keys[IS_MAILLE].key_type = K_STRING;
	hdr_keys[IS_HEADER].key = S_HEADER;
	hdr_keys[IS_HEADER].key_length = sizeof(S_HEADER) -1;
	hdr_keys[IS_HEADER].key_val = (long)"";
	hdr_keys[IS_HEADER].key_type = K_STRING;
	hdr_keys[IS_END].key = S_END;
	hdr_keys[IS_END].key_length = sizeof(S_END) -1;
	hdr_keys[IS_END	].key_val = (long)"";
	hdr_keys[IS_END	].key_type = K_STRING;
	hdr_keys[IS_HISTORY].key = S_HISTORY;
	hdr_keys[IS_HISTORY].key_length = sizeof(S_HISTORY) -1;
}

/* test si un mot cle est dans la table 
retourne -1 si non trouvee, le numero sinon
*/

tst_hdrkey(strg)
register char *strg;
{
	register struct hdr_keys *pk;
	register n;
	init_hdrkeys();
	pk = hdr_keys;
	for(n=0;n<HDR_NB_KEYS;n++) {
		if(strncmp(pk->key,strg,pk->key_length) == 0)
			return n;
		pk++;
	}
	return -1;
}

chk_hdrkey(p)
register char **p;
{
	register i, n;
	for(i=0;i<HDR_NB_MIN;i++) {
		if(hdr_keys[i].key_val != 0) continue;
		if((n = chkword(hdr_keys[i].key,*p)) > 0) {
			*p += n;
			return i;
		}
	}
	return -1;
}
