/*
C* IANCMD
	FUNCTION IANCMD(ICMD,IBUF,NCH,NC,IDB)
	int iancmd(icmd,ibuf,nch,idb)
	int chk_cmd(cmd,ibuf,idbcmd)
	struct cmdtab *cmd;char *ibuf; char *idbcmd;
 recherche si la chaine de NCH car. contenue dans ibuf correspond
 a une cmde de ICMD (chaine ibuf terminee par 0 pour chk_cmd)
 iancmd=nc =0 si cmde non reconnue, sinon = num. cmde
   renvoie idb=indice (>=0) du caract. suivant dans icmd (IANCMD)

 chk_cmd : cmd est de type struct cmdtab.
   retour:
 	idbcmd pointe vers le car suivant de la cmde trouvee
	valeur de la fonction : contenu de ret_val de cmd, ou numero
		de la commande (>= 1) si ce contenu est nul

*/

#include <inrimage/image.h>
#include <inrimage/dialog.h>
#include <ctype.h>
#include <string.h>

int iancmd_(icmd,ibuf,nch,nc,idb)
register CHAR *icmd, *ibuf;
register Fort_int *nch, *nc, *idb;
{
	CHAR *idbcmd;
	*nc = find_cmd(0,icmd,ibuf,(int)*nch,&idbcmd);
	*idb = (unsigned long)idbcmd - (unsigned long)icmd;
	return *nc;
}

int chk_cmd(cmd,ibuf,idbcmd)
register CHAR *ibuf, **idbcmd;
register struct cmdtab *cmd;
{
	return find_cmd(1,(CHAR *)cmd,ibuf,strlen(ibuf),idbcmd);
}

/* opt =0 si cmd de type Fortran, 1 si de type struct cmdtab */
int find_cmd(opt,cmd,ibuf,nch,idbcmd)
CHAR *cmd;
CHAR *ibuf;
register int nch;
CHAR **idbcmd;
int opt;
{
	register nc, i;
	register unsigned char *pb, *pc;
	register struct cmdtab *pcm;
	int ist;
	nc = 1;
/* convertir buffer en minuscules */
	pb = ibuf;
	for(i=0;i<nch;i++) {
		if(isupper(*pb))
			*pb |= 0x20;
		if(*pb == 0) break;
		pb++;
	}
	nch = i;  /* vrai nb de car. */
	if(opt > 0) {
		pcm = (struct cmdtab *) cmd;
		if((pc = (unsigned char *)pcm->cmd) == 0) return 0;
		ist = pcm->ret_val != 0 ? pcm->ret_val : nc;
	} else {
		ist = nc;
		pc = cmd;
	}
	while(1) {
		pb = ibuf;
		i = nch;
		while(i > 0) {
			if(*pb++ != *pc) break;
			i--;
			if(*pc == 0 || *pc == 255)
				if(i == 0) {
					*idbcmd = pc;
					return ist;
				}
			pc++;
		}
		/* chercher fin cmde */
		*idbcmd = pc;
		nc++;
		while (1) {
			if(*pc == 255 || *pc == 0) break;
			pc++;
		}
		if(opt > 0) {
			if(i == 0) {
				/* matched : check if nb min. satisfied */
				if(nch >= pcm->nbmin) return ist;
			}
			pcm++;
			if((pc = (unsigned char *)pcm->cmd) == (CHAR *)0) return 0;
			ist = pcm->ret_val != 0 ? pcm->ret_val : nc;
		} else {
			pc++;
			if(i == 0) {
				/* matched : check if nb min. satisfied */
				if(nch >= (int)*pc) return ist;
			}
			if(*(pc-1) == 255) return 0;
			ist = nc;
			pc++;
		}
	}
}
