/* IDONNE
	SUBROUTINE IDONNE(CHAIN,I0,I2,I,IER)
	int c_idonne(chain,i0,i2,ier)
 decode la chaine de caracteres contenue dans chain des indices
 i0 a i2 sous forme de nb entier, en forme decimale ou hexa (si commence par 0x apres le signe) 
 ier=0 si ok, nb de car. non traites sinon
 resultat dans I pour IDONNE, en valeur de fonction pour c_idonne
  i0 et i2 comptes a partir de 1 pour IDONNE (Fortran) de 0 pour c_idonne
*/

#include <ctype.h>
#include <inrimage/image.h>

idonne_(chain,i0,i2,i,ier)
register char *chain;
register Fort_int *i0, *i2, *i, *ier;
{
	*i = c_idonne(chain,(int)(*i0-1),(int)(*i2-1),ier);
}

c_idonne(chain,i0,i2,ier)
register char *chain;
register i0, i2;
Fort_int *ier;
{
	register i, s, c;
	register char *pend;
	char *p0;
	i = 0;
	*ier = 0;
	chain += i0;
	p0 = chain;
	c = *chain;
	s = 0;
	if(c == '-') {
		s = -1;
		chain++;
		i0++;
	} else if(c == '+') {
		chain++;
		i0++;
	}
	if(i0 > i2 || i0 < 0) return 0;
	pend = chain + (i2 - i0);
	if((i2 -i0) >= 1 &&
	   (*chain == '0') && ((*(chain+1) | 0x20) == 'x')) {
		   i = c_hxdonn(chain+2,i0+2,i2,ier);
	} else {
		while (chain <= pend) {
			if((c = *chain++) == 0) break;
			if(!isdigit(c)) {
				*ier = (unsigned long)chain - (unsigned long) p0;
				return i;
			}
			i = (10 * i) + (c & 0xf);
		}
	}
	if(s < 0)
		return -i;
	return i;
}
		
