/* test accessibilite et longueur d'un fichier
   renvoie -1 si inaccessible, longueur sinon
   Attention:
     1 si "<"
     -1 si ">"
   */

#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>

long ifsize_(path)
char *path;
{
  register int fd;
  register off_t n;
	if(*(path +1) == 0) {
		if(*path == '<') return 1;  /* dummy length */
		if(*path == '>') return -1;
	}
#if 0
 else if(*path == '<' && *(path+2) == 0)
		return 1;  /* dummy length : input is zcat output */
#endif
	if((fd = open(path,0)) < 0) return -1;
	n = lseek(fd,(off_t)0,SEEK_END);
	close(fd);
	return (long)n;
}
