/*
C*INTCHK
	FUNCTION INTCHK(ICRLF,TEXT,I1,I2)
	INTEGER TEXT(1)
	int c_intchk(icrlf,text,i1,i2)
	int icrlf,i1,i2; char *text;

imprime le message text sur stderr, precede de '\n' si icrlf == 0
et lit un entier sur stdin, et ne l'accepte que s'il est >= i1 et <= i2
En cas d'erreur : boucle si stdin est une tty, imerror sinon
*/

#include <inrimage/image.h>
#include <inrimage/dialog.h>
extern struct codcar codcar_;

Fort_int intchk_(icrlf,text,i1,i2)
Fort_int *icrlf, *i1, *i2;
char *text;
{
	return (Fort_int)c_intchk((int)*icrlf,text,(int)*i1,(int)*i2);
}

static char id[]= "? ";
int c_intchk(icrlf,text,i1,i2)
int icrlf;
register int i1, i2;
char *text;
{
	register i;
	Fort_int niv;
	id[1] = codcar_.ibell;
	if(i1 > i2)
		imerror(9,"intchk: bornes inversees!\n");
	while(1) {
		i = c_intget(icrlf,text);
		if(i >= i1 && i <= i2)
			return i;
		if(nivmac_(&niv) > 0)
			imerror(9,"intchk: donnee hors des bornes!\n");
		c_outstr(0,id);
	}
}
