/*
C*DOIMRW
$PROG DOIMRW
	INTEGER FUNCTION DOIMRW(ISENS,LU,ITYP,IRAND,IBUF,NBYT,NBLU,IST)
	INTEGER ISENS(1),LU(1),IRAND(1),NBYT(1),NBLU(1),IST(1)
	INTEGER IBUF(1),ITYP(1)
C ECRITURE (ISENS=1) OU LECTURE (ISENS NON 1) SUR U.L. LU
C  DE NBYT OCTETS DU BUFFER IBUF SUR le secteur isec ( 1 secteur = 256 bytes )
C  (A PARTIR DE LA POSITION COURANTE SI IRAND<0)
C  FORMAT "ASCII" SI ITYP=0 , "IMAGE" SI NON 0
C RENVOIE DANS NBLU LE NB D'OCTETS EFFECTIFS ET DANS IST
C LE STATUS SVC 1 ; DOIMRW VAUT IST
*/

#include <stdio.h>
#include <inrimage/image.h>

extern debug_;

doimrw_(isens,nf,ityp,nsec,ibuf,nbyt,nblu,ist)
int *isens,*ityp,*nsec,*nbyt,*nblu,*ist;
char *ibuf;
struct image **nf;
{
	long lseek();
	long offset;

	offset = *nsec * 256 ;

   if ( *isens == 1 )
	{			/* ecriture */

	if ( *nsec < 0 )
		{
		/* ecriture sequentielle */
		if ( debug_ ) fprintf(stderr,"%s doimrwd:ecriture sequentielle ",xargv[0]);
		*nblu = write((*nf)->fd,ibuf,*nbyt);
		(*nf)->byte_pnt += *nblu ;
		}
	else	{
		/* ecriture random */

		if ( (*nf)->byte_pnt != offset )
			{
			if ( debug_ ) 
				fprintf(stderr,"%s doimrw:ecriture random ",xargv[0]);

			/* on ne fait que les lseek necessaires */
			if ( ((*nf)->byte_pnt =
				lseek((*nf)->fd,offset,0)) == -1 )
				{
				perror("doimrw");
				return(-1);
				}
			}
		else	if ( debug_ )
				fprintf(stderr,"%s doimrw:ecriture random seq. ",xargv[0]);

		*nblu = write((*nf)->fd,ibuf,*nbyt);
		(*nf)->byte_pnt += *nblu ;
		}

	if ( debug_ ) fprintf(stderr,"%s sur %s nsec=%d nbyt=%d nblu=%d\n",xargv[0],
				(*nf)->nom,*nsec,*nbyt,*nblu);

	if ( *nblu <= 0 ) perror("doimrw");

	return ( *ist = ( *nblu <= 0 ? -1 : 0 ) );

	}

   else
	{			/* lecture */

	if ( *nsec < 0 ) 
		{
		/* lecture sequentielle */
		if ( debug_ ) fprintf(stderr,"%s doimrw:lecture sequentielle ",xargv[0]);
		*nblu = read((*nf)->fd,ibuf,*nbyt);
		(*nf)->byte_pnt += *nblu ;
		}
	else	{
		/* lecture random */
		if ( (*nf)->byte_pnt != offset )
			{
			if ( debug_ ) fprintf(stderr,"%s doimrw:lecture random ",xargv[0]);

			/* on ne fait que les lseek necessaires */
			if ( ((*nf)->byte_pnt =
				lseek((*nf)->fd,offset,0)) == -1 )
				{
				perror("doimrw");
				return(-1);
				}
			}
		else	if (debug_) 
				fprintf(stderr,"%s doimrw:lecture random seq.",xargv[0]);

		*nblu = read((*nf)->fd,ibuf,*nbyt);
		(*nf)->byte_pnt += *nblu ;
		}

	if ( debug_ ) fprintf(stderr,"%s sur %s nsec=%d nbyt=%d nblu=%d\n",xargv[0],
				(*nf)->nom,*nsec,*nbyt,*nblu,*ist);

	if ( *nblu <= 0 ) perror("doimrw");

	return ( *ist = ( *nblu < 0 ? -1 : 0 ) );
	}

}
