C*RDBINR
      SUBROUTINE RDBINR(LU,ITAB,I0,N,IBS,IBUF)
C  LECTURE BINAIRE : A PARTIR DU FICHIER ASSIGNE A L'UNITE
C LOGIQUE LU, ON REMPLIT LE TABLEAU ITAB, A PARTIR DE L'ELEMENT I0,
C  AVEC N ELEMENTS DE IBS OCTETS CHACUN
C  (IBS=1 POUR CARACTERES, 2 POUR INTEGER*2, 4 POUR INTEGER OU
C   REELS SIMPLE PRECISION, 8 POUR DOUBLE PRECISION, PAR EXEMPLE).
C   IBUF EST UN TABLEAU DE TRAVAIL : LE PREMIER MOT DOIT CONTENIR
C   LA TAILLE DE LA LIGNE DU FICHIER EN OCTETS, LE 2EME EST LE
C   POINTEUR DANS LA LIGNE ET DOIT OBLIGATOIREMENT ETRE INITIALISE
C   A 0 AVANT LA PREMIERE LECTURE SUR LE FICHIER. LES MOTS SUIVANTS
C   SERVIRONT A STOCKER UNE LIGNE DU FICHIER. LA DIMENSION
C   DE IBUF DOIT ETRE AU MOINS (LREC+3)/4+2 SI LREC EST LE NB D'OCTETS
C  PAR LIGNE.
C
      INTEGER ITAB(1),IBUF(3),RANDRD
      DATA NPROG/163/
      IF(N.LE.0) RETURN
      NN=N*IBS
      LGL=IBUF(1)
      IPT=IBUF(2)
      I1=(I0-1)*IBS+1
      IF(IPT.LE.0) GOTO 20
10    N1=NN
      IF(N1.GT.(LGL-IPT+1)) N1=LGL-IPT+1
      CALL MVBYTE(IBUF(3),ITAB,IPT,I1,N1)
      NN=NN-N1
      IF(NN.LE.0) GOTO 30
      I1=I1+N1
20    IF(RANDRD(LU,-1,IBUF(3),LGL,NBL,IS2).NE.0) GOTO 101
      IF(NBL.NE.LGL) GOTO 111
      IPT=1
      GOTO 10
30    IPT=IPT+N1
      IBUF(2)=IPT
      RETURN
101   IS1=1+100*NPROG
      CALL ERMESS(IS1,IS2)
111   CALL MESERR('LONGUEUR DE LIGNE NON CONFORME $',9)
      END
