# Inrimage RPM specification
# (c) 1990-2009 INRIA

Name: inrimage
Version: 4.6.8

Release: static_R1
Summary: image processing tools
Group: Applications/inria
License: GPL
Distribution: INRIA
Source0: %{name}-%{version}.tar.gz
BuildRoot: %{_builddir}/%{name}-root

# TODO : utiliser _sourcedir _rpmdir
%define prefix  /usr/local

%description
Inrimage is a software developped at INRIA (http://www.inria.fr) and providing
libraries (C, C++ and Fortran) and commands for image processing. Inrimage
deals with its own image format allowing mathematic processing but it can
read standard formats (RAS,PNG,JPEG,JPEG2000,TIFF,NETPBM,GIF) or export to
these formats. Language is currently french.
Official site is http://inrimage.gforge.inria.fr.

%prep
%setup -q

%build
./configure --disable-build-fonts # LDFLAGS="-static-libgcc -static"
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{prefix}/bin
%{prefix}/include
%{prefix}/lib
#%{prefix}/man
%{prefix}/share

%changelog

