#include <inrimage/image.h>
#include <stdio.h>


static char Ucmd[]=
"image1-in image2-in [image-out]";
static char Udetail[]=
"\tsi 'image1-in' ou 'image2-in' est '-', on prendra stdin\n\
\tsi 'image-out' est absent on ecrira sur stdout\n\
\tcette commande est une variante de 'arit2'";

extern debug_;

/* le meme executable est appele avec differents noms
(liens sur le meme fichier */

static struct multi_cmd cmds[] = {
	"ad",Ucmd,Udetail,	/*  1 */
	"so",Ucmd,Udetail,	/*  2 */
	"mu",Ucmd,Udetail,	/*  3 */
	"di",Ucmd,Udetail,	/*  4 */
	"min",Ucmd,Udetail,	/*  5 */
	"max",Ucmd,Udetail,	/*  6 */
	0,0,0,
};

extern int inr_initm();

fcmain_()
{

	char in1[128],in2[128],out[128];
	Fort_int choix;
	register i1, i2;

	/* initialiser et determiner quel nom de commande est utilise */
	choix = inr_initm(0,0,"2.1",cmds);  /* valeur entre 0 et 5 */

	if ( debug_ ) printf("fonction %s\n",cmds[choix].name);

	/* get 2 input files */
	i1 = infileopt(in1);
	i2 = infileopt(in2);
	/* only one file may be stdin */
	if((i1 == 0) && (i2 == 0)) 
		imerror(9,"2 images d'entree obligatoires\n");

	/* output file */
	outfileopt(out);

	if(tstopts())
		iusage_(Ucmd,Udetail);

	choix++;

	sarit2_(&choix,in1,in2,out);
	return 0;

}


