#include <stdio.h>
#include <inrimage/image.h>
#include <inrimage/error.h>
#include <inrimage/contour.h>

/*extern int c_iask(), c_irctgp(), c_intget(), c_intchk(); */
extern struct fc_cont *open_ct();
extern int vischn_();

static Fort_int flg_closed, numax, nbct;
static Fort_int inums[2], xydim[2];
static Fort_int isens, ismmx[2], point[2], flg_vis, xv_val[2], num_env;
#define LGFIL 256
static char nomold[LGFIL];
kviscn_()
{
#ifndef NONINTERACTIF
	char nom[LGFIL];
	struct fc_cont *ct_in;
	char list_cont[32];
	int ier;
	Fort_int ierr;
	Fort_int zero= 0, n, ndimv;
	c_erreur(ier);
	if(ier == 0) {
		flg_closed = (Fort_int)(2 - c_iask(0,"contours fermes ? "));
		c_getnom(0,"fichiers contours ",nom,nomold,LGFIL);
		ct_in = open_ct(nom,xydim,&numax,&nbct);
	}
	while(1) {
		c_intch(0,"1er, dern. contour ",1,2,inums);
		if(inums[0] <= 0) inums[0] = 1;
		if(inums[1] < inums[0]) inums[1] = inums[0];
		sprintf(list_cont,"%ld-%ld",inums[0],inums[1]);
		isens = (Fort_int) c_intget(0,"sens demande (-1,1 ou 0) ");
		num_env = (Fort_int) c_intget(0,"num enveloppe ");
		ismmx[0] = 0;
		ismmx[1] = 0x7fffffff;
		point[0] = -1;
		point[1] = -1;
		if(c_iask(0,"test sur surf. ? ") == 1) {
			c_intch(0,"surf min, max ",1,2,ismmx);
		}
		flg_vis = (Fort_int)c_intchk(1,"trace: 0,1 tek,2 xvis ",0,2);
		if(flg_vis == 2)
			c_intch(0,"val pour trace pos et neg ",1,2,xv_val);
		if(flg_vis == 1)
			asstek_();
		n = 1;
		ndimv = 1;
		exec_(&ierr,&zero,&zero,&n,&ndimv,vischn_,&ct_in,&numax,&flg_vis,&flg_closed,&isens,&num_env,ismmx,xv_val,list_cont,xydim,&ierr);

		if(c_iask(0,"continue ? ") != 1)
			break;
	}
	if(flg_vis == 1)
		fertek_();
#else
	imerror(9,"Interactive mode not supported\n");
#endif
	return 0;
}
