/*
      c_sancon(in,out,ixy0,idimxy,iseuil,ivis,iconn,lg_bmap)
  lance l'execution du suivi de contours
 l'entree est une image sur 8 ou 1 bits
 sortie possible sur fichier disque et/ou graphique tektro

in, out : noms image entree/ fichier resultat
ixy0[2] : coin haut gauche de la fenetre a traiter (>=1)
idimxy[2] : taille fenetre
iseuil[2] : valeur min et max des pixels d'oblets
ivis : 1= , +2 = sortie tek
iconn: 1= connexite forte
lg_bmap : taille bitmap des contours
*/

#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

// extern struct nf_ct *c_iouvct();


c_sancon(in,out,ixy0,idimxy,iseuil,ivis,iconn,lg_bmap)
char *in, *out;
int *ixy0, *idimxy,*iseuil,*ivis,*iconn, lg_bmap;
{
	Fort_int lfmt[9];
	struct image *nf;
	int xy0[2], dimxy[2], seuils[2];
	nf = image_(in,"e","",lfmt);
	if((lfmt[I_BSIZE] != 1) && ((lfmt[I_BSIZE] != -1) || (lfmt[I_TYPE] != PACKEE)))
		imerror(6,"il faut une image de 1 ou 8 bits\n");
	if(lfmt[I_NDIMV] != 1) imerror(6,"L'image ne doit pas tre vectorielle\n");
	xy0[0] = *ixy0 <= 0 ? 1 : *ixy0;
	xy0[1] = *(ixy0+1) <= 0 ? 1 : *(ixy0+1);
	dimxy[0] = idimxy[0];
	if((dimxy[0] <= 0) || ((dimxy[0] + ixy0[0] - 1) > lfmt[I_DIMX]))
		dimxy[0] = lfmt[I_DIMX] - xy0[0] + 1;
	dimxy[1] = idimxy[1];
	if((idimxy[1] <= 0)  || ((dimxy[0] + ixy0[0] - 1) > lfmt[I_DIMX]))
		dimxy[1] = lfmt[I_DIMY] - xy0[1] + 1;
	seuils[0] = iseuil[0];
	seuils[1] = iseuil[1];
	if(lfmt[I_BSIZE] == -1) {
		if(seuils[0] > 0) seuils[0] = 1;
		seuils[1] = 0;
	} else if(seuils[1] < 0) seuils[1]= 0;
	if(*ivis & 1) {
		anac_info.anac_ct_out = c_iouvct(out,1,"rW");
		c_wctdim(anac_info.anac_ct_out,xy0,dimxy);
	}
	if(*ivis & 2) c_t4init(0,0,0);
	c_dancon(nf,lfmt,dimxy,xy0,seuils,ivis,iconn,lg_bmap);
	if(*ivis & 1) c_fermct(anac_info.anac_ct_out);
	if(*ivis & 2) {
		t4end_();
		fertek_();
	}
	return 0;

}
