#include <stdio.h>
#include <ctype.h>
#include <inrimage/tek.h>

extern debug_;

#define NBVMAX 200

short D_NORM= 1;
short D_DASH = 1;


#define DEBUG 1
#ifdef DEBUG
int nbgs= 0, nbnor= 0, nbdash= 0, nbvnor= 0, nbvdash= 0;
#endif
extern char *i_malloc();
extern short xycadre[];

static char curfnt= 0;
static char fntsz[]= {87,82,70,64};
static int x_ch;

static short X0=0 , Y0= 0, X, Y;
static int numpag= 0;
static char ch_loaded[128]= {0}, new_ch[128];
static int new= 0;
static int diam;
extern int is_pipe;
short *pxy, *path;
short graph= 0, trace= 0;
char mode;
int imode;
unsigned char phy, phx, ieb, ly;
char flg_initp, flg_asc;
int nbvec= 0;	/* nb vect dans page */
static int nbvp;	/*nb vect du path courant */
int xoff= 0, yoff= 0;
int xend= TEK_SIZE -1, yend= TEK_SIZE -1;
extern int Xmin, Ymin, Xmax, Ymax;
FILE *rd_file;

extern  FILE *f_in;
extern int flg_stat, flg_ntext, flg_cadre;
#define PUSH_FAM 0x10
#define PUSH_ALL 0x1ff
tekps(paper)
struct paper *paper;
{
	unsigned char mapn= 0;
	register c, i;
	if(!flg_cadre) {
		Xmin = Ymin = TEK_SIZE;
		Xmax = Ymax = 0;
	}
	rd_file = f_in;
	init_pg();
	pxy = path =(short *) i_malloc(4*NBVMAX);
	trace = graph = 0;
	mode = T_NORM;
	imode = I_NORM;
	diam = D_NORM;
	while ((c = getc(f_in)) != EOF) {
		c &= 0x7f;
		if(c < 0x20) {
			switch (c) {
			case GS :
#ifdef DEBUG
				nbgs++;
#endif
				ch_vmod(mode,imode,diam);
				trace = 0;
				nbvp = 0;
				pxy = path;
				break;
		       case '\r':
		       case '\n':
			       X = 0;
		       case US:
			       flushpath();
			       graph = 0;
			       trace = 0;
/*				tk_endtext(); */
			       break;
		       case FS:	/* mode point */
			       flushpath();
			       graph = -1;
			       trace = 0;
				tk_endtext();
			       break;
		       case ESC :
				while(1) {
					if((c = getc(f_in)) == EOF) {
						if(!flg_stat) {
							ps_newpage(numpag);
						}
						return -1;
					}
					if((c &= 0x7f) > 0) break;
				}
				set_esc(c);
			       break;
			default:
				;
/*??
				fprintf(stderr,"unknown ctrl char 0x%x\n",c);
*/
		       }
			continue;
		}
		if(graph == 0) {
			putasc(c);
		} else {
			getxy(c);
		}
	}
	tk_endtext();
	flushpath();
	if(!flg_stat) {
		if(nbvec > 1)
			ps_eop();
		nbvec = 0;
		ps_newpage(numpag);
	}
}

set_esc(c)
register char c;
{
	switch (c) {
	case T_ERASE :
		if(nbvec <= 1) return 1 /* makes c99 happy */;
		flushpath();
		tk_endtext();
		if(!flg_stat) ps_eop();
		init_pg();
		break;
	case T_SIZ1 :
		tk_font(0);
		break;
	case T_SIZ2 :
		tk_font(1);
		break;
	case T_SIZ3 :
		tk_font(2);
		break;
	case T_SIZ4 :
		tk_font(3);
		break;
	case T_DOT:
		nbdash++;
		ch_vmod(T_DOT,I_DOT,D_DASH);
		break;
	case T_NORM:
		nbnor++;
		ch_vmod(T_NORM,I_NORM,D_NORM);
		break;
	case T_D_DASH:
		nbdash++;
		ch_vmod(T_D_DASH,I_D_DASH,D_DASH);
		break;
	case T_SHORTDASH:
		nbdash++;
		ch_vmod(T_SHORTDASH,I_SHORTDASH,D_DASH);
		break;
	case T_LONGDASH:
		nbdash++;
		ch_vmod(T_LONGDASH,I_LONGDASH,D_DASH);
		break;
	default:
		fprintf(stderr,"warning: unknown ESC seq 0x%x\n",c);
		return -1;
	}
	return 0;
}

/* chg du type de vecteur */
ch_vmod(mod,imod,d)
register mod, imod, d;
{
	tk_endtext();
	if(graph <= 0)
		trace = 0;
	else if(nbvp > 0) {
		flushpath();
		*pxy++ = X;
		*pxy++ = Y;
		nbvp++;
	}
	if(!flg_stat && (imode != imod))
		ps_tekvect(imod);
	mode = mod;
	imode = imod;
	diam = d;
	graph = 1;
}

init_pg()
{
	nbvec = 0;
	nbvp = 0;
	flg_initp = 0;
	graph = 0;
	phx = phy = 0;
	X = X0;
	Y = Y0;
	flg_asc = 0;
	mode = T_NORM;
	trace = 0;
}

putasc(c)
register char c;
{
	if(flg_asc == 0) {  /* 1er caractere */
		flushpath();
		if(flg_initp == 0) 
			hdr_pg();
		flg_asc = 1;
		if(!flg_stat) 
			ps_moveto(X,Y);
		if(!flg_ntext) {
			if(!flg_stat)
				putchar('(');
			x_ch = X;
			if(Ymax < (Y + fntsz[curfnt]))
				Ymax = Y + fntsz[curfnt];
		}
	}
	if(!flg_stat && !flg_ntext)
		putchar(c);
	if(flg_ntext) return 1 /* makes c99 happy */;
	x_ch += fntsz[curfnt];
	if(Xmax < x_ch)
		Xmax = x_ch;
}



getxy(c)
register char c;
{
	char hyx[2];
	register unsigned char  v, fl_ieb;
	if(trace == 0) {	/* tracer path precedent */
		flushpath();
		trace = 1;
	}
	x_getxy(c);
	if(!flg_cadre) {
		if(X < Xmin) Xmin = X;
		else if(X > Xmax) Xmax = X;
		if(Y < Ymin) Ymin = Y;
		else if(Y > Ymax) Ymax = Y;
	}
	nbvp++;
	nbvec++;
	*pxy++ = X;
	*pxy++ = Y;
	if(nbvp >= NBVMAX) {
		if(debug_)
			fprintf(stderr,"too many vectors : break path\n");
		flushpath();
		*pxy++ = X;
		*pxy++ = Y;
		nbvp++;
	}
	if(debug_)
		fprintf(stderr,"(%d,%d) ",X,Y);
	if(graph < 0) {   /* mode point */
		nbvp++;
		*pxy++ = X;
		*pxy++ = Y;
		trace = 0;
		flushpath();
	}
}

x_getxy(c)
register char c;
{
	char hyx[2];
	register unsigned char  v, fl_ieb;
	fl_ieb = 0;
	hyx[0] = phy;
	hyx[1] = phx;
       	while (1) {
		v = c & T_MASKV;
		if((c &= T_MASKH) == T_LX) break;
		switch (c) {
		case T_HXY:
			if(fl_ieb == 0) hyx[0] = v;
			else hyx[1] = v;
			break;
		case T_LBY:
			if(fl_ieb > 0) {
				ieb = ly;
				ly = v;
			} else {
				ly = v;
				fl_ieb++;
			}
		}
		if((c = getc(rd_file)) == EOF) return -1;
		if(is_pipe) putc(c,f_in);
	}
	phy = hyx[0];
	phx = hyx[1];
	X = ((phx << 7) | (v << 2) | (ieb & 3));
	Y = ((phy << 7) | (ly << 2) | (ieb >> 2));
	if(X < 0) X = 0;
	if(Y < 0) Y = 0;
}

flushpath()
{
	if(nbvp > 1) {
		if(flg_initp == 0)
			hdr_pg();
		if(!flg_stat) ps_lwidth((float)diam);
		if(graph > 0 && mode != T_NORM) {
			nbvdash += nbvp;
			if(!flg_stat) dashedpath(nbvp,path);
		} else {
			nbvnor += nbvp;
			if(!flg_stat) {
				ps_drawpath(nbvp,path,0);
			}
		}
		if(debug_)
			fprintf(stderr,"\n");
	}
	nbvp = 0;
	pxy = path;
}

hdr_pg()
{
	register x;
	/* trace du cadre : epaisseur 4 */
	if(flg_cadre) {
		cadre(4);
	}
	flg_initp = 1;
}

static short cad[10];
/* trace du cadre d'epaisseur e */
cadre(e)
register e;
{
	if(flg_stat)
		return 1 /* makes c99 happy */;
	printf("gsave [] 0 setdash\n");
	ps_lwidth((float)e);
	cad[0] = xycadre[0];
	cad[1] = xycadre[1];
	cad[2] = cad[0];
	cad[3] = xycadre[3];
	cad[4] = xycadre[2];
	cad[5] = cad[3];
	cad[6] = cad[4];
	cad[7] = cad[1];
	ps_drawpath(4,cad,1);
	/* restore */
	printf("grestore\n");
}

dashedpath(nbv,p)
register nbv;
register short *p;
{
	ps_drawpath(nbv,p);
}

tk_endtext()
{
	if(flg_asc) {
		if(!flg_stat && !flg_ntext)
			ps_endtext();
		flg_asc = 0;
	}
}
tk_font(n)
register n;
{
	curfnt = n;
	if(!flg_stat) {
		ps_tekfont(n);
	}
}


tk_pass1()
{
	register c;
	if(debug_)
		fprintf(stderr,"Calcul min  max\n");
	rd_file = stdin;
	Xmin = Ymin = TEK_SIZE;
	Xmax = Ymax = 0;
	init_pg();
	pxy = path =(short *) i_malloc(4*NBVMAX);
	trace = graph = 0;
	mode = T_NORM;
	imode = I_NORM;
	diam = D_NORM;
	while ((c = getchar()) != EOF) {
		if(is_pipe) putc(c,f_in);  /* copie */
		c &= 0x7f;
		if(c < 0x20) {
			switch (c) {
			case GS :
				graph = 1;
				trace = 0;
				nbvp = 0;
				pxy = path;
				break;
		       case '\r':
		       case '\n':
			       X = 0;
		       case US:
			       graph = 0;
			       trace = 0;
			       flg_asc = 0;
			       break;
		       case FS:	/* mode point */
			       graph = -1;
			       trace = 0;
			       break;
		       case ESC :
			       while(1) {
				       if((c = getchar()) == EOF) {
					       rewind(f_in);
					       return -1;
				       }
				       if((c &= 0x7f) > 0) break;
			       }
			       if(is_pipe) putc(c,f_in);
			       P1_esc(c);
			       break;
			default:
				;
/*??
				fprintf(stderr,"unknown ctrl char 0x%x\n",c);
*/
		       }
			continue;
		}
		if(graph == 0) {
			P1_asc(c);
		} else {
			P1_getxy(c);
		}
	}
	rewind(f_in);
	i_Free(&path);
}

P1_esc(c)
register char c;
{
	switch (c) {
	case T_ERASE :
		init_pg();
		break;
	case T_SIZ1 :
	case T_SIZ2 :
	case T_SIZ3 :
	case T_SIZ4 :
		break;
	case T_DOT:
	case T_NORM:
	case T_D_DASH:
	case T_SHORTDASH:
	case T_LONGDASH:
		P1_vmod();
		break;
	default:
		fprintf(stderr,"warning: unknown ESC seq 0x%x\n",c);
		return -1;
	}
	return 0;
}
P1_vmod()
{
	if(graph <= 0)
		trace = 0;
	graph = 1;
}

P1_getxy(c)
register c;
{
	x_getxy(c);
	if(X < Xmin) Xmin = X;
	else if(X > Xmax) Xmax = X;
	if(Y < Ymin) Ymin = Y;
	else if(Y > Ymax) Ymax = Y;
}

P1_asc(c)
register c;
{
	if(!flg_ntext) {
		if(flg_asc == 0) {
			x_ch = X;
			if(Ymax < (Y + fntsz[curfnt]))
				Ymax = Y + fntsz[curfnt];
		}
		x_ch += fntsz[curfnt];
		if(Xmax < x_ch)
			Xmax = x_ch;
	}
	flg_asc = 1;
}
