#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>


/* renvoie l'indice +1 du 1e bit a 0 de anac_info.bitmap 
0 si tout est pris
*/
int tst_bitmap()
{
	register int i, n, v, k;
	n = 1;
	for(i=0;i< anac_info.lg_bmap;i++) {
		if((v = anac_info.bitmap[i]) == 0xff) {
			n += 8;
			continue;
		}
		if(v == 0) return n;
		k = 0x80;
		while(k) {
			if( ! (v & k)) return n;
			n++;
			k >>= 1;
		}
	}
	return 0;
}

/* met a val (0/1) le bit n de la bitmap (n >= 1) */
void set_bitmap(n,val)
int n, val;
{
	int k;
	if(n <= 0) imerror(9,"set_bitmap : mauvais parametre n\n");
	n--;
	k = 0x80 >> (n % 8);
	if(val)
		anac_info.bitmap[n / 8] |= k;
	else
		anac_info.bitmap[n / 8] &= ~k;
	
}
