#include <inrimage/image.h>
#include <inrimage/anac.h>
/*
  isens >0  contour positif => trait continu
   isens <0  contour negatif => trait pointille
  closed !=0  => contour ferme
  j = indice (>=1) 1e bloc dans chn
  nbpt = nb pts par bloc
  dmax = dim max de l'image = max(ndimx,ndimy)
*/

#define TEK_WIDTH 780

void c_ecchtk(chn,j,isens,closed,nbpt,dmax)
struct chn *chn;
int j, isens, closed, nbpt, dmax;
{
  struct chn *pchn;
  unsigned short *ps;
  int itrac, ix, iy, ixv, iyv, ix0, iy0, i;
  if(isens < 0)
    c_t4trac(0,1);
  else
    c_t4trac(0,0);
  itrac = 0;
  while(j > 0) {
    pchn = chn + j - 1;
    i = 0;
    j = pchn->inext;
    ps = pchn->pts;
    while(i++ < nbpt) {
      if(ixv = *ps++) {
	iyv = *ps++;
	iy = TEK_WIDTH - ((iyv * TEK_WIDTH) + dmax - 1)/dmax;
	ix = ((ixv * TEK_WIDTH) + dmax - 1) / dmax;
	if((itrac == 0) && closed) {
	  ix0 = ix;
	  iy0 = iy;
	}
	c_t4vabs(ix,iy,itrac);
	itrac = 1;
      } else ps++;
    }
  }
  if(closed)
    c_t4vabs(ix0,iy0,2);
  else
    c_t4vabs(ix,iy,2);
}
