#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

extern int koctet_;

/*
   retourne indice +1 de struct chn libre dans anac_heap
*/
int c_gtbloc()
{
	int i, j;
	struct chn *pchn;
	
	if((i = anac_info.ipvid)) { /* il y a des blocs libres */
		pchn = (struct chn *)anac_heap + i - 1;
		anac_info.ipvid = pchn->inext;
	} else {
		i = anac_info.ix_chn + sizeof(struct chn);
		if(i >= anac_info.ix_cont_desc)
			imerror(8,"Pas assez de memoire (-k %d)\n",koctet_);
		anac_info.ix_chn = i;
		anac_info.ix_chn_max = i;
		i /= sizeof(struct chn);
		pchn = (struct chn *)anac_heap + i - 1;
	}
	/* raz du bloc */
	for(j=0;j< 2*NBPTS_BLOC;j++)
		pchn->pts[j] = 0;
	anac_info.tot_blocs++;
	return i;
}
