C*MRAYON
	SUBROUTINE MRAYON(COORD,NDIM,X,Y,R,ERR1)
	INTEGER *2 COORD(2)
	IF(NDIM.GT.1)GO TO 5
	X=COORD(1)
	Y=COORD(2)
	R=0.
	ERR1=0.
	GO TO 120
5     X=0.
	Y=0.
	DO 1 I=1,NDIM
	IY=2*I
	IX=IY-1
	X=X+COORD(IX)
	Y=Y+COORD(IY)
1     CONTINUE
	X=X/NDIM
	Y=Y/NDIM
	CALL CALRAY(COORD,NDIM,X,Y,R)
	CALL ERROR2(COORD,NDIM,X,Y,R,ERR0)
	WRITE(0,100)ERR0
100   FORMAT('ERREUR QUADRATIQUE INITIALE ',E11.4)
	IF(ERR0.LE.1.E-10)GO TO 200
	K=1
	ALPHA=.5
6     R1=R
	X1=X
	Y1=Y
	DO 2 I=1,5
	ERX=0.
	ERY=0.
	DO 3 J=1,NDIM
	IY=2*I
	IX=IY-1
	DEN=SQRT((COORD(IX)-X1)*(COORD(IX)-X1)+(COORD(IY)-Y1)*
     *(COORD(IY)-Y1))
	ERX=ERX+COORD(IX)-R1*(COORD(IX)-X1)/DEN
	ERY=ERY+COORD(IY)-R1*(COORD(IY)-Y1)/DEN
3     CONTINUE
	ERX=ERX/NDIM
	ERY=ERY/NDIM
	X1=(1.-ALPHA)*X1+ALPHA*ERX
2     Y1=(1.-ALPHA)*Y1+ALPHA*ERY
	CALL CALRAY(COORD,NDIM,X1,Y1,R1)
	CALL ERROR2(COORD,NDIM,X1,Y1,R1,ERR1)
	IF(ERR1.LT.ERR0)GO TO1000
	K=K+1
	IF(K.LT.10)GO TO 4
200   X1=X
	Y1=Y
	R1=R
	ERR1=ERR0
	GO TO 1000
4     ALPHA=ALPHA/2.
	GOTO 6
1000  X=X1
	Y=Y1
	R=R1
	WRITE(0,110)ERR1
110   FORMAT('ERREUR QUADRATIQUE FINALE ',E11.4)
	IF(ERR1.LE.1.E-10)GO TO 120
	ERR1=ERR1/R1
120   RETURN
	END
