C* ARIG1
	SUBROUTINE ARIG1(A,NTABA,NF1,ISF1,NFO,ISFO,LFMT1,LFMTO,NTYP,NE,
     .NM,NVAL)
C  ARIG1 CALCULE LES PARAMETRES NECESSAIRES A L'OPERATION ET
C  EFFECTUE LA LECTURE ET L'ECRITURE SUR LES FICHIERS IMAGE.
C  A: TABLEAU
C  NTABA: DIMENSION EN NOMBRE DE MOTS DU TABLEAU A
C  NF1,ISF1: NUMEROS DE FICHIER ET DE SOUS-FICHIER DE L'IMAGE
C            D'ENTREE
C  NFO,ISFO: NUMEROS DE FICHIER ET DE SOUS-FICHIER DE L'IMAGE
C            RESULTAT
C  LFMT1,LFMTO: FORMATS DES IMAGES
C  NTYP: CODE DE L'OPERATION
C    1=BIAS, 2=SCALE, 3=LOG, 4=EXP, 5=RACINE, 6=SEUIL BAS, 7=SEUIL HAUT
C    8=DIV., 9=MASQUE BAS, 10=MASQUE HAUT, 11=MODULE, 12=CARRE,
C    13=SEUIL BAS VARIABLE, 14=SEUIL HAUT VARIABLE
C     LA DIVISION (I=8) EST REMPLACEE PAR MULTIPL. PAR INVERSE
C   POUR MASQUES BAS ET HAUT LE RESULTAT EST SUR 1 BIT
C  NE: EXPOSANT DU SCALAIRE DANS LE CAS DE LA MULTIPLICATION
C  NM: SCALAIRE
C  NVAL: VALEUR A METTRE DAS LE CAS DES SEUILS VARIABLES.
	external btest
	INTEGER A(1),LFMT1(9),LFMTO(9)
	INTEGER*2 ISF1,ISFO
	INTEGER E1,E2,EO
	LOGICAL BTEST
C DETERMINATION DE LA BIT-SIZE DES IMAGES
	NO=LFMTO(3)*8
	IF (LFMTO(3).LT.0) NO=-LFMTO(3)
	NB1=LFMT1(3)*8
	IF(LFMT1(3).LT.0) NB1=-LFMT1(3)
	NSIG1=0
	IF(LFMT1(9).LT.0) NSIG1=1
	NB1S=NB1
	IF(NSIG1.EQ.0) NB1S=NB1S+1
C NORMALISATION DE L'EXPOSANT DE L'IMAGE D'ENTREE
	E1=LFMT1(9)
	IF(E1.LT.0)E1=-E1
	IF(E1.EQ.0)E1=200
	E1=E1-NB1
C INITIALISATION DES DECALAGES
	ISH1=0
	ISH2=0
	CALL REXP1(E1,NE,EO,NB1S,NM,NVAL,NBO,ISH1,ISH2,NSIG1,NSIGO,NTYP)
C MISE A JOUR DE L'EXPOSANT DU RESULTAT
	IF(NTYP.NE.9.AND.NTYP.NE.10) GOTO 5
	IF(LFMTO(3).NE.-1.OR.LFMTO(4).NE.-1) CALL ERMESF(6)
	GOTO 6
5     ISHO=NO-NBO
	LFMTO(9)=EO+NBO
	IF((LFMTO(9).GT.300).OR.(LFMTO(9).LT.100)) CALL ERMESF(14)
	IF(NSIGO.EQ.1) LFMTO(9)=-LFMTO(9)
	CALL FMTSET(NFO,LFMTO)
C DETERMINATION DE J1
6     J1=-1
	IF((NB1+ISH1).GT.0.AND.(NB1+ISH1).LT.32)J1=ISHFT(J1,NB1+ISH1)
	IF((NB1+ISH1).GE.32) J1=0
	J3=ISHFT(-1,NO-32)
C DETERMINATION DE LA BYTE SIzE
	NBY1=(NB1+7)/8
	NBYO=(NO+7)/8
C DETERMINATION DU NOMBRE DE LIGNES QUI TIENNENT DANS LE TABLEAU A
	IF(NBY1.LT.NBYO) GO TO 1
	CALL SETUP(NTABA,LFMT1,NROW,NREST,NDIMA)
	GO TO 2
1     CALL SETUP(NTABA,LFMTO,NROW,NREST,NDIMA)
2     IF(NROW.LE.0) CALL ERMESF(8)
	NCOUP=LFMT1(2)/NROW
	NZ=0
	IF(NBYO.LE.NBY1) NZ=1
10    KPT1=(NDIMA-1)*NBY1
	KPTO=(NDIMA-1)*NBYO
C OPERATION POINT PAR POINT
	DO 40 ICOUP=1,NCOUP
	CALL LECT(NF1,NROW,A)
	IF(LFMT1(4).EQ.-1)CALL UNPKBT(A,A,NDIMA,NB1)
	K1=0
	KO=0
	IF(NZ.EQ.1) GO TO 20
	K1=KPT1
	KO=KPTO
20    DO 31 L=1,NDIMA
C  ON PREND NBY1 OCTETS SUCCESSIFS (UN POINT) DU TABLEAU A
C ET LES MET DANS I; PUIS EFFECTUE ISH DECALAGES SUR I AVEC
C APPROXIMATION SI C'EST UN DECALAGE VERS LA DROITE,ET COMPLEMENTE
C A GAUCHE PAR DES 1 SI LE POINT EST NEGATIF
	II=0
	DO 109 JJ=1,NBY1
	CALL ILBYTE(IV,A,K1)
	II=IV+ISHFT(II,8)
	K1=K1+1
109   CONTINUE
	NS=32-NB1
	I=ISHFT(II,ISH1)
	IF(ISH1.GE.0) GOTO 110
	IF(ISH1.LE.-32) GOTO 120
	IF((.NOT.BTEST(II,NS)).OR.(NSIG1.EQ.0)) GOTO 115
	I=IOR(J1,I)
115   IF(BTEST(II,32+ISH1)) I=I+1
	GOTO 120
110   IF((.NOT.BTEST(II,NS)).OR.(NSIG1.EQ.0)) GOTO 120
	I=IOR(J1,I)
C  EFFECTUER L'OPERATION
120   GOTO(210,220,230,230,230,240,250,270,260,280,230,230,290,99),NTYP
C BIAIS
210   I=I+NM
	GOTO 300
C SCALE
220   I=I*NM
	GOTO 300
230   GOTO 300
C SEUIL BAS
240   IF(NM.GT.I) I=NM
	GOTO 300
C SEUIL HAUT
250   IF(NM.LT.I) I=NM
	GOTO 300
C MASQUE BAS
260   IF(I.GT.NM) GO TO 281
261   CALL BSET(A,L-1)
	GOTO 31
C MASQUE HAUT
280   IF(I.GT.NM) GO TO 261
281   CALL BCLR(A,L-1)
	GOTO 31
C SEUIL BAS VARIABLE
290   IF(I.LT.NM)I=NVAL
	GOTO 300
C SEUIL HAUT VARIABLE
99    IF(I.GT.NM)I=NVAL
	GOTO 300
C DIVISION
270   I=I/NM
C  ON EFFECTUE D'ABORD ISHO DECALAGES SUR I PUIS
C  ON PREND NBYO OCTETS DE I ET LES MET DANS LE TABLEAU A
C  A PARTIR DU KOIEME OCTET
300   I=IAND(J3,ISHFT(I,ISHO))
302   M=KO+NBYO-1
	DO 410 J=1,NBYO
	CALL ISBYTE(I,A,M)
	I=ISHFT(I,-8)
	M=M-1
410    CONTINUE
	KO=KO+NBYO
	IF(NZ.EQ.1) GO TO 31
	K1=K1-2*NBY1
	KO=KO-2*NBYO
31    CONTINUE
	IF(NTYP.EQ.9.OR.NTYP.EQ.10) GOTO 32
	IF(LFMTO(4).EQ.-1) CALLPCKBT(A,A,NDIMA,NO)
32    CALL ECR(NFO,NROW,A)
40    CONTINUE
	IF(NREST.EQ.0) RETURN
	NROW=NREST
	NREST=0
	NCOUP=1
	NDIMA=NROW*LFMT1(1)
	GO TO 10
	RETURN
	END
