C* REXP1
	SUBROUTINE REXP1(E1,NE,EO,NB1S,NM,NVAL,NBO,ISH1,ISH2,NSIG1
     %,NSIGO,NTYP)
C  DETERMINE EN FONCTION DE L'OPERATION ,L'EXPOSANT,LA BIT SIZE,
C  ET LA NATURE DU RESULTAT,AINSI QUE LES DECALAGES A EFFECTUER
C  SUR L'IMAGE D'ENTREE
C  E1: EXPOSANT DE L'IMAGE D'ENTREE
C  NE:EXPOSANT DU SCALAIRE (MULTIPLICATION)
C  NB1S: BIT SIZE DE L'IMAGE D'ENTREE,TOUJOURS AVEC LE BIT SIGNE
C  NM: VALEUR DU SCALAIRE
C  NVAL:VALEUR A METTRE DANS LE CAS DE SEUILS VARIABLES
C  NSIG1=0 SI L'IMAGE 1 EST SANS SIGNE,1 DANS LE CAS CONTRAIRE
C  NTYP:CODE DE L'OPERATION
C      A LA SORTIE:
C  EO:EXPOSANT DU RESULTAT
C  NBO: BIT SIZE DU RESULTAT
C  ISH1: NOMBRE DE DECALAGES A EFFECTUER SUR L'IMAGE D'ENTREE
C  ISH2:NOMBRE DE DECALAGES A EFFECTUER SUR NM
C  NSIGO=0 SI LE RESULTAT EST SANS SIGNE,1 DANS LE CAS CONTRAIRE
	external btest
	logical btest
	INTEGER E1,EO
	NSIG2=0
C CALCUL DU NOMBRE DE BITS DE NM
	DO 1 II=1,31
	IF((BTEST(NM,0).AND.(.NOT.BTEST(NM,II))).OR.(.NOT.BTEST(NM,0)
     ..AND.BTEST(NM,II))) GO TO 2
1     CONTINUE
	II=II-1
2     NB2S=33-II
	IF(BTEST(NM,0)) NSIG2=1
	IF((NTYP.EQ.2).OR.(NTYP.EQ.8)) GO TO 3
	IF(NB1S.LT.NB2S) CALL ERMESF(9)
3     GO TO (10,20,30,30,30,60,60,80,50,50,30,30,130,130),NTYP
C ADDITION
10    NSIGO=IOR(NSIG1,NSIG2)
	NBO=NB1S+1
	EO=E1
	IF(NBO.LE.32) GO TO 11
	ISH1=-1
	ISH2=-1
	EO=EO+1
	NBO=32
11    IF(NSIGO.EQ.0) NBO=NBO-1
	RETURN
C MULTIPLICATION
20    NSIGO=IOR(NSIG1,NSIG2)
	NBO=NB1S+NB2S-1
	IF(NBO.LE.32) GO TO 21
	ISH1=MIN0(0,16-NB1S)
	ISH2=MIN0(0,16-NB2S)
	NBO=31
21    EO=E1-ISH1+NE-ISH2
	IF(NSIGO.EQ.0) NBO=NBO-1
	RETURN
C CAS IMPOSSIBLES
30    CALL ERMESF(4)
C DIVISION
80    NSIGO=IOR(NSIG1,NSIG2)
	ISH1=32-NB1S
	EO=E1-NE-ISH1
	NBO=32
	IF(NB2S.GE.3) NBO=32-NB2S+2
	IF(NSIGO.EQ.0) NBO=NBO-1
	RETURN
C SEUILS
C CALCUL DE LA BIT SIZE DE NVAL
130   NSIG3=0
	DO 131 II=1,31
	IF((BTEST(NVAL,0).AND.(.NOT.BTEST(NVAL,II))).OR.(.NOT.BTEST
     .(NVAL,0).AND.BTEST(NVAL,II))) GO TO 132
131   CONTINUE
	II=II-1
132   NB3S=33-II
	IF(BTEST(NVAL,0))NSIG3=1
	IF(NB1S.LT.NB3S) CALL ERMESF(9)
	IF(NSIG1.EQ.0.AND.NSIG3.EQ.1) CALL ERMESF(9)
60    NSIGO=NSIG1
	IF(NSIG1.EQ.0.AND.NSIG2.EQ.1) CALL ERMESF(9)
	NBO=NB1S
	EO=E1
	IF(NSIGO.EQ.0)NBO=NBO-1
	RETURN
50    NBO=0
	EO=200
	NSIGO=0
	RETURN
	END
