/* t4trac
	subroutine t4trac(mode,itype)
	c_t4trac(mode,itype)
c  choix du mode de trace et du type de vecteur
c  mode ignore ici (0=normal, 1=defocalise)
c  itype=0,1,2,3,4 pour traits continus,pointilles, mixte,
c    tirets courts et tirets longs
*/

#include <stdio.h>
#include <inrimage/image.h>
#define ESC 0x1b
static char vbuf[2]= {ESC,0};
static char vtyp[]= "`abcd";
extern struct tktrnx tktrnx_;
extern debug_;

void c_t4trac();

t4trac_(mode,itype)
Fort_int *mode, *itype;
{
/* pour avoir un hard copy sur plotter hp
  modif P. CIPIERE 3/11/83 */
	hptrac_(mode,itype);
	c_t4trac((int)*mode,(int)*itype);
}

void c_t4trac(mode,itype)
int mode;
register int itype;
{
	if(itype < 0 || itype > 4) {
		if (debug_) fprintf(stderr,"Warning! t4trac: wrong vecteur type %d\n",itype);
		return;
	}
	if(!tktrnx_.tk_psmode) {
		vbuf[1] = vtyp[itype];
		c_t4send(vbuf,2);
		return;
	}
	c_t4chgmod();
	ps_tekvect(itype);
}
