/*
	SUBROUTINE CHGTEK(ITB)
  permet de changer le nom de la tektro en /dev/tek ou /dev/tty
   dans la table TEK_nom de asstek
  si itb(1)=0 on met /dev/tek, si itb(1)=1, on met /dev/tty, 
  si itb(1) = 2 on met '<' (pour dire stdin)
  si itb(1)= 3 on met '>' (pour dire stdout)
  si itb(1)<0 on met le nom de fichier contenu dans itb(2) a itb(6)
   si itb(1)>2 on ne fait rien
   si itb(1)=1 ou 2 on met 1 dans TEK_typ, 0 sinon
NB : dans asstek, si la variable TEK_select est a 0, on regarde l'etat
	de la variable d'environnement TEK_NOM pour savoir si on doit
	changer le nom de la tek.
	la variable TEK_select est mise a 1 par chgtek.
*/
#include <string.h>
extern char TEK_nom[];
extern int TEK_typ;	/* type de la tek : console ou non */
extern int TEK_select;	/* indicateur de selection automatique de tek */
char ntek[]= "/dev/tek";
char ntty[]= "/dev/tty";
chgtek_(itb)
int *itb;
{
int i;
	TEK_select = 1;
	TEK_typ = 0;
	if(*itb == 0) {	/* /dev/tek */
		for (i=0;(TEK_nom[i] = ntek[i]) > 0;i++)
			;
		return 1 /*makes c99 happy*/;
	}
	if(*itb > 0) {	/* /dev/tty */
		if(*itb > 3) return 1 /*makes c99 happy*/;
		if(*itb == 1) {
			for (i=0;(TEK_nom[i] = ntty[i]) > 0;i++)
				;
		} else {
			TEK_nom[1] = 0;
			if(*itb == 2)
				TEK_nom[0] = '<';
			else
				TEK_nom[0] = '>';
		}
		TEK_typ = 1;
		return 1 /* makes c99 happy */;
	}
	if(*itb < 0) {	/* nom de fichier dans itb(2) */
		itb++;
		strncpy(TEK_nom,(char *)itb,19);
		TEK_nom[19] = 0; 	/* forcer 1 0 */
		return 1 /* makes c99 happy */; 
	}
}
