/* icode c_icode
	SUBROUTINE ICODE(IVAL,ITAB,LGR)
	c_icode(ival,itab,lgr)
 code l'entier IVAL sous forme de chaine de caracteres dans ITAB
 le resultat de longueur LGR chiffres est cadre a gauche et suivi
   d'un espace
 ITAB doit etre de longueur suffisante
*/

#include <string.h>
#include <inrimage/image.h>

icode_(ival,itab,lgr)
Fort_int *ival, *lgr;
char *itab;
{
	int xlgr;
	c_icode((int)*ival,itab,&xlgr);
	*lgr = (Fort_int) xlgr;
}
static char tbchf[]= "0123456789";

#define E_BUF 32
c_icode(val,itab,lgr)
register int val, *lgr;
register char *itab;
{
	char buf[E_BUF];
	register n, lg, v;
	if(val == 0) {
		strcpy(itab,"0 ");
		*lgr = 2;
		return 2;
	}
	n = E_BUF -1;
	lg = 0;
	v = val < 0 ? -val : val;
	if(v < 0) {  /* valeur neg max : 0x80000000 */
		if(sizeof(int) != 4)
			imerror(9,"icode: sizeof of int != 4\n");
		strcpy(itab,"-2147483648 ");
		*lgr = 12;
		return 12;
	}
	while(v) {
		buf[n--] = tbchf[v % 10];
		v /= 10;
	}
	n++;
	lg = E_BUF - n +1;
	if(val < 0) {
		*itab++ = '-';
		lg++;
	}
	while(n < E_BUF)
		*itab++ = buf[n++];
	*itab++ = ' ';
	*lgr = lg;
	return lg;
}

