/* mvbyte
	subroutine mvbyte(a,b,ixa,ixb,nbyt)
	c_mvbyte(a,b,nbyt)
		char *a, *b; int  nbyt;
  transfert de nbyt octets de a dans b en partant des octets
  d'indices ixa et ixb (1 a n)
on appelle mvmots si adresses et nb multiples de 4
*/
#include <stdio.h>
#include <inrimage/image.h>

/* on ne fait pas d'hypothese sur la place des octets dans un mot */

mvbyte_(in,out,i_in,i_out,nbytes)
CHAR *in,*out;
Fort_int *i_in,*i_out,*nbytes;
{
	c_mvbyte(in + *i_in -1,out + *i_out -1,(int)*nbytes);
}

#define M_ALIGNED (sizeof(Fort_int) -1)
#define I_ALIGNED (sizeof(int) -1)

c_mvbyte(in,out,nbytes)
register CHAR *in,*out;
register nbytes;
{

	register CHAR *r_in, *r_out, *last_out;

	if ( in  == out ) return 0; /* rien a faire */
	if(((unsigned long)in & M_ALIGNED) == 0 && ((unsigned long)out & M_ALIGNED) == 0 && (nbytes & M_ALIGNED) == 0)
		return c_mvmots((Fort_int *)in,(Fort_int *)out,nbytes/(sizeof(Fort_int)));
	if((M_ALIGNED != I_ALIGNED) &&
	   ((unsigned long)in & I_ALIGNED) == 0 && ((unsigned long)out & I_ALIGNED) == 0 && (nbytes & I_ALIGNED) == 0)
		return c_mvints((int *)in,(int *)out,nbytes/(sizeof(int)));

	if (  in  <  out )  {	/* on commence par la fin */

		r_in = in  + nbytes - 1;
		r_out = out  + nbytes - 1;

		last_out = out  - 1;

		while ( r_out > last_out )
			{
			*(r_out--) = *(r_in--) ;
			}
	} else {	/* on commence par le debut */

		r_in = in;
		r_out = out;

		last_out = out + nbytes;

		while ( r_out < last_out )
			{
			*(r_out++) = *(r_in++) ;
			}
		}
	return 0;
}
