/*
C*RCODX
	SUBROUTINE RCODX(RES,TAB1,LGR,LGD)
c  codage d'un nombre reel res sous forme de chaine de caracteres
c  dans tab1.  LGR est le nombre de caracteres generes
c  (caracteres inutiles supprimes).
c  LGD= nb car. max autorises (signe non compris).
c  TAB1 doit etre de longueur 4 mots.
c  codage en format f si abs(res) entre .1 et 1e6
   formats par defaut f12 et e11 sans le signe
*/

#include <inrimage/image.h>

rcodx_(res,tab1,lgr,lgd)
float *res;
Fort_int *lgr, *lgd;
char *tab1;
{
register float r;
register int nb, lmx;
register char *p1, *p0, *p2;
int i, n1, n2;
	lmx = *lgd;
	r = *res;
	i = 0;
	if(r < 0) {
		r = -r;
		i = 1;
		*tab1++ = '-';
	}
	if(r == 0.) {
		*tab1++ = '0';
		*tab1 = '\0';
		*lgr = 1;
		return 1 /* makes c99 happy */; 
	}
	if(r >= .1 && r < 1.e6) {
		if(lmx == 0) {
			n1 = 12;
			n2 = 5;
		} else {
			n1 = lmx;
			if(r < 1000.) {
				if (r< 10.) nb = 1;
				else	if(r < 100.) nb = 2;
					else	nb = 3;
			} else {
				if(r < 10000.) nb = 4;
				else	if(r < 100000.) nb = 5;
					else nb = 6;
			}
			n2 = n1 - nb -1;
			if(n2 < 0) n2 = 0;
			else if(n2 > 6) n2 = 6;
		}
		sprintf(tab1,"%-*.*f",n1,n2,r);
		p0 = tab1;
		while (*p0 && *p0 != ' ')	/* rechercher fin chaine */
			p0++;
		p0 -= 1;
		if(lmx == 0) {	/* codage min. : supp 0  apres . */
			while (*p0 == '0')
				p0--;
		}
		*lgr = i + p0 - tab1 +1;
		return 1 /* makes c99 happy */; 
	}
	if(lmx > 0) n1 = lmx;
	else n1 = 11;
	n2 = n1 - 6;
	if(n2 < 0) n2 = 0;
	else if(n2 > 6) n2 = 6;
	sprintf(tab1,"%-*.*e",n1,n2,r);
	p0 = tab1;
	while (*p0 && *p0 != ' ')	/* rechercher fin chaine */
		p0++;
	p2 = p0 -= 1;
	*lgr = i + p0 - tab1 +1;
	if(lmx > 0) return 1 /* makes c99 happy */; 
		/* codage min. : supp 0  apres . */
	while (*p0-- != 'e')
		;
	p1 = p0;	/* p1 pointe sur car. avant 'e' */
	while (*p0 == '0')
		p0--;
	if(p0 == p1) return 1 /* makes c99 happy */; 
		/* supprimer 0 fin mantisse */
	while (p1 <= p2) 
		*++p0 = *p1++;
	*lgr = i + p0 - tab1 +1;
}
