#include <stdio.h>
#include <inrimage/image.h>

static Fort_int icodo[2]= {1,0};

/* lit un fichier (nf) de tables couleur dans les 3 tableaux bufr, bufg, bufb
de taille maxcol.
renvoie dans i0 l'indice du 1e element valide et dans nb le nb valide
Met a 0 les tableaux de 0 a i0-1 et de i0+nb a maxcol
renvoie le nb de tables effectivement differentes (1 a 3)
*/
ird_ctfile(nf,i0,nb,bufr0,bufg0,bufb0,maxcol)
register struct image *nf;
char *bufr0, *bufg0, *bufb0;
int maxcol;
int *i0, *nb;
{
	register char *bufg, *bufb;
	struct nf_fmt gfmt;
	char *cols[3];
	register unsigned char *pc;
	register unsigned char *data;
	unsigned char *bufdata;
	register i, j, nz;
	c_getgfm(nf,&gfmt,1);
	nz = gfmt.DIMY;
	if(nz != 1 && nz != 3)
		imerror(9,"ird_ctfile : bad DIMY for color file %s\n",nf->nom);
	if(gfmt.DIMX > maxcol)
		imerror(9,"ird_ctfile : DIMX of %s too large (> %d)\n",nf->nom,maxcol);
	cols[0] = bufr0;
	cols[1] = bufg0;
	cols[2] = bufb0;
	i = nz * gfmt.DIMX * 4;
	data = bufdata = (unsigned char *)i_malloc(i);
	c_lect(nf,nz,data);
	*nb = gfmt.DIMX;
	if(gfmt.BSIZE != 1)
		c_cnvtbg(data,data,*nb,&gfmt.BSIZE,icodo,gfmt.EXP,(Fort_int)0);
	i = gfmt.offsets[0];
	if((i + *nb) > maxcol)
		i = maxcol - *nb;
	*i0 = i;
	for(i=0;i<nz;i++) {
		pc = (unsigned char *)cols[i];
		for(j=0;j<*i0;j++) {
			*pc++ = 0;
		}
		for(j=0;j<*nb;j++)
			*pc++ = *data++;
		for(j= *i0 + *nb;j<maxcol;j++)
			*pc++ = 0;
	}
	i_Free((char **)&bufdata);
	if(nz == 1) {
		pc = (unsigned char *)bufr0;
		bufg = bufg0;
		bufb = bufb0;
		for(j=0;j<maxcol;j++) {
			*bufg++ = *pc;
			*bufb++ = *pc++;
		}
		return 1;
	}
	return icmp_ct(bufr0,bufg0,bufb0,maxcol);
}

