C* FFTMUL
	SUBROUTINE FFTMUL(NROW,N2POW,X,Y,LO)
C CE SOUS PROGRAMME EFFECTUE LA TRANSFORMEE DE FOURIER RAPIDE 842
C DE LO COLONNES COMPLEXES (Z=X+IY) DE N=2**N2POW POINTS CHACUNES.
C LO=NROW
C LES LIGNES SONT SUPPOSEES RANGEES SEQUENTIELLEMENTS DANS LES TAB
C LEAUX X(POUR LES PARTIES REELLES) ET Y(..IMAGINAIRES).
C ON EFFECTUE AUTANT D ITERATIONS EN BASE 8 QUE POSSIBLE
C ON TERMINE ALORS PAR LES BASES 4 OU 2.(MEME METHODE QUE POUR
C LE SOUS PROG. FRXFM).
C
C LA FFT EST EFFECTUEE IN PLACE.
C LES 2 VECTEURS X ET Y DE DIMENSION NROW*(2**N2POW)*LO
C DONNES.
C PROGRAMME REALISE PAR R.DERICHE LE 28/01/82.
C
C
C
C
	DIMENSION X(4),Y(4)
	DIMENSION L(15),IC(8)
	EQUIVALENCE (I1,IC(1)),(I2,IC(2)),(I3,IC(3)),(I4,IC(4))
	EQUIVALENCE (I5,IC(5)),(I6,IC(6)),(I7,IC(7)),(I8,IC(8))
	EQUIVALENCE (L15,L(1)),(L14,L(2)),(L13,L(3)),(L12,L(4)),
     ;(L11,L(5)),(L10,L(6)),(L9,L(7)),(L8,L(8)),
     ;(L7,L(9)),(L6,L(10)),(L5,L(11)),(L4,L(12)),(L3,L(13)),
     ;(L2,L(14)),(L1,L(15))
	NTHPO1=2**N2POW
	NTHPO=NTHPO1
	N8POW=N2POW/3
	IF(N8POW.EQ.0)GOTO 100
C   RADIX 8 PASSES
	NXTLT=NTHPO1
	DO 10 IW=1,N8POW
	NXTLT=NXTLT/8
	LENGT=8*NXTLT
	J1=1
	DO 15 J=1,8
	IC(J)=J1
	J1=J1+NXTLT
15    CONTINUE
	CALL R8TXMM(LO,NXTLT,NTHPO,LENGT,X((I1-1)*LO+1),X((I2-1)*LO
     %+1),X((I3-1)*LO+1),X((I4-1)*LO+1),X((I5-1)*LO+1),X((I6-1)*LO+1)
     %,X((I7-1)*LO+1),X((I8-1)*LO+1),Y((I1-1)*LO+1),Y((I2-1)*LO+1),
     %Y((I3-1)*LO+1),Y((I4-1)*LO+1),Y((I5-1)*LO+1),Y((I6-1)*LO+1)
     %,Y((I7-1)*LO+1),Y((I8-1)*LO+1),NROW)
10    CONTINUE
C  FACTEUR 4
100   IF(N2POW-3*N8POW-1) 110,120,130
C  ITERATION BASE 4
130   CONTINUE
	CALL R4TXMM(LO,NTHPO,X(1),X(LO+1),X(2*LO+1),X(3*LO+1),
     %Y(1),Y(LO+1),Y(2*LO+1),Y(3*LO+1),NROW)
	GOTO 110
C  ITERATION BASE 2
120   CONTINUE
	CALL R2TXMM(LO,NTHPO,X(1),X(LO+1),Y(1),Y(LO+1),NROW)
C
110   I=NTHPO+NTHPO
	DO 51 J=1,15
	L(J)=LO
	IF(J.GT.N2POW) GOTO 51
	I=I/2
	L(J)=I*LO
51    CONTINUE
	IJ=1
	DO 81 J1=1,L1,LO
	DO 82 J2=J1,L2,L1
	DO 83 J3=J2,L3,L2
	DO 84 J4=J3,L4,L3
	DO 85 J5=J4,L5,L4
	DO 86 J6=J5,L6,L5
	DO 87 J7=J6,L7,L6
	DO 88 J8=J7,L8,L7
	DO 89 J9=J8,L9,L8
	DO 90 J10=J9,L10,L9
	DO 91 J11=J10,L11,L10
	DO 92 J12=J11,L12,L11
	DO 93 J13=J12,L13,L12
	DO 94 J14=J13,L14,L13
	DO 95 JI=J14,L15,L14
	IF(IJ.GE.JI) GOTO 8
	  DO 40 JNR=1,NROW
	  IJNR=IJ+(JNR-1)
	  JINR=JI+(JNR-1)
	R=X(IJNR)
	X(IJNR)=X(JINR)
	X(JINR)=R
	R=Y(IJNR)
	Y(IJNR)=Y(JINR)
	Y(JINR)=R
40        CONTINUE
8     IJ=IJ+LO
95    CONTINUE
94    CONTINUE
93    CONTINUE
92    CONTINUE
91    CONTINUE
90    CONTINUE
89    CONTINUE
88    CONTINUE
87    CONTINUE
86    CONTINUE
85    CONTINUE
84    CONTINUE
83    CONTINUE
82    CONTINUE
81    CONTINUE
	RETURN
	END
