C* R8TX
	SUBROUTINE R8TX(NXTLT,NTHPO,LENGT,CR0,CR1,CR2,CR3,CR4,
     XCR5,CR6,CR7,CI0,CI1,CI2,CI3,CI4,CI5,CI6,CI7)
	DIMENSION CR0(1),CR1(1),CR2(1),CR3(1),CR4(1),CR5(1),CR6(1)
	DIMENSION CR7(1),CI0(1),CI1(1),CI2(1),CI3(1),CI4(1),CI5(1)
	DIMENSION CI6(1),CI7(1)
	DATA TWOPI/6.283185307/,RAC2/.7071067812/
	SCALE=TWOPI/FLOAT(LENGT)
	DO 20 I=1,NXTLT
	R0=FLOAT(I-1)*SCALE
	C1=COS(R0)
	S1=SIN(R0)
	C2=C1*C1-S1*S1
	S2=2*S1*C1
	C3=C1*C2-S1*S2
	S3=C2*S1+C1*S2
	C4=C2*C2-S2*S2
	S4=2.*C2*S2
	C5=C2*C3-S2*S3
	S5=C2*S3+C3*S2
	C6=C3*C3-S3*S3
	S6=2.*S3*C3
	C7=C3*C4-S3*S4
	S7=C3*S4+S3*C4
	DO 10 J=I,NTHPO,LENGT
	AR0=CR0(J)+CR4(J)
	AR1=CR1(J)+CR5(J)
	AR2=CR2(J)+CR6(J)
	AR3=CR3(J)+CR7(J)
	AR4=CR0(J)-CR4(J)
	AR5=CR1(J)-CR5(J)
	AR6=CR2(J)-CR6(J)
	AR7=CR3(J)-CR7(J)
	AI0=CI0(J)+CI4(J)
	AI1=CI1(J)+CI5(J)
	AI2=CI2(J)+CI6(J)
	AI3=CI3(J)+CI7(J)
	AI4=CI0(J)-CI4(J)
	AI5=CI1(J)-CI5(J)
	AI6=CI2(J)-CI6(J)
	AI7=CI3(J)-CI7(J)
	BR0=AR0+AR2
	BR1=AR1+AR3
	BR2=AR0-AR2
	BR3=AR1-AR3
	BR4=AR4-AI6
	BR5=AR5-AI7
	BR6=AR4+AI6
	BR7=AR5+AI7
	BI0=AI0+AI2
	BI1=AI1+AI3
	BI2=AI0-AI2
	BI3=AI1-AI3
	BI4=AI4+AR6
	BI5=AI5+AR7
	BI6=AI4-AR6
	BI7=AI5-AR7
	TTR=(BR5-BI5)*RAC2
	TTI=(BR5+BI5)*RAC2
	TR=(BR7+BI7)*(-RAC2)
	TI=(BR7-BI7)*RAC2
	CR0(J)=BR0+BR1
	CI0(J)=BI0+BI1
	IF(I.LE.1)GOTO 15
	V1=BR0-BR1
	V2=BI0-BI1
	CR1(J)=C4*V1-S4*V2
	CI1(J)=C4*V2+S4*V1
	V2=BR2-BI3
	V1=BR2+BI3
	V3=BI2+BR3
	V4=BI2-BR3
	CR2(J)=C2*V2-S2*V3
	CI2(J)=C2*V3+S2*V2
	CR3(J)=C6*V1-S6*V4
	CI3(J)=C6*V4+S6*V1
	V1=BR4+TTR
	V2=BR4-TTR
	V3=BI4+TTI
	V4=BI4-TTI
	CR4(J)=C1*V1-S1*V3
	CI4(J)=C1*V3+S1*V1
	CR5(J)=C5*V2-S5*V4
	CI5(J)=C5*V4+S5*V2
	V1=BR6+TR
	V2=BR6-TR
	V3=BI6+TI
	V4=BI6-TI
	CR6(J)=C3*V1-S3*V3
	CI6(J)=C3*V3+S3*V1
	CR7(J)=C7*V2-S7*V4
	CI7(J)=C7*V4+S7*V2
	GOTO 9
15    CI1(J)=BI0-BI1
	CR1(J)=BR0-BR1
	CR2(J)=BR2-BI3
	CR3(J)=BR2+BI3
	CI2(J)=BI2+BR3
	CI3(J)=BI2-BR3
	CR4(J)=BR4+TTR
	CR5(J)=BR4-TTR
	CI4(J)=BI4+TTI
	CI5(J)=BI4-TTI
	CR6(J)=BR6+TR
	CR7(J)=BR6-TR
	CI6(J)=BI6+TI
	CI7(J)=BI6-TI
9     CONTINUE
10    CONTINUE
20    CONTINUE
	RETURN
	END
