C*WRBINR
      SUBROUTINE WRBINR(LU,ITAB,I0,N,IBS,IBUF)
C  ECRITURE BINAIRE : ON ECRIT, SUR L'UNITE LOGIQUE LU,
C  LES N TERMES DU TABLEAU ITAB, CODES SUR IBS OCTETS,
C    A PARTIR DU TERME I0.
C  (IBS=1 POUR CARACTERES, 2 POUR INTEGER*2, 4 POUR INTEGER OU
C   REELS SIMPLE PRECISION, 8 POUR DOUBLE PRECISION, PAR EXEMPLE).
C   IBUF EST UN TABLEAU DE TRAVAIL : LE PREMIER MOT DOIT CONTENIR
C   LA TAILLE DE LA LIGNE DU FICHIER EN OCTETS, LE 2EME EST LE
C   POINTEUR DANS LA LIGNE ET DOIT OBLIGATOIREMENT ETRE INITIALISE
C   A 0 AVANT LA PREMIERE ECRITURE SUR LE FICHIER. LES MOTS SUIVANTS
C   SERVIRONT A STOCKER UNE LIGNE DU FICHIER.
C   IL FAUT ABSOLUMENT TERMINER L'ECRITURE DU FICHIER PAR UN
C   DERNIER APPEL A WRBINR APRES AVOIR CHANGE DE SIGNE IBUF(2)
C    (EVENTUELLEMENT AVEC N=AVEC N N{GATIF, POUR VIDER LE DERNIER
C   BUFFER SUR LE FICHIER.
C   DIM. DEIBUF DOIT ETRE AU MOINS (LREC+3)/4+2 SI LREC EST LE NB D'OCTETS
C  PAR LIGNE.
C
      INTEGER IBUF(3),ITAB(1),RANDWR
      DATA NPROG/164/
      IF(N.EQ.0) RETURN
      IPT=IBUF(2)
      LGL=IBUF(1)
      NN=0
      IF(N.LT.0) GOTO 50
      NN=N*IBS
      I1=(I0-1)*IBS+1
      IF(IPT.LE.0) IPT=1
      GOTO 20
10    N1=NN
      IF(N1.GT.(LGL-IPT+1)) N1=LGL-IPT+1
      CALL MVBYTE(ITAB,IBUF(3),I1,IPT,N1)
      NN=NN-N1
      IPT=IPT+N1
      I1=I1+N1
20    IF(IPT.LE.LGL) GOTO 15
21    IF(RANDWR(LU,-1,IBUF(3),LGL,NBL,IS2).NE.0) GOTO 101
      IF(NBL.NE.LGL) GOTO 111
      IPT=1
15    IF(NN.GT.0) GOTO 10
      IBUF(2)=IPT
      RETURN
50    IF(IPT.GT.1) GOTO 21
      RETURN
101   IS1=1+100*NPROG
      CALL ERMESS(IS1,IS2)
111   CALL MESERR('LONGUEUR DE LIGNE NON CONFORME $',9)
      END
