/***************************************************************************
Copyright (c) 1988,1989 
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

/*  s-p d'acces a la table des glyphs pour affichage image */
#include <stdio.h>
#include <string.h>
#include "imPcodes.h"
#include <errno.h>


unsigned char *bufmap= NULL, *i_malloc();
#ifdef XVDATAGLY
static char basemap[] = XVDATAGLY;
#else
static char basemap[] = "/usr/local/imfonts/impmap";
#endif
static char endmap[] = "0123456789ABCDEF";
static char mapname[128];

get_imgly(g_size,hdr)
register g_size;
register struct imagemap *hdr;
{
	int ngly;
	short bsize1, lgly, lgtab;
	register i, fd;
	i = strlen(basemap);
	strcpy(mapname,basemap);
	mapname[i] = endmap[g_size];
	mapname[i + 1] = '.';
	mapname[i + 2] = 'b';
	mapname[i + 3] = 0;
	if((fd = open(mapname,0)) <= 0) {
		fprintf(stderr,"map file %s : open err %d\n",mapname,errno);
		exit(1);
	} 

	if(read(fd,hdr,sizeof (struct imagemap)) != sizeof (struct imagemap)) errio();
	if(g_size != hdr->g_size) {
		fprintf(stderr,"taille incorrecte sur fichier %s\n",mapname);
		exit(1);
	}
	ngly = hdr->nb_gly;
	bsize1 = (g_size + 7) >> 3;
	lgly = bsize1 * g_size;
	lgtab = lgly * ngly;
	i_Free(&bufmap);
	bufmap = i_malloc(lgtab);
	if(read(fd,bufmap,lgtab) != lgtab) errio();
	close(fd);
}
