/* cut and paste sur images */

#include <inrimage/image.h>
#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

Widget ex_cutp_widget;
extern Pixmap pix_im, pix_undo;
extern struct button *pbt_undo;
extern struct imagept shpts[];
extern int truecol_type;
extern int scrdepth, byte_pixel;
extern unsigned char xtrans[];

extern int debug_;

extern struct button *l_bcutp[];


extern Display *dpy;
extern Visual *mydefvisual;
extern Colormap defcmap;
extern GC defgc, fillgc;
extern Window W_image;
extern Widget fill_dial_widget;

extern int flg_nu, flg_txt_fond;

int undo_valid= 1;

int xvgx_menu();
struct menu_item GX_menulist[]= {
	{"src",GXcopy},
	{"~src",GXcopyInverted},
	{"src & dst",GXand},
	{"src & ~dst",GXandReverse},
	{"~src & dst",GXandInverted},
	{"~src & ~dst",GXnor},
	{"src | dst",GXor},
	{"src | ~dst",GXorReverse},
	{"~src | dst",GXorInverted},
	{"~src | ~dst",GXnand},
	{"src ^ dst",GXxor},
	{"~src ^ dst",GXequiv},
};

struct xvmenu GX_menu= {
	"GX","","OP= ",xvgx_menu,sizeof(GX_menulist)/sizeof(struct menu_item),GX_menulist,NULL};

int xvundo_menu();
struct menu_item undo_menulist[]= {
	{"undo ON",1},
	{"undo OFF",0},
};
struct xvmenu undo_menu= {
	"umode","","",xvundo_menu,sizeof(undo_menulist)/sizeof(struct menu_item),undo_menulist,NULL};
#if 0
static char mname[]= "GX";
static char umname[]= "umode";
static struct GX_list {
	char *fname;
	int val;
} GX_list[]= {
	{"src",GXcopy},
	{"~src",GXcopyInverted},
	{"src & dst",GXand},
	{"src & ~dst",GXandReverse},
	{"~src & dst",GXandInverted},
	{"~src & ~dst",GXnor},
	{"src | dst",GXor},
	{"src | ~dst",GXorReverse},
	{"~src | dst",GXorInverted},
	{"~src | ~dst",GXnand},
	{"src ^ dst",GXxor},
	{"~src ^ dst",GXequiv},
};
#define NB_GX (sizeof(GX_list) / sizeof(struct GX_list))
#endif
static int mygc_func= GXcopy;

static Arg args[3];

int xvgx_menu(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register i;
	register struct menu_item *pi;
	pi = (struct menu_item *)&GX_menulist[(long)cl_data];
	mygc_func = pi->val;
	set_menu_btn(l_bcutp[7],cl_data,0);
}

int xvundo_menu(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register struct menu_item *pi;
	pi = (struct menu_item *)&undo_menulist[(long)cl_data];
	undo_valid = pi->val;
	set_menu_btn(l_bcutp[8],cl_data,0);
	if(undo_valid) 
		XtSetArg(args[0], XtNsensitive,True);
	else
		XtSetArg(args[0], XtNsensitive,False);
	XtSetValues(pbt_undo->b_win,args,1);
}



#define XVIS_CUTBUFFER 7
static struct imbox ibox, iboxu= {0};

static short inctb[7]= { 1,10,-1,-10,0,255,0};
xvtxt_fill(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;		
{
	register i, incr;
	char *s;
	int val;
	char tmp[16];
	if(*num_params != 1)
		imerror(9,"bad arg nb in xvtxt_fill\n");
	i = **params;
	if(i < '0' || i > '6')
		imerror(9,"bad arg in xvtxt_fill\n");
	i -= '0';
	if(i == 6) {
		bd_fill();
		return 1 /* makes c99 happy */; 
	}
	incr = inctb[i];
	if(i < 4) {
		s = (char *)XawDialogGetValueString(fill_dial_widget);
		sscanf(s,"%d",&val);
		val += incr;
	} else {
		val = incr;
	}
	sprintf(tmp,"%03d",val);
	XtSetArg(args[0],XtNvalue,(XtArgVal)tmp);
	XtSetValues(fill_dial_widget,args,1);
}

bd_fill()
{
	do_fill(get_fillval());
}

get_fillval()
{
	char *s;
	if(fill_dial_widget) {
		s = (char *)XawDialogGetValueString(fill_dial_widget);
		sscanf(s,"%d",&fill_value);
	}
	return fill_value;
}

do_fill(val)
register val;
{
	XGCValues gcv;
	register msk;
	char tmp[16];
	val &= 0xff;
	shdef_args();
	calc_imbox(shpts,&ibox);
	/* hide box */
	xvsh_boxdraw(shpts,1);
	save_undo(ibox.dx,ibox.dy,ibox.dz,ibox.dv);
	msk = xtrans[(val & 0xff)];
	if(scrdepth == 24)
		msk |= (msk << 8) | (msk << 16);
	gcv.function = GXset;
	init_gc(&fillgc,&gcv);
	do_fill1(&gcv,msk);
	xvsh_boxdraw(shpts,0);  /* redraw box */
	if(flg_nu) return 1 /* makes c99 happy */; 
	sprintf(tmp,"%03d",val);
	XtSetArg(args[0],XtNvalue,(XtArgVal)tmp);
	XtSetValues(fill_dial_widget,args,1);
}

do_fill1(pgcv,mask)
register mask;
XGCValues *pgcv;
{
  int i, j, ix, iy;
  pgcv->foreground = mask;
  pgcv->function = GXcopy;
  pgcv->fill_style = FillSolid;
  XChangeGC(dpy,fillgc,GCFunction | GCForeground | GCFillStyle ,pgcv);
  iy = ibox.y;
  ix = ibox.x;
  for(i=0;i<ibox.dz;i++) {
    for(j=0;j<ibox.dv;j++) {
      if(pix_im)
	XFillRectangle(dpy,pix_im,fillgc,ix,iy,ibox.dx,ibox.dy);
      XFillRectangle(dpy,W_image,fillgc,ix,iy,ibox.dx,ibox.dy);
      ix += im_w1v;
    }
    if(flg_z_horiz) {
      ix -= im_w1v;
      INCR_HZ(ix,iy);
    } else {
      ix = ibox.x;
      iy += im_h1;
    }
  }
}

bd_clear()
{
	do_gxf(GXclear);
}
bd_set()
{
	do_gxf(GXset);
}
bd_inv()
{
	do_gxf(GXinvert);
}
do_gxf(func)
register func;
{
	XGCValues gcv;
	register msk;
	shdef_args();
	calc_imbox(shpts,&ibox);
	/* hide box */
	xvsh_boxdraw(shpts,1);
	save_undo(ibox.dx,ibox.dy,ibox.dz,ibox.dv);
	gcv.function = func;
	init_gc(&fillgc,&gcv);
	if(func == GXinvert || scrdepth == 1) {
		do_gxf1(func,&gcv,AllPlanes);
	} else {
		msk = func == GXclear ? whitepixel : blackpixel;
		if(scrdepth == 24)
			msk |= (msk << 8) | (msk << 16);
		if(msk == 0)
			do_gxf1(GXclear,&gcv,AllPlanes);
		else
			do_fill1(&gcv,msk);
			
	}
	xvsh_boxdraw(shpts,0);  /* redraw box */
}

do_gxf1(func,pgcv,mask)
register func, mask;
XGCValues *pgcv;
{
  int i, j, iy, ix;
  pgcv->plane_mask = mask;
  pgcv->function = func;
  XChangeGC(dpy,fillgc,GCFunction | GCPlaneMask,pgcv);
  iy = ibox.y;
  ix = ibox.x;
  for(i=0;i<ibox.dz;i++) {
    for(j=0;j<ibox.dv;j++) {
      if(pix_im)
	XCopyArea(dpy,pix_im,pix_im,fillgc,ix,iy,ibox.dx,ibox.dy,ix,iy);
      XCopyArea(dpy,W_image,W_image,fillgc,ix,iy,ibox.dx,ibox.dy,ix,iy);
      ix += im_w1v;
    }
    if(flg_z_horiz) {
      ix -= im_w1v;
      INCR_HZ(ix,iy);
    } else {
      ix = ibox.x;
      iy += im_h1;
    }
  }
}


bd_copy()
{
	char buff[256];
	register d;
#if 0
	if(flg_nopix) {
		xvbell();
		return;
	}
#endif
	shdef_args();
	calc_imbox(shpts,&ibox);
	d = pix_im ? (int) pix_im : (int)W_image;
#if 0
	if(flg_z_horiz) {
		w1 = im_w1;
		h1 = 0;
	} else {
		w1 = 0;
		h1 = im_h1;
	}
#endif
	/* A FAIRE : avec dv !!! */
	sprintf(buff,"#xvis-hz2 %x [%d,%d,%d,%d] (%d,%d) (%d,%d,%d,%d)",d,
		im_w,im_w1,im_w1v,im_h1,ibox.x,ibox.y,ibox.dx,ibox.dy,ibox.dz,ibox.dv);
	XStoreBuffer(dpy,buff,strlen(buff),XVIS_CUTBUFFER);
	if(debug_)
		fprintf(stderr,"copy: %s\n",buff);
}
bd_paste()
{
	int dx1, dy1, dz1, dv1, ix1, iy1;
	shdef_args();
	calc_imbox(shpts,&ibox);
	dx1 = ibox.dx;
	dy1 = ibox.dy;
	dz1 = ibox.dz;
	dv1 = ibox.dv;
	ix1 = ibox.x;
	iy1 = ibox.y;
	xvsh_boxdraw(shpts,1);	/* hide box */
	do_paste(ix1,iy1,dx1,dy1,dz1,dv1);
	xvsh_boxdraw(shpts,0);  /* redraw box */
}

do_paste(ix10,iy1,dx1,dy1,dz1,dv1)
int dx1, dy1, dz1, dv1, ix10, iy1;
{
  int ix, ix0, ix1, iy, dx, dy, dz, dv, imh1, imw1, imw1v, imw;
  Pixmap pix;
  int nbytes;
  int n, i, j;
  register char *pc;
  XGCValues gcv;
  gcv.function = mygc_func;
  init_gc(&fillgc,&gcv);
  pc = (char *)XFetchBuffer(dpy,&nbytes,XVIS_CUTBUFFER);
  if(nbytes > 256) {
    xvbell();
    return 1 /* makes c99 happy */; 
  }
  n = sscanf(pc,"#xvis-hz2 %x [%d,%d,%d,%d] (%d,%d) (%d,%d,%d,%d)",&pix,
	     &imw,&imw1,&imw1v,&imh1,&ix0,&iy,&dx,&dy,&dz,&dv);
  XFree(pc);
  if(n != 11) {
    xvbell();
    return 1 /* makes c99 happy */; 
  }
  if(debug_)
    fprintf(stderr,"paste: %s\n",pc);
  if(dy > dy1)
    dy = dy1;
  if(dx > dx1)
    dx = dx1;
  if(dz > dz1)
    dz = dz1;
  if(dv > dv1)
    dv = dv1;
  ix = ix0;
  ix1 = ix10;
  XChangeGC(dpy,fillgc,GCFunction,&gcv);
  save_undo(dx,dy,dz,dv);
  for(i=0;i<dz;i++) {
    for(j=0;j<dv;j++) {
      if(pix_im)
	XCopyArea(dpy,pix,pix_im,fillgc,ix,iy,dx,dy,ix1,iy1);
      XCopyArea(dpy,pix,W_image,fillgc,ix,iy,dx,dy,ix1,iy1);
      ix += imw1v;
      ix1 += im_w1v;
    }
    if(imw1 == imw) {
      ix = ix0;
      iy += imh1;
    } else {
      ix += (imw1 -imw1v);
      if(ix >= imw) {
	ix = ix % imw1;
	iy += imh1;
      }
    }
    if(flg_z_horiz) {
      ix1 -= im_w1v;
      INCR_HZ(ix1,iy1);
    } else {
      ix1 = ix10;
      iy1 += im_h1;
    }
  }
}

int DB_buf= 0;
/* paste text from  buffer 0 */
bd_ptext()
{
	int nbytes;
	register char *pc;
	register val;
	pc = (char *)XFetchBuffer(dpy,&nbytes,DB_buf);
	val = get_fillval();
	do_ptext(val,-1,pc,nbytes);
	XFree(pc);
}

 /* supp les \ et retourne la nouvelle longueur*/
verif_text(pc)
register char *pc;
{
	register i, c, flg;
	register char *p2;
	i = 0;
	flg = 0;
	p2 = pc;
	while(c = *pc++) {
		if(flg) {
			flg = 0;
		} else if(c == '\\') {
			flg = 1;
			continue;
		}
		*p2++ = c;
		i++;
	}
	*p2 = 0;
	return i;
}

/*
paste text
 backgr = background value, pas de fond si -2, ignore si < 0, */
do_ptext(fillval,backgr,pc,nbytes)
register char *pc;
register fillval, backgr, nbytes;
{
  int n, i, j, ix1, iy1;
  int dir,asc, desc;
  int opt;
  XCharStruct overall;
  XGCValues gcv;
  GContext context;
  int dx1, dy1, dz1, dv1, size;
  if(debug_)
    fprintf(stderr,"paste text: %s\n",pc);
  shdef_args();
  calc_imbox(shpts,&ibox);
  dx1 = ibox.dx;
  dy1 = ibox.dy;
  dz1 = ibox.dz;
  dv1 = ibox.dv;
  ix1 = ibox.x;
  iy1 = ibox.y;
  xvsh_boxdraw(shpts,1);	/* hide box */
  gcv.function = mygc_func;
  init_gc(&fillgc,&gcv);
  n = xtrans[(fillval & 0xff)];
  if(scrdepth == 24)
    n |= (n << 8) | (n << 16);
  gcv.foreground = n;
  opt = GCFunction | GCForeground;
  if(backgr >= 0) {
    n = xtrans[(backgr & 0xff)];
    if(scrdepth == 24)
      n |= (n << 8) | (n << 16);
    gcv.background = n;
    opt |= GCBackground;
  }
  if(txtfont != (Font) 0) {
    gcv.font = txtfont;
    opt |= GCFont;
  }
  XChangeGC(dpy,fillgc,opt,&gcv);
  context = XGContextFromGC(fillgc);
  XQueryTextExtents(dpy,context,pc,nbytes,&dir,&asc,&desc,&overall);
  if((asc + desc) > dy1) {
    xvbell();
    XFree(pc);
    xvsh_boxdraw(shpts,0);  /* redraw box */
    return 1 /* makes c99 happy */; 
  }
  iy1 += asc;
  size = overall.width;
  if(size > dx1) {
    nbytes = (dx1 * nbytes) / size;
  }
  save_undo(dx1,dy1,dz1,dv1);
  for(i=0;i<dz1;i++) {
    for(j=0;j<dv1;j++) {
      if(flg_txt_fond && (backgr != -2)) {
	if(pix_im)
	  XDrawImageString(dpy,pix_im,fillgc,ix1,iy1,pc,nbytes);
	XDrawImageString(dpy,W_image,fillgc,ix1,iy1,pc,nbytes);
      } else {
	if(pix_im)
	  XDrawString(dpy,pix_im,fillgc,ix1,iy1,pc,nbytes);
	XDrawString(dpy,W_image,fillgc,ix1,iy1,pc,nbytes);
      }
      ix1 += im_w1v;
    }
    if(flg_z_horiz) {
      ix1 -= im_w1v;
      INCR_HZ(ix1,iy1);
    } else {
      ix1 = ibox.x;
      iy1 += im_h1;
    }
  }
  xvsh_boxdraw(shpts,0);  /* redraw box */
}

/*
put text at given position
 backgr = background value, pas de fond si -2, ignore si < 0, */
do_puttext(fillval,backgr,pc,nbytes,ix1,iy1)
register char *pc;
register fillval, backgr, nbytes;
register ix1, iy1;
{
	register n, i;
	int dir,asc, desc, opt;
	XCharStruct overall;
	XGCValues gcv;
	GContext context;
	if(debug_)
		fprintf(stderr,"put text: %s\n",pc);
	shdef_args();
	gcv.function = mygc_func;
	init_gc(&fillgc,&gcv);
	n = xtrans[(fillval & 0xff)];
	if(scrdepth == 24)
		n |= (n << 8) | (n << 16);
	gcv.foreground = n;
	opt = GCFunction | GCForeground;
	if(backgr >= 0) {
		n = xtrans[(backgr & 0xff)];
		if(scrdepth == 24)
			n |= (n << 8) | (n << 16);
		gcv.background = n;
		opt |= GCBackground;
	}
	if(txtfont != (Font) 0) {
		gcv.font = txtfont;
		opt |= GCFont;
	}
	XChangeGC(dpy,fillgc,opt,&gcv);
	context = XGContextFromGC(fillgc);
	XQueryTextExtents(dpy,context,pc,nbytes,&dir,&asc,&desc,&overall);
	iy1 += asc;
	if(flg_txt_fond && (backgr != -2)) {
		if(pix_im)
			XDrawImageString(dpy,pix_im,fillgc,ix1,iy1,pc,nbytes);
		XDrawImageString(dpy,W_image,fillgc,ix1,iy1,pc,nbytes);
	} else {
		if(pix_im)
			XDrawString(dpy,pix_im,fillgc,ix1,iy1,pc,nbytes);
		XDrawString(dpy,W_image,fillgc,ix1,iy1,pc,nbytes);
	}
}

save_undo(dx,dy,dz,dv)
int dx,dy,dz,dv;
{
  int ix1, iy1;
  int i, j, x0, y0;
  if(!undo_valid) {
    if(pix_undo) {
      XFreePixmap(dpy,pix_undo);
      pix_undo = 0;
    }
    return 1 /* makes c99 happy */; 
  }
  if(pix_undo) {
    if((ibox.dx * ibox.dv) != (iboxu.dx * iboxu.dv) || ((ibox.dy * ibox.dz) != (iboxu.dy * iboxu.dz))) {
      XFreePixmap(dpy,pix_undo);
      pix_undo = 0;
    }
  }
  if(!pix_undo)
    pix_undo = XCreatePixmap(dpy,W_image,dx*dv,dy*dz,scrdepth);
  ix1 = ibox.x;
  iy1 = ibox.y;
  /* save old region */
  iboxu.x = ix1;
  iboxu.y = iy1;
  iboxu.dx = dx;
  iboxu.dy = dy;
  iboxu.dz = dz;
  iboxu.dv = dv;
  y0 = 0;
  for(i=0;i<dz;i++) {
    x0 = 0;
    for(j=0;j<dv;j++) {
      if(pix_im)
	XCopyArea(dpy,pix_im,pix_undo,defgc,ix1,iy1,dx,dy,x0,y0);
      else
	XCopyArea(dpy,W_image,pix_undo,defgc,ix1,iy1,dx,dy,x0,y0);
      x0 += dx;
      ix1 += im_w1v;
    }
    y0 += dy;
    if(flg_z_horiz) {
      ix1 -= im_w1v;
      INCR_HZ(ix1,iy1);
    } else {
      ix1 = ibox.x;
      iy1 += im_h1;
    }
  }
}

bd_undo()
{
  int ix, iy, dx, dy, dz, dv;
  int i, j, x0, y0;
  if(!pix_undo || !undo_valid) return 1 /* makes c99 happy */; 
  dx = iboxu.dx;
  dy = iboxu.dy;
  dz = iboxu.dz;
  dv = iboxu.dv;
  ix = iboxu.x;
  iy = iboxu.y;
  y0 = 0;
  xvsh_boxdraw(shpts,1);	/* hide box */
  for(i=0;i<dz;i++) {
    x0 = 0;
    for(j=0;j<dv;j++) {
      if(pix_im)
	XCopyArea(dpy,pix_undo,pix_im,defgc,x0,y0,dx,dy,ix,iy);
      XCopyArea(dpy,pix_undo,W_image,defgc,x0,y0,dx,dy,ix,iy);
      x0 += dx;
      ix += im_w1v;
    }
    y0 += dy;
    if(flg_z_horiz) {
      ix -= im_w1v;
      INCR_HZ(ix,iy);
    } else {
      ix = iboxu.x;
      iy += im_h1;
    }
  }
  xvsh_boxdraw(shpts,0);  /* redraw box */
}

create_menu(ptb,w)
register struct button *ptb;
Widget w;
{
	register struct menu_item *pi;
	register struct xvmenu *pmenu;
	register Widget *pw;
	Widget mymenu;
	Widget entry;
	XtTranslations buttontrans;
	register long i;
	pmenu = (struct xvmenu *)ptb->b_menu;
	XtSetArg(args[0],XtNmenuName,pmenu->m_name);
	XtSetValues(w,args,1);
	XtSetArg(args[0],XtNlabel,pmenu->m_title);
	XtSetArg(args[1], XtNvisual, mydefvisual);
	XtSetArg(args[2], XtNcolormap, defcmap);

	mymenu = XtCreatePopupShell(pmenu->m_name, simpleMenuWidgetClass, w,args, 3);
	pi = pmenu->items;
	pw = (Widget *)pmenu->wlist;
	for(i=0;i<pmenu->nb_items;i++) {
		if(pi->label == NULL) {
			entry = XtCreateManagedWidget(pi->label,smeLineObjectClass,mymenu,args, 0);
			
		} else {
			XtSetArg(args[0],XtNlabel,pi->label);
			entry = XtCreateManagedWidget(pi->label,smeBSBObjectClass,mymenu,args, 1);
			XtAddCallback(entry, XtNcallback,pmenu->menu_evnt, (XtPointer)i);
		}
		if(pw != NULL) {
			*pw++ = entry;
		}
		pi++;
	}
/*!!	XtRealizeWidget(mymenu); */
	XtSetArg(args[0],XtNtranslations,&buttontrans);
	XtGetValues(w,args,1);
	ptb->b_im_norm = (long *)buttontrans;
}
