/* structures pour la table de variables */
struct argtab {
	char *name;
	char *value;
	short type;
	short nbval; /* nb de strings si type T_PSTRG */
};

struct pargtab {
	int nbvar;
	struct argtab **vlist;  /* liste de pointeurs ranges par ordre alpha */
	struct argtab *stdlist; /* liste  originale */
};

/* types */
#define T_STRG 0
#define T_INT 1
#define T_PSTRG 2
#define T_FLOAT 3
#define T_HEXA 4
#define T_FORTINT 5

#define MAXBUFEXE 32
struct exec_buf {
	char *next_input;  /* ptr vers input suivant ou null */
	int status;     /* type  of commend */
	int ix0;  /* indice dans bufexe du debut de cette commende */
	int lgr;  /* lgr de la commande, y compris le null */
};
struct exp_buf {  /* for expanded buffer */
  char *bufexe;
  char *args;  /* args string for script */
  int maxsize;
  struct exec_buf *pexec;
};
#define S_NORMAL 0
#define S_INPIPE 1
#define S_OUTPIPE 2
#define S_BUILTIN 4

struct xvcmdtab {
	char *name;
	int (*func)();
	int value;
	char *syntax;  /* help msg */
};

struct pcmdtab {
	int nbcmd;
	struct xvcmdtab **clist;
};
